.de Cs
.\" The following pair of macros are used to bracket sections of code
.in +0.5i
.br
.ft 5
.nf
..
.de Ce
.br
.fi
.ft 1
.in -0.5i
..
.de Ty          \" Type-ins and examples (typewriter)
.ft 5
.if \\n(.$>0 \&\\$1\fP\\$2
..
.de Al
.IP "\&\f5\s-1\\$1\s+1\fP"
..
.de At
.ft 3
.if \\n(.$>0 \&\\$1\fP\\$2
..
.\" following macro cuts the date provided by RCS so only yy/mm/dd shows
.de Cd
\&\\$2
..
.de Rv
.ds rV Revision: \\$2
..
.de Tc
\&\\$1 \\$2 \\$3 \\$4 \\$5
.if \\nI=2 \{\
.       tm .XA \\n(PN
.       tm \\*(SN \\$1 \\$2 \\$3 \\$4 \\$5
.\}
..

.\" the Fi numerical register is used to number figures
.nr Fi 0 1
.Rv $Revision: 2.0.2.2 $
.sp 3
.in +0.7i
.sp 0.22i
.vs 11
.ps +22
P
.br
\h'11p'B\ \ 
.ps -4
\v'-4p'Portable Batch System\v'4p'
.br
.ps +4
\h'21p'S
.br
.ps -22
.vs 12
\l'4.9i'
.br
.in -0.8i
.sp 3
.TL
Administrator Guide
.AU
Albeaus Bayucan \(dg
.FS \(dg
MRJ Technology Solutions., NASA Contract NAS 2-14303, Moffett Field, CA
.FE
Robert L. Henderson \(dg
Lonhyn T. Jasinskyj \(dg
Casimir Lesiak \(dg
Bhroam Mann \(dg
Tom Proett \(dg
Dave Tweten
.AI
Numerical Aerospace Simulation Systems Division
NASA Ames Research Center
.sp
.so ../ers/release.ms
.br
Printed: \*(DY
.LP
.OH 'PBS Administrator Guide''TOC'
.EH 'TOC''PBS Administrator Guide'
.bp
.EF '-ii-'''
.OF '''-iii-'
.DS C
Portable Batch System, Rights to Use and Redistribute
.DE
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
.LP
This product includes software developed by the NetBSD
Foundation, Inc. and its contributors.
.LP
.DS C
PBS Revision History
.DE
.so ../ers/rel_history.ms
\"
\" The TOC follows
.bp
.OF '''TOC'
.EF 'TOC'''
.XS ii
Revision History
.so toc.input
.XE
.LG
Table of Contents
.NL
.sp
.PX no
.OH 'PBS Administrator Guide''Installation'
.EH 'Installation''PBS Administrator Guide'
.nr % 1
.pn 1
.bp
.nr % 1
.P1
.OF 'Chapt \*(rV''%'
.EF '%''Chapt \*(rV'
.NH 1
.Tc \f3\s+2Introduction\s-2\fP
.LP
This document is intended to provide the system administrator with the
information required to build, install, configure, and manage the Portable
Batch System.  It is very likely that some important tidbit of information
has been left out.  No document of this sort can ever be complete, and until
it has been updated by several different administrators at different sites,
it is sure to be lacking.
.LP
You are strongly encouraged to read the PBS External Reference Specification,
ERS, included with the release.  Look for pbs_ers.ps in the src/doc directory.
.NH 2
What is PBS
.LP
The Portable Batch System, PBS, is a batch job and computer system resource
management package.  It was developed with the intent to be conformant with
the POSIX 1003.2d Batch Environment Standard.  As such, it will accept batch
jobs, a shell script and control attributes, preserve and protect the job
until it is run, run the job, and deliver output back to the submitter.
.LP
PBS may be installed and configured to support jobs run on a single system,
or many systems grouped together.   Because of the flexibility of PBS,
the systems may be grouped in many fashions.
.NH 2
Components of PBS
.LP
PBS consist of four major components: commands, the job server, the job
executor, and the job scheduler.  A brief description of each is given
here to help you make decisions during the installation process.
.IP Commands
PBS supplies both command line commands that are POSIX 1003.2d conforming and
a graphical interface.   These are used to submit, monitor, modify, and
delete jobs.  The commands can be installed on any system type supported by
PBS and do not require the local presence of any of the other components of PBS.
There are three classifications of commands: user commands which any authorized
user can use, operator commands, and manager (or administrator) commands.
Operator and manager commands require different access privileges.
.IP "Job Server"
The Job Server is the central focus for PBS.  Within this document, it is
generally referred to as 
.I "the Server"
or by the execution name
.I pbs_server .
All commands and the other daemons communicate with the Server via an IP
network.
The Server's main function is to provide the basic batch services such as
receiving/creating a batch job, modifying the job, protecting the job against
system crashes, and running the job (placing it into execution).
.IP "Job Executor"
The job executor is the daemon which actually places the job into execution.
This daemon is called 
.I Mom
as it is the mother of all executing jobs, and
.I pbs_mom .
Mom places a job into execution when it receives a copy of the job from a 
Server.   Mom creates a new session as identical to a user login session
as is possible.  For example, if the user's login shell is csh, then
Mom creates a session in which .login is run as well as .cshrc.  
Mom also has the responsibility for returning the job's output to the user
when directed to do so by the Server.
.IP "Job Scheduler"
The Job Scheduler is another daemon which contains the site's policy controlling
which job is run and where and when it is run.  Because each site has its own
ideas about what is a good or effective policy, PBS allows each site to 
create its own scheduler.  When run, the scheduler can communicate with the
various Moms
to learn about the state of system resources and with the Server to learn
about the availability of jobs to execute.   The interface to the Server
is through the same API as the commands.   In fact, the Scheduler just
appears as a batch Manager to the Server.  
.LP

.Tc \f3\s+2Installation\s-2\fP
.LP
This section attempts to explain the steps to build and install PBS.
PBS installation is accomplished via the GNU autoconf process.
This installation procedure requires more manual configuration than is
\*Qtypical\*U for many packages.  There are a number of options which
involve site policy and therefore cannot be determined automagically.
.NH 2
.Tc \f3Release Contents\fP
.LP
.NH 3
Tar File
.LP
PBS is provided as a single tar file.  The tar file contains:
.IP -
This document in both postscript and text form.
.IP -
All source code, header files, and make files required to build
and install PBS.
.IP -
A full set of documentation sources.  These are troff input files.
.LP
.NH 3
Additional Requirements
.LP
PBS uses a configure script generated by GNU autoconf to produce makefiles.
If you have a POSIX make program then the makefiles generated by configure
will try to take advantage of POSIX make features.  If your make is unable to
process the makefiles while building you may have a broken make.
Should make fail during the build, try using GNU make.
.LP
If the Tcl based GUI (xpbs and xpbsmon) or the Tcl based scheduler is used,
the Tcl header and library are required.  If the BaSL scheduler is used,
yacc and lex (or GNU bison and flex) are required.
The offical site for Tcl is:
.in +0.5i
.br
http://www.scriptics.com/
.br
ftp://ftp.scriptics.com/pub/tcl/tcl8_0
.LP
Versions of Tcl previous to 8.0 can no longer be used with PBS.  Tcl
and Tk version 8.0 or greater must be used.
.in -0.5i
.LP
A possible site for yacc and lex is:
.in +0.5i
.br
prep.ai.mit.edu:/pub/gnu
.in -0.5i
.NH 2
.Tc \f3Build Overview\fP
.LP
The normal PBS build procedure is to separate the source from the target.
This allows the placement of a single copy of the source on a shared file
system from which multiple different target systems can be built.  Also, the
source can be protected from accidental destruction or modification by making
the source read-only.  However, if you choose, objects may be made within
the source tree.
.LP
In the following descriptions, the 
.I "source tree"
is the result of un-tar-ing the tar file into a directory (and subdirectories).
A diagram of the source tree is show in figure \n(H1\-\n+(Fi.
.KF
.so sourcetree.pic
.sp
.ce
\f3Figure \n(H1\-\n(Fi: Source Tree Structure\f1
.sp
.KE
.KS
The 
.I "target tree"
is a set of parallel directories in which the object modules are actually
compiled.  This tree may be separate from the source tree.
.KE
.LP
An overview of the installation steps is listed here.
Detailed explanation of symbols will follow.
It is recommended that you read completely 
through these instructions before beginning the installation.  To install PBS:
.IP 1.
Place the tar file on the system where you would like to maintain the source.
.IP 2.
Untar the tar file.  It will untar in the current directory
producing several files and subdirectories.  This is the 
.I "source tree" .   
You may write protect the source tree at this point should you so choose.
.IP
In the top directory are two files, named "How_to_Install" and "INSTALL".
The "How_to_Install" file is actually a set of release notes containing
information about the release contents and pointing to this guide for
installation instructions.  The "INSTALL" file consists of standard notes about
the use of GNU's configure.
.IP 3.
If you choose to have separate build and src trees create the top level
directory of what will become the 
.I "target tree" 
at this time.
This need not be within the source tree.  It must reside on a system
of the same architecture as the target system for which you are generating
the PBS binaries.
This may well be the same system as holds the source or it may not.
Change directories to the top of the target tree.
.IP 4.
Make a job scheduler choice.
A unique feature of PBS is its external scheduler module.   This allows a
site to implement any policy of its choice.   To provide even more freedom
in implementing policy, PBS provides three scheduler frameworks.   Schedulers
may be developed in the C language, the Tcl scripting language, or PBS's
very own C language extensions, the \f3Ba\fPtch \f3S\fPcheduling
\f3L\fPanguage, or BaSL.
.IP
As distributed, 
.I configure
will default to a C language based scheduler known as 
.I fifo .
This scheduler can be configured to several common simple scheduling policies,
not just first in \- first out as the name suggests..
When this scheduler
is installed, certain configuration files are installed in
PBS_HOME/scheduler_priv/.
\f3You will need to modify these files for your site.\fP
These files are discussed in chapter 4.5 \*QC based Sample Scheduler\*U,
in the section \*QFIFO Scheduler\*U.  
.IP
To change the selected scheduler, see the configure options
.At --set-sched
and
.At --set-sched-code
in the Features and Package Options section of this chapter.
Additional information on the types of scheduler and how to configure fifo
can be found in the Scheduling Policies chapter later in this guide.
.IP 5.
From within the top of the target tree, type the following command
.Cs
{source_tree}/configure [options]
.Ce
Where 
.Ty {source_tree}
is the full relative or absolute path to the configure script
in the source tree. If you are building in the source tree type
.Ty ./configure
at the top level of the source tree where the configure script is found.
.IP
This will generate the complete target tree and a set of header files and
makefiles used to build PBS.
.I Note,
unlike in prior versions of PBS, the top two subdirectories will be
.Ty doc
and 
.Ty src
rather than
.Ty doc
and
.Ty obj ;
this is a result of the one-for-one copy of the tree made by configure.
This step will only need to be redone if you choose to change options specified
on the configure command line.
See section
.B "2.3 Build Details"
for information on the configure options. 
\f3There are certain options which you must specify\fP.
.IP
Because the number of options may be large and each option is very wordy
you may wish to create a shell script consisting of the configure command
and the selected options.
.IP 6.
The next step is to compile PBS by typing
.Cs
make
.Ce
from the top of the target tree.
.IP 7.
The documentation is not generated by default.
You may make it by specifying the
.Ty "--enable-docs"
option to configure or by changing into the
.I doc
subdirectory in the target tree and typing make.
.IP
In order to build and print PostScript copies of the documentation from the
included source, you will need the GNU groff formating package including the
\*Qms\*U formatting macro package.
You may choose to print using
different font sets.   In the source tree is a file \*Qdoc/doc_fonts\*U
which may require editing.  Please read the comments in that file.  Note that
font position 4 is left with the symbol font mounted.
.IP 8.
To install PBS you must be running with root privileges.  As root, type 
.Cs
make install
.Ce
This generates the working directory structures required for running PBS
and installs the programs in the proper executable directories.
You must be root to perform this step. 
.IP
When the directories are made, they are also checked to ensure that they have
been setup with the correct ownership and permissions.  This is performed to
insure that files are not tampered with and the security of PBS compromised.
Part of the check is to insure that all parent directories and all files are:
.RS
.IP - 3
owned by root (bin, sys, or any uid < 10), 
.B EPERM 
returned if not;
.IP -
that group ownership is by a gid < 10, 
.B EPERM 
returned if not;
.IP -
that the directories are not world writable, or where required to be
world writable that the sticky bit is set,
.B EACCESS
returned if not; and
.IP -
that the file or directory is indeed a file or directory,
.B ENOTDIR
returned if not.
.RE
.IP
The various PBS daemons will also
perform similar checks when they are started.
.IP 9.
The three daemons, pbs_server, pbs_sched and pbs_mom
must be run by root in order to function.  Typically they should be
started at system boot time.
To have a fully functional system, each of the daemons will require certain
configuration information.   This is explained in detail in this guide in
.B "chapter 2. Batch System Configuration" .
.IP
Note that not all three daemons must be or even should be present on all
systems.
In the case of a large system, all three may be present.   In the case of a
cluster of workstations, you may have the server (pbs_server) and the
scheduler (pbs_sched) on one system only and a copy of Mom (pbs_mom) on each
node where jobs may be executed.  At this point, it is assumed that you plan
to have all three daemons running on one system.
.RS
.IP A.
\f3One time only\fP, start pbs_server with
the "-t create" option.  See the ERS for command details.  This option
causes the server to initialize various files.  This option will not be
required after the first time unless you wish to clear the server database
and start over.  See the pbs_server(8) man page for more information.
A copy of the section 8 man pages can be found in the External Reference Spec,
ERS.  For man pages on pbs_server and pbs_mom, see ERS chapter 6.
For man pages on the scheduler, see ERS chapter 7.
.IP B.
Start the execution server, pbs_mom.  No options or arguments are required.
Mom will look for a configuration file in PBS_HOME/mom_priv/config.  If it is
not found, Mom will continue to function, but certain requests may be made of
Mom from the local system only.  See the pbs_mom(8) man page
for more information on the config file.
.IP C.
Start the selected job scheduler, pbs_sched.
.RS
.IP a.
For C language based schedulers, such as the default, see the man page
pbs_sched_cc(8) for more detail.  
.IP b.
For the BaSL scheduler, the scheduling policy is written in a
specialized batch scheduling language that is similar to C. The scheduling
code, containing BaSL constructs, must first be converted into C using the
.B basl2c
utility.  This is done by setting the configure option 
.At --set-sched-code=file
where 
.I file
is the relative (to src/scheduler.basl/samples) or absolute path of a basl
source file.  The file name should end in 
.Ty .basl .
A good sample program is "fifo_byqueue.basl" that can schedule jobs on a
single-server, single-execution host environment, or a single-server,
multiple-node hosts environment. Read the header of this sample scheduler
for more information about the algorithm used.
.IP
The scheduler configuration file is an important entity in BaSL because it is
where the list of servers and host resources reside.
Execute the basl based scheduler by typing:
.Cs
pbs_sched -c config_file
.Ce
The scheduler searches for the config file in
PBS_SERVER_HOME\f2/sched_priv\fP by default.
More information can be found in the man page pbs_sched_basl(8).
.IP c.
The Tcl scheduler
requires the Tcl code policy module.
Samples of Tcl scripts may be found in
.I src/scheduler.tcl/sample_scripts
.IP
For the Tcl based scheduler, the Tcl body script should be placed in 
PBS_HOME\f5/sched_priv/\f2some_file\f1 and the Scheduler run via
.Cs
pbs_sched -b PBS_HOME/sched_priv/some_file
.Ce
More information can be found in the man page pbs_sched_tcl(8).
.RE
.RE
.IP 10.
Log onto the system as root and define yourself to pbs_server as a manager
by typing:
.Cs
\f1#\fP qmgr
\f1Qmgr:\fP set server managers=your_name@your_host
.Ce
From this point, you no longer need root privilege.  Note, "your_host"
can be any host on which PBS' qmgr command is installed.
You can now configure and manage a remote batch system from the comfort of
your own workstation.
.IP
Now you need to define at least one queue.  Typically it will be an
execution queue unless you are using this server purely as a gateway.
You may chose to establish queue minimum, maximum, and/or default 
resource limits for some resources.  For example, to establish a
minimum of 1 second, a maximum of 12 cpu hours, and a default of 30 cpu
minutes on a queue named \*Qqname\*U; issue the following commands inside
of qmgr:
.Cs
\f1Qmgr:\fP create queue qname queue_type=e
\f1Qmgr:\fP s q qname resources_min.cput=1,resources_max.cput=12:00:00
\f1Qmgr:\fP s q qname resources_default.cput=30:00
\f1Qmgr:\fP s q qname enabled=true
.Ce
Lastly, allow the the scheduling of jobs by pbs_sched by issuing:
.Cs
\f1Qmgr:\fP s s scheduling=true
.Ce
.sp
When the attribute
.At scheduling
is set to true, the server will call the the job scheduler, if false the job
scheduler is not called.  The value of 
.At scheduling
may be specified on the pbs_server command line with the \-a option.
.NH 2
.Tc \f3Build Details\fP
.LP
While the overview gives sufficient information to build a basic PBS system,
there are lots of options available to you and custom tailoring that should
be done.
.NH 3
.Tc "Make File Targets"
.LP
The follow target names are applicable for make:
.IP all 11
The default target, it compiles everything.
.IP build 11
Same as all.
.IP depend 11
Builds the header file dependency rules.
.IP install\ 
Installs everything.
.IP clean 
Removes all object and executable program files in the current subtree.
.IP distclean
Leaves the object tree very clean.  It will remove all files that were
created during a build.
.LP
.NH 3
.Tc "Configure Options"
.LP
The following is detailed information on the options to the configure script.
.NH 4
Generic Configure Options
.LP
The following are generic configure options that do not effect PBS.
.IP --cache-file=\f5file\fP
Cache the system configuration test results in \f5file\fP.
.br
Default: config.cache
.IP --help\ \ 
Prints out information on the available options.
.IP --no-create
Do not create output files.
.IP "--quiet, --silent"
Do not print \*Qchecking\*U messages.
.IP --version
Print the version of autoconf that created configure.
.IP --enable-depend-cache
This turns on configure's ability to cache 
.I makedepend
information across runs of configure.
This can be bad if the user makes certain configuration
changes in rerunning configure, but it can save time in the hands of
experienced developers.
.br
Default: disabled
.LP
.NH 4
Directory and File Names
.LP
These options specify where PBS objects will be placed.
.IP --prefix=\f5PREFIX\fP
Install files in subdirectories of \f5PREFIX\fP directory.
.br
Default: /usr/local
.IP --exec-prefix=\f5EPREFIX\fP
Install architecture dependent files in subdirectories of \f5EPREFIX\fP.
.br
Default: see PREFIX
.IP --bindir=\f5DIR\fP
Install user executables (commands) in subdirectory \f5DIR\fP.
.br
Default: EPREFIX/bin   (/usr/local/bin)
.IP --sbindir=\f5DIR\fP
Install System Administrator executables in subdirectory \f5DIR\fP.
This includes certain administrative commands and the daemons.
.br
Default: EPREFIX/sbin   (/usr/local/sbin)
.IP --libdir=\f5DIR\fP
Object code libraries are placed in \f5DIR\fP.  This includes the PBS API
library, libpbs.a.
.br
Default: PREFIX/lib   (/usr/local/lib)
.IP --includedir=\f5DIR\fP
C language header files are installed in \f5DIR\fP.
.br
Default: PREFIX/include   (/usr/local/include)
.IP --mandir=\f5DIR\fP
Install man pages in \f5DIR\fP.
.br
Default: PREFIX/man   (/usr/local/man)
.IP --srcdir=\f5SOURCE_TREE\fP
PBS sources can be found in directory \f5SOURCE_TREE\fP.
.br
Default: location of
.I configure
script.
.LP
.NH 4
Features and Package Options
.LP
In general, these options take the following forms:
.TS
tab(;) ;
l l.
\f5--disable-\fP\s-2FEATURE\s+2;Do not compile for \s-2FEATURE\s+2, same as --enable-\s-2FEATURE\s+2=no
\f5--enable-\fP\s-2FEATURE\s+2;Compile for FEATURE
\f5--with-\fP\s-2PACKAGE\s+2;Compile to include \s-2PACKAGE\s+2 
\f5--without-\fP\s-2PACKAGE\s+2;Do not compile to include PACKAGE, same as with-PACKAGE=no
\f5--set-\fP\s-2OPTION\s+2;Set the value of \s-2OPTION\s+2
.TE
For PBS, the recognized --enable/disable, --with/without, and --set options are:
.IP --enable-docs
Build (or not build) the PBS documentation.
To do so, you will need the following GNU
utilities: groff, gtbl and gpic.  Even if this option is not set, the
man pages will still be installed.
.br
Default: disabled
.IP --enable-server
Build (or not build) the PBS job server, pbs_server.
Normally all components (Commands, Server, Mom, and Scheduler) are built.
.br
Default: enabled
.IP --enable-mom
Build (or not build) the PBS job execution daemon, pbs_mom.
.br
Default: enabled
.IP --enable-clients
Build (or not build) the PBS commands.
.br
Default: enabled
.IP --with-tcl=\f5DIR_PREFIX\fP
Use this option if you wish Tcl based PBS features compiled.  These features
include the GUI interface, xpbs.  If the following option, --with-tclx, is
set, use this option only if the Tcl libraries are not co-located with the
Tclx libraries.  When set, \f5DIR_PREFIX\fP must specify the absolute path
of the directory containing the Tcl Libraries.
.br
Default: without, Tcl utilities are not built.
.IP --with-tclx=\f5DIR_PREFIX\fP
Use this option if you wish the Tcl based PBS features to be based on Tclx.
This option implies --with-tcl.
.br
Default: Tclx is not used.
.IP --enable-gui
Build the xpbs GUI.
Only valid if --with-tcl is set.
.br
Default: enabled
.IP --set-cc[=\f5ccprog\fP]
Specify which C compiler should be used.  This will override the CC environment
setting.  If only --set-cc is specified, then CC will be set to \f5cc\fP.
.br
Default: gcc (after all, configure is from GNU also)
.IP --set-cflags[=\f5FLAGS\fP]
Set the compiler flags.  This is used to set the CFLAGS variable.
If only --set-cflags is specified, then CFLAGS is set to \*Q\*U.
This must be set to \f5-64\fP to build 64 bit objects under Irix 6, e.g.
.Ty "--set-cflags=-64" .
Note, multiple flags, such as -g and -64 should be enclosed in quotes, e.g.
.Ty "--set-cflags='-g\ -64'"
.br
Default: CFLAGS is set to a best guess for the system type.
.IP --enable-debug
Builds PBS with debug features enabled.   This allows the daemons to remain
attached to standard output and produce vast quantities of messages.
.br
Default: disabled
.IP --set-tmpdir=\f5DIR\fP
Set the tmp directory in which pbs_mom will create temporary scratch
directories for jobs.  Used on Cray systems only.
.br
Default: /tmp
.IP --set-server-home=\f5DIR\fP
Sets the top level directory name for the PBS working directories, PBS_HOME.
This directory MUST reside on a local file system.  PBS uses synchronous
writes to files to maintain state.  
.br
Default: /usr/spool/pbs
.IP --set-server-name-file=\f5FILE\fP
Set the file name which will contain the name of the default server.
This file is used by the commands to determine which server to contact.
If \f5FILE\fP is not an absolute path, it will be evaluated relative to
the value of --set-server-home.  
.br
Default: server_name
.IP --set-default-server=\f5HOSTNAME\fP
Set the name of the host that clients will contact when not otherwise specified
in the command invocation.  It must be the primary network name of the host.
.br
Default: the name of the host on which PBS is being compiled.
.IP --set-environ=\f5PATH\fP
.mc |
Set the path name of the file containing the environment variables used by
the daemons and passed to the jobs.
For AIX based systems, we suggest setting this option to \f5/etc/environment\fP.
Relative path names are interpreted relative to the value of --set-server-home,
PBS_HOME.
.br
Default: the file \f5pbs_environment\fP in the directory PBS_HOME.
.IP
For a discussion of this file and the environment, see section
.B "5.1.1. Internal Security" .
You may edit this file to modify the path or add other environmental variables.
.mc
.IP --enable-plock-daemons=\f5WHICH\fP
Enable daemons to lock themselves into memory to improve performance.
The argument \f5WHICH\fP is the logical-or of 1 for pbs_server, 2 for
pbs_sheduler, and 4 for pbs_mom (7 is all three daemons).
This option is recommended for Unicos systems.   It should \f3not\fP be used for
AIX systems.
.br
Default: disabled.
.IP --enable-syslog
Enable the use of syslog for error reporting.   This is in addition to the
normal PBS logs.
.br
Default: disabled.
.IP --set-sched=\f5TYPE\fP
Set the scheduler (language) type.
If set to \f5c\fP, a C based scheduler will be compiled.
If set to \f5tcl\fP, a Tcl based scheduler will be used.
If set to \f5basl\fP, a BAtch Scheduler Language scheduler will be generated.
If set to \f5no\fP, no scheduler will be compiled, jobs will have to be run
by hand.
.br
Default: c
.IP --set-sched-code=\f5PATH\fP
Sets the name of the file or directory containing the source for the scheduler.
This is only used for C and BaSL schedulers, where --set-sched is set to
either \f5c\fP or \f5basl\fP.
For C Schedulers, this should be a directory name.   For BaSL schedulers,
it should be file name ending in \f5.basl\fP.  If the path is not absolute,
it will be interpreted relative to 
SOURCE_TREE/src/schedulers.SCHED_TYPE/samples.  For example, if  --set-sched
is set to basl, then set --set-sched-code to \f5fifo_byqueue.basl\fP.
.br
Default: fifo  (C based scheduler)
.IP --enable-tcl-qstat
Builds qstat with the Tcl interpreter extensions.  This allows site and
user customizations.  Only valid if --with-tcl is already present.
.br
Default: disabled
.IP  --set-tclatrsep=\f5CHAR\fP
Set the character to be used as the separator character between attribute
and resource names in Tcl/Tclx scripts.
.br
Default: "."
.IP --set-qstatrc-file=\f5FILE\fP
Set the name of the file that qstat will use if there is no 
.I .qstatrc
file in the user's home directory.  
This option is only valid when  --enable-tcl-qstat is set.
If \f5FILE\fP is a relative path, it will be evaluated relative to
the PBS Home directory, see --set-server-home.
.br
Default: PBS_HOME/qstatrc
.IP  --with-scp
Directs PBS to attempt to use the
.I "Secure Copy Program" ,
.I scp ,
when copying files to or from a remote host.  This applies for delivery of
output files and stage-in/stage-out of files.  If scp is to used and the
attempt fails, PBS will then attempt the copy using rcp in case that scp
did not exist on the remote host.
.IP
For local delivery, \*Q/bin/cp -r\*U is always used.   For remote delivery, a
varient of rcp is required.   The program must always provide a non-zero exit
status on any failure to deliver files.   This is not true of all rcp
implementation, hence a copy of a known good rcp is included in the source,
see mom_rcp.
More information can be found in chapter 6.4
\*QDelivery of Output Files.\*U
.br
Default: sbindir/pbs_rcp  (from the mom_rcp source directory) is used,
where sbindir is the value from --sbindir.
.IP --enable-shell-pipe
When enabled, pbs_mom passes the name of the job script to the top level
shell via a pipe
rather than placing the script file as the shell's standard input.  This does
result in a second shell being created to process the script.  However, a
command in the script that reads from standard input will not be able to access
the script contents, which can cause some shells to by-pass commands in
the script.   
.br
Default: enabled
.IP --enable-sp2
Turn on special features for the IBM SP.   This requires access to a special
IBM supplied library, libSDR.a.  This library is not provided by IBM except
on special request.  This option is only valid when the PBS machine type is
aix4.  The PBS machine type is automatically determined by the configure
script.
.br
Default: disabled
.IP --enable-srfs
This option enables support for Session Reservable File Systems.
It is only valid on
Cray systems with the NASA modifications to support Session Reservable
File System, SRFS.
.br
Default: disabled
.IP --enable-array
Setting this under Irix 6.x enables the use of SGI Array Session tracking.
Enabling this feature is recommanded if MPI jobs use the Array Services
Daemon.  The PBS machine type is set to irix6array.
.br
Default: disabled
.LP
.NH 2
.Tc "\f3Machine Dependent Build Instructions\fP"
.LP
There are a number of possible variables that are only used for a
particular type of machine.  If you are not building for one of
the following types, you may ignore this section.
.NH 3
.Tc "Cray Systems"
.LP
.NH 4
Cray C90, J90, and T90 Systems
.LP
On the traditional Cray systems such as the C90, PBS supports
Unicos versions 8, 9 and 10.
.LP
If your system supports the Session Reservable File System enhancement by NASA,
run configure with the 
.Ty --enable-srfs
option.
If enabled, the server and MOM will be compiled to have the resource names
.I srfs_tmp ,
.I srfs_big ,
.I srfs_fast ,
and
.I srfs_wrk .
These may be used from
.B qsub
to request SRFS allocations.  The file
.Ty /etc/tmpdir.conf
is the configuration file for this.  An example file is:
.Cs
# Shell environ var     Filesystem
TMPDIR
BIGDIR                  /big/nqs
FASTDIR                 /fast/nqs
WRKDIR                  /big/nqs
.Ce
The directory for TMPDIR will default to that defined by JTMPDIR in
Unicos's /usr/include/tmpdir.h.
.LP
Without the SRFS mods, Mom under Unicos will create a temporary job scratch
directory.   By default, this is placed in /tmp.   The location can be changed
via 
.Ty --set-tmpdir=DIR .
.LP
.NH 4
Unicos 10 with MLS
.LP
If you are running Unicos MLS, required in Unicos 10.0 and later, the following
action is required after the system is built and installed.  MOM updates 
.At ue_batchhost
and
.At ue_batchtime
in the UDB for the user.  In an MLS system, MOM must have the security
capability to write the protected UDB.  To grant this capability,
change directory to wherever pbs_mom has been installed and type:
.Cs
spset -i 16 -j daemon -k exec pbs_mom
.Ce
You, the administrator, must have capabilities
.B secadm
and 
.B "class 16"
to issue this command.  You use the setucat and setucls commands to get to these
levels if you are authorized to do so.  The UDB 
.At reclsfy
permission bit gives a user the proper authorization to use the spset command.
.QP
.B WARNING
.QP
There has been only limited testing in the weakest of MLS environments,
problems may appear because of differences in your environment.
.NH 4
Cray T3E Systems
.LP
For Cray T3E systems,  
.B TBD .
.LP
.NH 3
.Tc "IBM Workstations"
.LP
PBS supports IBM workstations running AIX 4.x.
When man pages are installed in 
.I mandir ,
the default man page file name suffix,
\*Q\f3B\fP\*U,  must be removed.   Currently, this must be done by hand.
For example, change man3/qsub.3B to man3/qsub.3.
.LP
Do not use the configure option \f5--enable-plock\fP.
It will crash the system by using up all of memory.
.NH 3
.Tc IBM SP
.LP
Every thing under IBM Workstation section above applies to the IBM SP.
Be sure to read the section
.B "3.1 Nodes"
before configuring the Server.
.LP
Set special SP-2 code to interface with the IBM Resource (Job) Manager with
.Ty --enable-sp2 .
.\" This interface requires two libraries libjm_client.a
.\" and libSDR.a.
.\" \f3IBM \*Qnormally\*U does not supply libSDR.a to SP customers unless 
.\" it is explicitly requested.\fP
.\" .LP
.\" .IP LIBSDR
.\" is the full path of the directory holding the IBM supplied library libSDR.a.
.\" The program
.\" .B pbsnodes
.\" should be run periodicly to disable nodes which are down.
.\" The following script is presented as an example of how to generate
.\" the names of nodes which have gone down from the output of the IBM command
.\" .B SDRGetObjects :
.\" .Cs
.\" #!/bin/sh
.\" 
.\" SDRGetObjects switch_responds node_number switch_responds | \\
.\"         awk '$2 == 0 {printf("b%2.2d%2.2d\n",($1/16+1),$1%16)}'
.\" .Ce
.\" If this script is called "are_down", then the following line could be used
.\" in a MOM config file to create a resource which would flag the
.\" bad nodes for PBS.
.\" .Cs
.\" setdown  !/u/pbsbin/pbsnodes `/u/pbsbin/are_down`
.\" .Ce
.\" The resource "setdown" should then be called before doing any checking of
.\" node availability.
.\" .LP
.\" On the IBM SP, the name of the nodes in mom_priv/nodes must be the same
.\" name as known to the 
.\" IBM Resource Manager, i.e. as defined in the SDR.  The name can be the
.\" hostname without the domain name, that is it does not have to be fully
.\" qualified.
.\" .LP
.NH 3
.Tc "SGI Workstations Running IRIX 5"
.LP
If, and only if, your system is running Irix 5.3, you will need to add
.Ty -D_KMEMUSER
to
.B CFLAGS
because of a quirk in the Irix header files.
.LP
.NH 3
.Tc "SGI Workstations Running IRIX 6"
.LP
If built for Irix 6.x, pbs_mom will track which processes are part of a PBS job
using POSIX session numbers.  This method is fine for workstations and
multiprocessor boxes not running the SGI Array Services Daemon (arrayd) and not
using SGI's mpirun command.  The PBS machine type (PBS_MACH) is set to 
.Ty irix6 .
.LP
Where arrayd and mpirun is being used, the tasks
of a parallel job are started through requests to arrayd and hence are not
part of the job's POSIX session.  In order to relate processes to the job, 
the SGI Array Session Handle (ASH) must be used.
This feature is enabled by setting
.Ty --enable-array .
The PBS machine type (PBS_MACH) is set to
.Ty irix6array
.LP
IRIX 6 supports both 32 and 64 bit objects.
In prior versions of PBS, PBS was typically built as a 32 bit object.
Irix 6.4 introduced system supported checkpoint/restart,
PBS will include support for checkpoint/restart if the file
.I /usr/lib64/libcpr.so
is detected during the build process.  To interface with the SGI
checkpoint/restart library, PBS must be made as a 64 bit object.  Add 
.Ty "-64"
to the 
.B CFLAGS .
This can be done via the configure option
.Ty --set-cflags=-64
.QP
.B WARNING
.QP
Because of changes in structure size, PBS will not be able to recover any
server, queue, or job information recorded by a PBS built with 32 bit objects,
or vice versa.
Please read chapter 3.8 of the Admin Guide
entitled 
.I "Installing an Updated Batch System"  
for instructions on dealing with this incompatibility.
.LP
If libcpr.so is not present, PBS may be built as either a 32 bit or
a 64 bit object.  To build as 32 bit, add
.Ty "-n32"
instead of -64 to
.B CFLAGS .
.LP
.NH 3
.Tc "FreeBSD and NetBSD"
.LP
There is a problem with FreeBSD up to at least version 2.2.6.  It is possible
to lose track of which session a set of processes belongs to if the
session leader exits.  This means that if the top shell of a job leaves
processes running in the background and then exits, MOM will not be
able to find them when the job is deleted.  This should be fixed in
a future version.
.LP
.NH 3
.Tc "Linux"
.LP
Redhat version 4.x is supported.
Version 5.x is not currently supported; there are system header file
differences.
.LP
.NH 3
.Tc "SUN Running SunOS"
.LP
The native SunOS C compiler is not ANSI and cannot be used to build PBS.
GNU gcc is recommended.
.LP
.NH 2
.Tc "\f3Additional Build Options\fP"
.LP
Two header files within the subdirectory src/include provide additional
configuration control over the server and MOM.
The modification of any symbols in the two
files should not be undertaken lightly.
.NH 3
.Tc pbs_ifl.h
.LP
This header file contains structures, symbols and constants used by the API,
libpbs.a, and the various commands as well as the daemons.
Very little here should ever be changed.  Possible exceptions are the following
symbols.  They must be consistent between all batch systems
which might interconnect.
.IP PBS_MAXHOSTNAME
Defines the length of the maximum possible host name.  This should be set 
at least as large as
.B MAXHOSTNAME
which may be defined in 
.I sys/params.h .
.IP PBS_MAXUSER
Defines the length of the maximum possible user login name.
.IP PBS_MAXGRPN
Defines the length of the maximum possible group name.
.IP PBS_MAXQUEUENAME
Defines the length of the maximum possible PBS queue name.
.IP PBS_USE_IFF
If this symbol is set to zero (0), before the library and commands are built,
the API routine pbs_connect() will not attempt to invoke the program
.B pbs_iff
to generate a secure credential to authenticate the user.
Instead, a clear text credential will be generated.
This credential is completely subject to forgery and is useful only for
debugging the PBS system.
You are strongly advised against using a clear text credential.
.IP PBS_BATCH_SERVICE_PORT
Defines the port number at which the server listens.
.IP PBS_MOM_SERVICE_PORT
Defines the port number at which MOM, the execution miniserver, listens.
.IP PBS_SCHEDULER_SERVICE_PORT
Defines the port number at which the scheduler listens.
.LP
.NH 3
.Tc server_limits.h
.LP
This header file contains symbol definitions used by the server and by MOM.
Only those that 
.I might
be changed are listed here.  These should be changed with care.  It is 
strongly recommended that no other symbols in server_limits.h be changed.
If server_limits.h is to be changed, it may be copied into the include
directory of the 
.I target
(build) tree and modified before compiling.
.IP NO_SPOOL_OUTPUT
If defined, directs MOM to not use a spool directory for the job output,
but to place it in the user's home directory while the job is running.
This allows a site to invoke quota control over the output of running batch
jobs.
.IP PBS_BATCH_SERVICE_NAME
This is the service name used by the server to determine to which port number
it should listen.   It is set to
.Ty pbs ,
in quotes as it is a character string.   Should you wish to assign PBS a service
port in 
.Ty /etc/services ,
change this string to the service name assigned.
You should also update PBS_SCHEDULER_SERVICE_NAME as required.
.IP PBS_DEFAULT_ADMIN
Defined to the name of the default administrator, typically \*Qroot\*U.
Generally only changed to simplify debugging.
.IP PBS_DEFAULT_MAIL
Set to user name from which mail will be sent by PBS.  The default is "adm".
This is overridden if the server attribute
.I mail_from
is set.
.IP PBS_JOBBASE
The length of the job id string used as the basename for job associated files
stored in the spool directory.  It is set to 11, which is 14 minus the 3
characters of the suffixes like 
.Ty .JB
and 
.Ty .OU .
Fourteen is the guaranteed length for a file name under POSIX.   The actual
length that a file name can be depends on the file system and must be determined
at run time, but PBS is too lazy to go to that trouble.  If the server
and MOM run on a file system that support longer names (most do), then
you may up this value so that the names are more readable.
.IP PBS_MAX_HOPCOUNT
Used to limit the number of hops taken when being routed from queue to queue.
It is mainly to detect loops.
.IP PBS_NET_MAX_CONNECTIONS
The maximum number of open file descriptors and sockets supported by the
server.  
.IP PBS_NET_RETRY_LIMIT
The limit on retrying requests to remote servers.
.IP PBS_NET_RETRY_TIME
The time between network routing retries to remote queues and for requests
between the server and MOM.
.IP PBS_RESTAT_JOB
To refrain from over burdening any given MOM, the server will wait this
amount of time (default 30 seconds)
between asking her for updates on running jobs.  In other words, if a user
asks for status of a running job more often than this value, the prior data
will be returned.
.IP PBS_ROOT_ALWAYS_ADMIN
If defined (set to 1), \*Qroot\*U is an administrator of the batch system
even if not listed in the 
.Ty managers
attribute.
.IP PBS_SCHEDULE_CYCLE
The default value for the elapsed time between scheduling cycles with no
change in jobs queued.
This is the initial value used by the server, but it can be changed via 
.B qmgr (1B).
.LP
.NH 2
.Tc "\f3Site Modifiable Source Files\fP"
.LP
It is safe to skip this section untill you have played with PBS for a while
and want to start tinkering.
.LP
Dave Tweten of NASA has said, "If it ain't source, it ain't software."
This is part of PBS's philosophy that source distribution should be a major
part of any software product.  Otherwise, the product becomes
\*Qhard\*U\-ware.
The first example of this philosophy is the PBS job scheduler.   The
implementation of the site policy is left to the site.  PBS provides three
tools for that implementation, the BaSL scheduler, the Tcl scheduler, and
the C scheduler.
.LP
The philosophy does not stop with the scheduler.
With distribution of the source, a site has the ability to modify any
part of PBS as they so choose.  Of course, in indiscriminate modification is
not without dangers.  Not the least of which is conflicts with future releases
by the developers.
.LP
Certain functions of PBS appear to be likely targets of widespread modification
by sites for a number of reasons.  When identified, the developers of PBS have
attempted to improve the easy of modification in these areas by the inclusion
of special 
.I "site specific modification routines" .
These are identified in the IDS under chapter headings of \*QSite Modifiable
Files\*U in the sections on the Server and MOM.
The distributed default version of these files build a private library,
libsite.a, which is include in the linking phase for the server and for MOM.
They may be replace as needed by a site.  The procedure is described in
the IDS under \*Qlibsite.a \- Site Modifiable Library\*U in chapter 10.
.LP
The files include:
.IP Server
.RS
.IP site_allow_u.c
The routine in this file, 
.I site_allow_u() ,
provides an additional point at which a user
can be denied access to the batch system (server).  It may be used instead
of or in addition to the server Acl_User list.
.IP site_alt_rte.c
The function
.I site_alt_router()
allows a site to add decision capabilities to job routing.  This function
is called on a per-queue basis if the queue attribute 
.At alt_router
is true.  As provided, site_alt_router() just invokes the default router,
.I default_router() .
.IP site_check_u.c
The routine in this file,
.I site_check_user_map() ,
provides the service of authenticating that the
job owner is privileged to run the job under the user name specified or
selected for execution on the server system.  Please see the IDS for the
default authentication method.
.IP site_map_usr.c
For sites without a common user name/uid space, this function,
.I site_map_user() ,
provides a place to add a user name mapping function.
The mapping occurs at two times.  First to determine if a user making a request
against a job is the job owner, see \*QUser Authorization\*U.
Second, to map the submitting user (job owner) to an execution uid on the
local machine.
.IP site_*_attr_*.h
These files provide a site with the ability to add local attributes to the
server, queues, and jobs.  The files are installed into the target tree
\*Qinclude\*U subdirectory during the first make.
As delivered, they contain only comments.  If a site wishes to
add attributes, these files can be 
.I carefully
modified.
.IP
The files are in three groups, by server, queue, and job.   In each group
are
.I site_*_attr_def.h
files which are used to defined the name and support functions for the new
attribute or attributes, and
.I site_*_attr_enum.h
files which insert a enumerated label into the set for the corresponding parent
object.  For server, queue, node  attributes, there is also an additional file
that defines if the qmgr(1) command will include the new attribute in
the set \*Qprinted\*U with the 
.Ty "print server" ,
.Ty "print queue" ,
or 
.Ty "print node"
sub-commands.
.IP
Detailed information on how to modify these files can be found in the IDS
under the \*QSite Modifiable Files\*U section of the Server chapter, chapter 5.
You should note that just adding attributes will have no effect on how PBS
processes jobs.   The main usage for new attributes would be in providing new
scheduler controls and/or information.  The scheduling algorithm will have
to be modified to use the new attributes.    If you need MOM to do something
different with a job, you will still need \*Qto get down and dirty\*U with
her source code.
.RE
.IP MOM
.RS
.IP site_mom_chu.c
If a server is feeding jobs to more than one MOM, additional checking for
execution privilege may be required at MOM's level.  It can be added in
this function
.I site_mom_chkuser() .
.IP site_mom_ckp.c
Provide post-checkpoint,
.I site_mom_postchk()
and pre-restart
.I site_mom_prerst()
\*Quser exits\*U for the Cray.
.IP site_mom_jset.c
The function
.I site_job_setup()
allows a site to perform specific actions once the job session has been created
and before the job runs.
.RE
.LP
.OH 'PBS Administrator Guide''Configuration'
.EH 'Configuration''PBS Administrator Guide'
.NH 1
.Tc "\f3\s+2Batch System Configuration\s-2\fP"
.LP
Now that the system has been built and installed, the work has just begun.
The scheduling policy must be implemented and the Server and Moms configured.
These items are closely coupled.   Managing which and how many jobs are
scheduled into execution can be done in several methods.  Each method has
an impact on the implementation of the scheduling policy and server attributes.
An example is the decision to schedule jobs out of a single pool (queue) or
divide jobs into one of multiple queues each of which is managed differently.
More on this type of discussion is covered under the sections
.B "Server Management"
and 
.B "Scheduling Policies" .  
.NH 2
.Tc \f3Nodes\fP
.LP
Before proceeding, you will need to make some decisions about how the overall
batch system is to be arranged.  
To do that, we need to define some terms:
.IP Node\ \ \ 
A computer system with a single Operating System image, a unified virtual 
memory image, and one or more IP addresses.  Frequently, the term 
.I "execution host"
is used for node.
A box like the SGI Origin 2000,
with contains multiple processing units running under a single OS copy is
one node.
A box like the IBM SP which contains many units, each with their own copy
of the OS, is a collection of many nodes.
.IP
Under PBS, a node may be allocated
.I exclusively ,
.I shared ,
or
.I "timeshared" .
.IP Cluster
A collection of nodes managed by one batch system.  A cluster may be made up
of nodes that are allocated to only one job at a time or of nodes that have
many jobs executing on each at once or a combination of both.
.IP "Cluster Node"
To confuse the issue, we use the term
.I "cluster node"
to identify a node that is allocated specifically to one job (see 
.I "exclusive node" ),
or a few jobs (see 
.I "shared nodes" ).
This type of node may also be called
.I "space shared" .
Hosts that are timeshared among many jobs are called \*Qtimeshared.\*U
.IP "Exclusive Nodes"
An exclusive node is one that is used by one and only one job at a time.
A set of nodes is assigned exclusively to a job for the duration of that job.
This is typically done to improve the performance of message passing programs.
.IP "Shared Nodes"
A
.I "shared node"
is one which is shared by multiple jobs.   If several jobs which requested
multiple shared nodes are running, some nodes may be common to the subset
allocated to each job and some may be unique.  When a node is allocated as
a shared node, it remains so until all jobs using it are terminated.  Then 
the node may be next allocated for shared or exclusive use.
.IP Timeshare
In our context, to always allow multiple jobs to run concurrently on
an execution host or node.  Often the term host rather than node is used
in conjunction with timeshare, as in 
.I "timeshared host" . 
If the term node is used without the timeshare prefix, the node is one which
is allocated either exclusively or shared.
.IP
If a host, or node, is indicated to be timeshared, it will never be allocated
(by the server) exclusively or shared.
.IP "Load Balance"
A policy wherein jobs are distributed across multiple timeshared hosts
to even out the work load on each host.  Being a policy, the distribution
of jobs across execution hosts is solely a function of the Job Scheduler.
.IP "Node Property"
In order to have a means of grouping nodes for allocation, a set of zero or
more node properties may be given to each node.   The property is nothing
more than a string of printable characters without meaning to PBS.   
You, as the PBS administrator, may chose whatever property names you wish.
Your choices for property names should be relayed to the users.
.IP "Batch System"
A PBS Batch System consists of one Job Server (pbs_server), one or more Job
Schedulers (pbs_sched), and one or more execution servers (pbs_mom).
With prior versions of PBS, a Batch System could be set up to support only
a cluster of exclusive nodes 
.B or
to support one or more timeshared hosts.
There was no support for shared nodes.  With this release, a PBS Batch System
may be set up to feed work to one large timeshared system, multiple time
shared systems, a cluster of nodes to be used exclusively or shared, or
any combination of the preceding.
.LP
.NH 3
.Tc "Defining Nodes"
.LP
In prior PBS systems, nodes were only specified when the system was built and
configured to support exclusive nodes.   A single pbs_mom was given a list
of nodes.   When  jobs were run, the top level shell for all jobs ran on the
host where that Mom lived.  Mom allocated nodes to the job and provided the job
a file containing the list of nodes allocated to it.  
If the PBS batch system was supporting one or more timeshared hosts, only the
Job Scheduler knew of those hosts.   It directed where the server should send
the job for execution.
.LP
In this version of PBS, allocation of nodes is handled by the Server instead
of Mom.   Each node to be used by a job must have its own copy of Mom running
on it.  If only timeshared hosts are to be served by the PBS batch system,
then as before, the Job Scheduler must direct where the job should be run.
If unspecified, the Server will execute the job on the host where it is running.
See the next section for full details.
.LP
If nodes are to be allocated 
.I exclusively 
or
.I shared ,
a list of the nodes must be specified to the server.   This list may also
contain timeshared nodes.   Nodes marked as timeshared will be listed
by the
server in a node status report along with the other nodes.  However, the
server will \f3not attempt to allocate them\fP to jobs.
The presence of timeshared nodes in
the list is solely as a convenience to the Job Scheduler and other programs,
such as xpbsmon.
.LP
The node list is given to the server in a file named
.Ty nodes
in the server's home directory
.Ty PBS_HOME/server_priv .
This is a simple text file with the specification of a single node per line
in the file.  The format of each line in the file is:
.Cs
node_name[:ts] [property ...]
.Ce
The node name is the network name of the node (host name).  The optional
.Ty :ts
appended to the name indicates that the node is a timeshared node.
Zero or more properties may be specified.   Each item on the line must be
separated by white space.  Comment lines may be included if the first
non-white space character is the pound sign '#'.
.LP
This is the same format used by Mom in earlier versions with the addition
of the :ts suffix.  The following is an example of a possible nodes file:
.Cs
# The first set of nodes are space shared (cluster) nodes.
# Note that the properties are provided to group 
# certain nodes together.
curly stooge odd
moe   stooge even
larry stooge even
harpo marx odd
groucho marx odd
chico marx even
# And for fun we throw in one timeshared node.
chaplin:ts 
.Ce
.LP
.mc |
After the pbs_server is started with a nodes file containing at least one
node definition, the list of nodes may be altered via the qmgr command.
.IP "Add nodes:"
\f5create node\ \f2node_name\f5\ [attributes=values]\f1
.br
where attributes are \f5state\fP, \f5properties\fP, and \f5ntype\fP.
The possible values for the attributes are:
.RS
.IP state
Which can take the values:
\f5free\fP, \f5down\fP, or \f5offline\fP.
.IP properties
Which can be
any string or comma separated strings which must be enclosed in quotes.
For example: \f5properties="green,blue,yellow"\fP
.IP ntype\ 
What can take the values:
\f5cluster\fP or \f5time-shared\fP.
.RE
.IP "Delete nodes:"
\f5delete node \f2node_name\f1
.IP "Modify nodes:"
\f5set\ node\ \f2node_name\f5\ [attributes=values]\f1
.br
where attributes are the same as for create.
.mc
.LP
.NH 3
.Tc "Where Jobs May Be Run"
.LP
Where jobs may be or will be run is determined by an interaction between
the Scheduler and the Server.  This interaction is effected by the existence
of the 
.I nodes
file.   
.NH 4
No Node File
.LP
If a nodes file does not exist, the server only directly knows about its own
host.   It will assume that jobs may be executed on it.  When told to run
a job without a specific execution host named, it will default to its own host.
Otherwise, it will attempt to execute the job where directed in the Run Job
request.
.NH 4
Node File Exists
.LP
If a nodes file exists, then the following rules come into play
.RS
.IP 1. 4
If a specific host is named in the Run Job request and
the host is specified in the nodes file as a 
.I timeshared
host, the Server will attempt to run the job on that host.
.IP 2.
If a specific host is named in the Run Job request and
the named node is not in the nodes file as a timeshared host or if there
are multiple nodes named in the Run Job request, then the Server attempts to
allocate the named 
.I cluster
node or nodes to the job.  All of the named nodes must appear in the server's
nodes file.  If the allocation succeeds, the job
is run directly on the first of the nodes allocated.
.IP 3.
If no location was specified on the Run Job request, but
the job requests nodes, then cluster nodes which match the request are allocated
if possible.  If the allocation succeeds, the job is run on the node allocated
to match the first specification in the node request.
Note, the Scheduler may modify the
job's original node request,  see the job attribute
.At neednodes .
.IP 4.
Otherwise,  a set of nodes to allocate is specified by a server attribute,
.At default_node .
By default, this is one shared node, 
.Ty 1#shared .
It may be set to any valid node request
or any single timeshared node listed in the nodes file.
.RE
.LP
What the above all means can be boiled down into the following set of
guidelines:
.RS
.IP \- 4
If the batch system consists of a single timeshared host on which the server
and Mom are running, no problem \- all 
the jobs run there.  The scheduler only needs to say which job it wants run.
.IP \-
If you are running a timeshared complex with \f2one\fP or more back-end hosts,
where Mom is on a different host than is the server, then
load balancing jobs across the various hosts
is a matter of the scheduler determining on which host to place the 
selected job.
This is done by querying the resource monitor side of Mom using the resource
monitor API - the addreq() and getreq() calls.   The Scheduler tells the server
where to run each job.  You should change the server attribute
.At default_node
to a value of one of the time shared hosts (the host if you only have one).
.IP \-
If your cluster is made up of cluster nodes and you are
running distributed (multiple node) jobs, as well as serial jobs, the
Scheduler typically uses the
.I "Query Resource"
or
.I Avail
request to the server for each queued job under consideration.   The Scheduler
then selects one of the jobs that the Server replied could run, and directs
that the job should be run.  The Server will then allocate the nodes to the job.
By leaving the server attribute 
.At default_node
set to one shared node,
.Ty 1#shared ,
jobs which do not request nodes will be placed together on a few nodes
running shared jobs.
.IP \-
If you have a batch system supporting both cluster nodes and one timeshared
node, the situation is like the above, only you may wish to change
.At default_node
to point to the timeshared host.  Jobs that do not ask for nodes will end
up running on the timeshared host.
.IP \-
If you have a batch system supporting both cluster nodes and multiple time
shared hosts,  you have a complex system which requires a smart scheduler.
The Scheduler must recognize which jobs request nodes and use the
.I Avail 
request to the Server. It must also recognize which jobs are to be load
balanced among the timeshared hosts, and provide the host name
to the Server when directing that the job be run.  The supplied 
.I fifo
scheduler has this capability.
.RE
.LP
.NH 3
.Tc "Specifying Nodes"
.LP
The \f2nodes\fP resource is set by the user to declare the node requirements
for the job.  It is a string of the form 
.Cs
node_spec[+node_spec...]
.Ce
where node_spec is
.Cs
.Ty "number | property[:property...] | number:property[:property...]"
.Ce
The node_spec may have an optional global modifier appended. This is of the
form
.Ty #property .
For example:
.Cs
.Ty 6+3:fat+2:fat:hippi+disk
.Ce
or 
.Cs
.Ty 6+3:fat+2:fat:hippi+disk#prime .
.Ce
Where fat, hippi, and disk are examples of property names assigned by the
administrator in the \*Qnodes\*U file.  The above example translates as the 
user requesting 6 plain nodes plus 3 \*Qfat\*U nodes plus 2 nodes that are
both \*Qfat\*U and \*Qhippi\*U plus one \*Qdisk\*U node, a total of 12 nodes.
Where #prime is appended as a global modifier, the global property,
\*Qprime\*U is appended by the Server to each element of the spec.  It would
be equivalent to
.Cs
.Ty 6:prime+3:fat:prime+2:fat:hippi:prime+disk:prime .
.Ce
A major use of the global modifier is to provide the 
.I shared
keyword.   This specifies that all the nodes are to be shared nodes.  The
keyword shared is only recognized as such when used as a global modifier.
.LP
Two additional Read-Only resources exist for jobs.
They are \f2nodect\fP and \f2neednodes\fP.
Nodect (node count) is set by the server to the integer number of nodes
desired by the user as declared in the \*Qnodes\*U resource specification.
That declaration is parsed and
the resulting total number of nodes is set in nodect.  This is useful when
an administrator wishes to place an integer limit,
.I resources_min
or 
.I resources_max ,
on the number of nodes used by a job entering a queue.
.LP
Based on the above example, it would be set to 12 (6+3+2+1).
Neednodes is initially set by the Server to the same value as nodes.
Neednodes may be modified by the job scheduler for special policies.
The contents of
neednodes determines which nodes are actually assigned to the job.
Neednodes is visible to the administrator but not to the user.
.LP
If you wish to set up a queue default value for \*Qnodes\*U (a value to which
the resource is set if the user does not supply one), corresponding
default values must be set for \*Qnodect\*U and \*Qneednodes\*U.  For example
.Cs
\f1Qmgr:\fP set queue foo resources_default.nodes=1
\f1Qmgr:\fP set queue foo resources_default.nodect=1
\f1Qmgr:\fP set queue foo resources_default.neednodes=1
.Ce
Minimum and maximum limits are set for \*Qnodect\*U only.  For example:
.Cs
\f1Qmgr:\fP set queue foo resources_min.nodect=1
\f1Qmgr:\fP set queue foo resources_max.nodect=15
.Ce
Minimum and maximum values must 
.B not
be set for nodes or neednodes as those are string values.
.NH 2
.Tc \f3Network Addresses\fP
.LP
PBS makes use of fully qualified host names for identifying the jobs and
their location.  A PBS batch system is known by the host name on which the
server, pbs_server, is running.  If the server is started with an non-standard
port number, see -p option in the pbs_server(8) man page, the server \*Qname\*U
becomes 
.I host_name.domain:port , 
where port is the numeric port number being used.  See the discussion of 
.B "Alternate Test Systems"
later in this section.
.LP
.mc |
The three daemons and the commands will attempt to use /etc/services to identify
the standard port numbers to use for communication.  The port numbers need not
be below the magic 1024 number.  The service names that should be added to
/etc/services are
.Cs
pbs           15001/tcp           # pbs server (pbs_server)
pbs_mom       15002/tcp           # mom to/from server
pbs_resmom    15003/tcp           # mom resource management requests
pbs_resmom    15003/udp           # mom resource management requests
pbs_sched     15004/tcp           # scheduler
.Ce
The numbers listed are the default number used by this version of PBS.  If
you change them, be careful to use the same numbers on all systems.  
.mc
.LP
If the services cannot be found in /etc/services, the PBS components will
default to the above listed numbers.
.LP
As of release 1.1.9, there is one additional port used.  
.I pbs_dis
is used for requests of the server in the new 
.I "Data Is Strings" 
data encoding.  
As of release 1.1.10, port 15003/tcp is used by pbs_mom for task management
(and alternately for scheduler communication) as well as 15003/udp.
.NH 2
.Tc \f3Starting Daemons\fP
.LP
All three of the daemon processes, Server, Scheduler and MOM,
must run with the real and effective uid of root.
Typically, the daemons are started from the systems boot files,
e.g. /etc/rc.local.
However, it is recommended that the Server be brought up \*Qby hand\*U the
first time and configured before being run at boot time.
.NH 3
Starting the Server
.LP
The initial run of the Server or any first time run after recreating the home
directory should be with the
.Ty "-t create"
option.   This option directs the Server to create a new server database.
If one is already present, it is discarded after receiving a positive
validation response.  At this point it is necessary to configure the
Server.  See the section 3.4.1
.B "Server Configuration".
The create option leaves the server in a \*Qidle\*U state.  In this state
the server will not contact the scheduler and jobs are not run, except manually via the qrun(1B) command.
Once the server is up, it can be placed in the \*Qactive\*U state by setting
the server attribute \f5scheduling\fP to a value of true:
.Cs
qmgr -c "set server scheduling=true"
.Ce
The value of \f5scheduling\fP is retained across server terminations/starts.
.LP
After the server is configured it may be placed into service.   Normally it is
started in the system boot file.  The 
.Ty "-t start_type"
option may be specified where
.Ty start_type
is one of the options specified in the ERS (and the pbs_server man page).
The default is
.Ty warm . 
Another useful option is the 
.Ty "-a true|false"
option.  This turns on|off the invocation of the PBS job scheduler.
.NH 3
Starting the Scheduler
.LP
The Scheduler should also be started at boot time.  Typically the only required
option for the BaSL based scheduler is the
.Ty "-r script_file"
option specifying the script file.
For the Tcl based scheduler, the option
.Ty "-b script_file"
is used to specify the Tcl script to be called.
.NH 3
Starting MOM
.LP
MOM should also be started at boot time.  Typically there are no options unless
MOM is being restarted on a running system or the pbs_sever or pbs_sched
are running on a different host.
.LP
If MOM is taken down and the
host system continues to run, MOM should be restarted with the
.Ty -r
option.  This directs MOM to kill off any jobs which were left running.  See
the ERS for a full explanation.
.LP
By default, MOM will only accept connections from a privileged port on her
system, either the port associated with \*Qlocalhost\*U or the name returned
by gethostname(2).    If the server or scheduler are
running on a different host, the host
name(s) must be specified in MOM's configuration file.
See the -c option on the
pbs_mom(8B) man page and in the Admin Guide, see sections
.B "2.5 3Configurating the Execution Server, pbs_mom"
for more information on the configuration file.
.LP
Should you wish to make use of the prologue and/or epilogue script features,
please see section 6.2 \*QJob Prologue/Epilogue Scripts".
.NH 2
.Tc \f3Configuring the Job Server, pbs_server\fP
.LP
Server management consist of configuring the server attributes and establishing
queues and their attributes.
Unlike Mom and the Job Scheduler, the Job Server (pbs_server) is configured
while it is running, except for the nodes file.
Configuring server and queue attributes and creating queues is done with the
qmgr(1B) command.  This must be either as root or as a User who has been
granted PBS Manager privilege as shown in the last step in the
.B "Build Overview"
section of this guide.
Exactly what needs to be set depends on your
scheduling policy and how you chose to implement it.  The system needs at
least one queue established and certain server attributes initialized.
.LP
The server attributes are discussed in section 2.4 of the ERS.  The following
are the \*Qminimum required\*U server attributes and the recommended attributes.
For the sake of examples, we will assume that your site is a sub-domain of a
large network.  All hosts at your site have names of the form:
.sp
.nf
\ \ \ \f2host\f3.foo.bar.com\f1
.fi
.sp
and the batch system consists of a single large machine named
.B big.foo.bar.com .
.NH 3
.Tc Server Configuration
.LP
The following attributes are required or recommended.
They are set via the 
.I "set server"
(s s) subcommand to the
.I qmgr (1B)
command.
.LP
Not all of the Server Attributes are discussed here, only what is needed
to get a reasonable system up and running.   See the
.I pbs_server_attributes
man page for a complete list.
.NH 4
Required Server Attributes
.LP
.Al default_queue 
Declares the default queue to which jobs are submitted if a queue is not
specified on the qsub(1B) command.  The queue must be created first.
Example:
.Cs
c q dque queue_type=execution
s s default_queue=dque
.Ce
.NH 4
Recommended Server Attributes
.LP
.Al acl_hosts
A list of hosts from which jobs may be submitted.  For example, if you wish
to allow all the systems on your sub-domain plus one other host, boss,
at headquarters to submit jobs, then set:
.Cs
s s acl_hosts=*.foo.bar.com,boss.hq.bar.com
.Ce
.Al acl_host_enable
Enables the server host access control list, see above.
.Cs
s s acl_host_enable=true
.Ce
.Al default_node
Defines the node on which jobs are run if not otherwise directed.  Please see
section 2.1.2 
.B "Where Jobs May be Run"
for a discussion of how to set this attibute depending on your system.
The default value (also the value assumed if the attribute is unset) is
.Ty 1#shared .
.Cs
s s default_node=big.foo.bar.com
.Ce
.Al managers
Defines which users, at a specified host, are granted batch system
administrator privilege.  For example, to grant privilege to \*Qme\*U at
all systems on the sub-domain and \*Qsam\*U only from this system, big, then:
.Cs
s s managers=me@*.foo.bar.com,sam@big.foo.bar.com
.Ce
.Al operators
Defines which users, at a specified host, are granted batch system
operator privilege.  Specified as are the managers.
.Al resources_cost
If you are planning to use the \*Qsynchronous job starts\*U
feature across multiple execution hosts, you may wish to establish 
arbitrary costs for various resources on each system.  See the ERS section on 
.B "Synchronize Job Starts" 
(section 3.2.2).
.Al resources_defaults
This attribute establishes the resource limits assigned to jobs that were
submitted without a limit and for which there are no queue limits.  It is 
important that a default value be assigned for any resource requirement used
in the scheduling policy.
.Cs
s s resources_defaults.cput=5:00
s s resources_defaults.mem=4mb
.Ce
.Al resources_max
This attribute sets the maximum amount of resources which can be used by a
job entering any queue on the server.   This limit is checked only if there
is not a queue specific resources_max attribute defined for the specific 
resource.
.Al system_cost
See resources_cost.
.LP
.NH 3
.Tc Queue Configuration
.LP
Each server must have at least one queue defined.  It may be either a routing
queue or an execution queue.  Typically it will be an execution queue;
jobs cannot be executed while residing in an routing queue.
.LP
Queue attributes fall into three groups, those which are applicable to both 
types of queues, those applicable only to execution queues and those applicable
only to routing queues.  If an \*Qexecution queue only\*U attribute is set
for a routing queue, or vice versa, it is simply ignored by the system.
However, as this situation might indicate the administrator made a mistake,
the Server will issue a warning message about the conflict.
The same message will be issued if the queue type is changed and there are
attributes that do not apply to the new type.
.LP
Not all of the Queue Attributes are discussed here, only what is needed
to get a reasonable system up and running.   See the
.I pbs_queue_attributes
man page for a complete list.
.NH 4
Required Attributes for All Queues
.LP
.Al queue_type
Must be set to either 
.Ty execution
or
.Ty routing 
(e or r will do).  The queue type must be set before the queue can be enabled.
If the type conflicts with certain attributes which are valid only for the
other queue type,  the set request will be rejected by the server.
.Cs
s q dque queue_type=execution
.Ce
.Al enabled
If set to true, jobs may be enqueued into the queue.  If false, jobs will not
be accepted.
.Cs
s q dque enabled=true
.Ce
.Al started
If set to true, jobs in the queue will be processed, either routed by the
server if the queue is a routing queue or scheduled by the job scheduler
if an execution queue.
.Cs
s q dque started=true
.Ce
.LP
.NH 4
Required Attributes for Routing Queues
.LP
.Al route_destinations
List the local queues or queues at other server to which jobs in this routing
queue may be sent.  For example:
.Cs
s q routem route_destination=dque,overthere@another.foo.bar.com
.Ce
.LP
.NH 4
Recommended Attributes for All Queues
.LP
.Al resources_max
If you chose to have more than one execution queue based on the size or type
of job, you may wish to establish maximum and minimum values for various
resource limits.  This will restrict which jobs may enter the queue.  A routing
queue can be established to \*Qfeed\*U the execution queues and jobs will
be distributed by those limits automatically.
.IP
A resources_max value defined for a specific resource at the queue level will
override the same resource resources_max defined at the server level.
Therefore, it is possible to define a higher as well as a lower value for a
queue limit than the server's corresponding limit.
If there is no maximum value declared for a resource type, there is no 
restriction on that resource.  For example:
.Cs
s q dque resource_max.cput=2:00:00
.Ce
places a restriction that no job requesting more than 2 hours of cpu time will
be allowed in the queue.   There is no restriction on the memory,
.At mem ,
limit a job may request.
.Al resources_min
Defines the minimum value of resource limit specified by a job before the
job will be accepted into the queue.
If not set, there is no minimum restriction.
.LP
.NH 4
Recommended Attributes for Execution Queues
.LP
.Al resources_default
Defines a set of default values for jobs entering the queue that did not
specify certain resource limits.  There is a  corresponding server attribute
which sets a default for all jobs.
.IP
The limit for a specific resource usage is established by checking various
job, queue, and server attributes.  The following list shows the attributes
and their order of precedence:
.RS
.IP 1. 4
The job attribute Resource_List, i.e. what was requested by the user.
.IP 2.
The queue attribute resources_default.
.IP 3.
The server attribute resources_default.
.IP 4.
The queue attribute resources_max.
.IP 5.
The server attribute resources_max.
.IP *
Under Unicos, a user supplied value must be within the system's User Data
Base, UDB, limit for the user.
If the user does not supply a value, the lower of the defaulted value from the
above list and the UDB limit is used.
.RE
.IP
\f3Please note, an \f2unset\f3 resource limit for a job is treated as an 
\f2infinite\f3 limit\f1.
.LP
.NH 4
Selective Routing of Jobs into Queues
.LP
Often it is desirable to route jobs to various queues on a server, or even
between servers, based on the resource requirements of the jobs.  
The queue 
.I resource_min
and
.I resource_max
attributes discussed above make this selective routing possible.
As an example, let us assume you wish to establish two execution queues,
one for short jobs of less than 1 minute cpu time, and the other for long
running jobs of 1 minute or longer.  Call them 
.B short
and 
.B long .
Apply the resources_min and resources_max attribute as follows:
.Cs
set queue short resources_max.cput=59
set queue long  resources_min.cput=60
.Ce
.LP
When a job is being enqueued, it's requested resource list is tested against
the queue limits:
.Ty "resource_min <= job_requirement <= resource_max" .
If the resource test fails, the job is not accepted into the queue.
Hence, a job asking for 20 seconds of cpu time would be accepted into queue
.B short
but not into queue
.B long .
Note, if the min and max limits are equal, only that
exact value will pass the test.
.LP
You may wish to set up a routing queue to feed jobs into the queues with
resource limits.   That will place the job into the appropriate queue.
For example:
.Cs
create queue feed queue_type=routing
set queue feed route_destination="short,long"
set server default_queue=feed
.Ce
A job will end up in either 
.B short
or 
.B long
depending on its cpu time request.
.LP
You should always list the destination queues in order of the most restrictive
first as the first queue which meets the job's requirements will be its
destination (assuming that queue is enabled).  Extending the above example to
three queues:
.Cs
set queue short resource_max.cput=59
set queue long  resource_min.cput=1:00,resource_max.cput=1:00:00
create queue verylong queue_type=execution
set queue feed route_destination="short,long,verylong"
.Ce
A job asking for 20 minutes (20:00) of cpu time will be placed into queue
.B long .
A job asking for 1 hour and 10 minutes (1:10:00) will end up in queue
.B verylong
by default.
.LP
One word of caution is required.  If a job does not specify a resource list
(requirement) for the tested resource.   No test is made.  In the above case,
a job without a cpu time limit will be allowed into queue
.B short .
For this reason, together with the fact that an unset limit is considered to
be an infinite limit, you may wish to add a default value to the queues.
.Cs
set queue short resource_default.cput=40
.Ce
will see that a job without a cpu time specification is limited to 40 seconds
if it enters the short queue.
Be aware of two facts:
.RS
.IP 1.
If a default value is assigned, it is done so after the tests against
min and max.
.IP 2.
Default values assigned to a job from a queue
.Ty resource_default
are not carried with the job if the job moves to another queue.  Those resource
limits becomes unset as when the job was specified.  If the new queue specifies
default values, those values are assigned to the job while it is in the
new queue.
.RE
.LP
Minimum and maximum queue limits work with numerical valued resources, 
including time and size values.   Generally, they do not work with string
valued resources because of character comparison order.
However, setting the min and max to the same value to
force an exact match will work even for string valued resources.
For example,
.Cs
set queue big resource_max.arch=unicos8
set queue big resource_min.arch=unicos8
.Ce
can be used to limit jobs entering queue 
.B big
to those specifying
.Ty arch=unicos8 .
Again, remember that if 
.Ty arch
is not specified by the job, no test is performed and it will be accepted.
.LP
.NH 3
.Tc "Recording Server Configuration"
.LP
Should you wish to record the configuration of a server for re-use, you
may used the 
.I print
subcommand of
.B qmgr (8B).
For example,
.Cs
qmgr -c "print server" > /tmp/server.con
.Ce
will record in the file server.con the qmgr subcommands required to recreate
the current configuration including the queues.
The commands could be feed back into qmgr via standard input:
.Cs
qmgr < /tmp/server.con
.Ce
.LP
.NH 2
.Tc "\f3Configuring the Execution Server, pbs_mom\fP"
.LP
Mom is configured via a configuration file which she reads at initialization
time and when sent the SIGHUP signal.  This file is described in the pbs_mom(8) man page as well as in the following section.
.LP
If the -c option is not specified when mom is run, she will open
.I PBS_HOME/mom_priv/config
if it exists.   If it does not, mom will continue anyway.
This file may be placed else where or given a different name. In which case,
pbs_mom must be started with the -c option.
.LP
The file provides several types of run time information to pbs_mom:
static resource names and values, external resources provided 
by a program to be run on request via a shell escape, and values
to pass to internal set up functions at initialization
(and re-initialization).
.LP
Each item type is on a single line with the component parts separated by
white space.  If the line starts with a hash mark (pound sign, #), 
the line is considered to be a comment and is skipped.
.NH 3
"Access Control and Initialization Values"
.LP
An initialization value directive has a name which starts with a
dollar sign ($) and must be known to MOM via an internal table.
Currently the entries in this table are: 
.IP clienthost
A 
.I $clienthost
entry causes a host name to be added to the list of hosts which will be allowed
to connect to MOM as long as they are using a privileged port.
For example, here are two
configuration file lines which will allow the hosts "fred" and "wilma"
to connect:
.Cs
$clienthost      fred
$clienthost      wilma
.Ce
Two host names are always allowed to connect to pbs_mom, "localhost"
and the name returned to pbs_mom by the system call gethostname().  These
names need not be specified in the configuration file.  The hosts
listed as "clienthosts" comprise a "sisterhood" of hosts.  Any one of the
sisterhood will accept connections from a scheduler 
[Resource Monitor (RM) requests]
or server [jobs to execute] from within the sisterhood.
They will also accept Internal MOM (IM) messages from within the sisterhood.
For a sisterhood to be able to communicate IM messages to each other,
they must all share the same RM port.
.IP
For a scheduler to be able to query resource information from a Mom,
the scheduler's host must be listed as a 
.I clienthost .
.IP
If the Server is provided with a nodes file,  the IP addresses of the hosts
(nodes) in the file will be forwarded by
the Server to the Mom on each host listed in the node file.
These hosts need not be
in the various Mom's configuration file as they will be added internally when
the list is received from the Server.  The Server's host must be either
the same host as the Mom or be listed as a clienthost entry in each Mom's
config file.
.IP restricted
A 
.I $restricted
host entry
causes a host name to be added to the list of hosts which will be allowed
to connect to MOM without needing to use a privilaged port.  These names
allow for wildcard matching.  For example, here is a configuration file
line which will allow queries from any host from the domain "ibm.com".
.Cs
$restricted      *.ibm.com
.Ce
Connections from the specified hosts are restricted in that only
internal queries may be made.  No resources from a config file
will be reported and no control requests can be issued.
This is to prevent any shell commands from being
run by a non-root process.  
.IP
This type of entry is typically used to specify hosts on which a monitoring
tool, such as xpbsmon, can be run.   Xpbsmon will query Mom for general
resource information.
.IP logevent
A
.I $logevent
entry sets the mask that determines which event types are logged by pbs_mom.
For example:
.Cs
$logevent 0x1ff

$logevent 255
.Ce
.IP
The first example would set the log event mask to 0x1ff (511) which enables
logging of all events including debug events.  The second example would set
the mask to 0x0ff (255) which enables all events except debug events.
The values of events are listed in chapter 6.3 \*QUse and Maintenace of Logs\*U
 of this guide.
.IP cputmult
A
.I $cputmult
entry sets a factor used to adjust cpu time used by a job.  This is provided
to allow adjustment of time charged and limits enforced where the job might
run on systems with different cpu performance. 
If Mom's system is faster than the reference system, set cputmult to a decimal
value greater than 1.0.   If Mom's system is slower, set cputmult to a value
between 1.0 and 0.0.  The value is given by
.Cs
value = speed_of_this_system / speed_of_reference_system
.Ce
For example:
.Cs
$cputmult 1.5

$cputmult 0.75
.Ce
.IP wallmult
A $wallmult entry sets a factor used to adjust wall time usage by to job to a
common reference system.  The factor is used for walltime calculations and
limits in the same way as cputmult is used for cpu time.
.NH 3
"Static Resources"
.LP
For static resource names and values, the configuration file contains a
list of resource name/value pairs, one pair per line and separated by
white space.   An Example of static resource names and values could be 
the number of tape drives of different types and could be specified by
.Cs
tape3480      4

tape3420      2

tapedat       1

tape8mm       1
.Ce
The names can be anything and are not restricted to actual hardware. 
For example the entry
.Ty "pong  1"
could be used to indicate to the scheduler that a certain piece
of software is available on this system.
.NH 3
"Shell Commands"
.LP
If the first character of the value portion of a name/value pair
is the exclamation mark (!),
the entire rest of the line is saved to be executed through the services of
the \f3system\fP(3) standard library routine.
The first line of output from the shell command is returned as the response
to the resource query.   
.LP
The shell escape provides a means for the resource monitor to yield
arbitrary information to the scheduler.  Parameter substitution is
done such that the value of any qualifier sent with the resource query, as
explained below, replaces a token with a percent sign (%) followed
by the name of the qualifier.  For example, here is a configuration file
line which gives a resource name of "escape":
.Cs
escape     !echo %xxx %yyy
.Ce
If a query for "escape" is sent with no qualifiers, the command
executed would be "echo %xxx %yyy".  If one qualifier is sent,
"escape[xxx=hi there]", the command executed would be "echo hi there %yyy".
If two qualifiers are sent, "escape[xxx=hi][yyy=there]", the command
executed would be "echo hi there".  If a qualifier is sent with
no matching token in the command line, "escape[zzz=snafu]", an error
is reported.
.LP
A possible use of the shell command configuration entry is to provide a
means by which the use of floating software licenses may be tracked.
If a program can be written to query the license server, the number of
available licenses could be returned to tell the scheduler if it is possible
to run a job that needs a certain licensed package.  [You get the fun and
games of writing this program.]
.LP
.NH 2
.Tc "\f3Configurating the Scheduler, pbs_sched\fP"
.LP
The configuration required for a scheduler depends on the scheduler itself.
If you are starting with the delivered 
.I fifo
scheduler, please jump ahead to section 4.5.1 \*QFIFO Scheduler\*U in this
guide.
.NH 2
.Tc "\f3Alternate Test Systems\fP"
.LP
Alternate or test copies of the various daemons may be run through the use of
the command line options which set their home directory and service port.
For example, the following commands would start the three daemons with a home
directory of 
.Ty /tmp/altpbs
and four ports around 13000.
.LP
.Cs
pbs_server -t create -d /tmp/altpbs -p 13000 -M 13002 -S 13004
pbs_mom -d /tmp/altpbs -M 13002 -R 13003
pbs_sched -d /tmp/altpbs -S 13004 -r script_file
.Ce
.LP
The home directories must be pre-built.  The easiest method is to
alter the 
.B PBS_SERVER_HOME
variable by use of the 
.Ty --set-server-home
option to configure, rerun configure and remake PBS.
.LP
Jobs may be directed to the test system by using the
.Ty server:port
syntax on the -q option.  Status is also obtained using the 
.Ty :port
syntax:
For example, to submit a job to the default queue on the above test server,
request the status of the test server, and request the status of jobs at
the test server:
.Cs
qsub -q @\f1host\fP:13000 job
qstat -Bf \f1host\fP:13000
qstat @\f1host\fP:13000
.Ce
.LP
If you or users are using job dependencies on or between test systems,
there are minor problems of which you (and the users) need to be aware.
The syntax of both the dependency string,
.Ty depend_type:job_id:job_id   
and the job id
.Ty seq_number.host:port 
use colons in an indistinguishable manner. 
The way to work around this is covered in the
.B "Advice for Users"
section at the end of this guide.
.NH 2
.Tc "\f3Installing an Updated Batch System\fP"
.LP
Once you have a running batch system, there will come a time when you wish to
update it or install a new version.
It is assumed that you will wish to build and test the new version using
alternative directories and port numbers described above.
You may change the location of PBS_SERVER_HOME for the
test version, see configure option 
.Ty --set-server-home .
Once you are satisfied with the new system, it is suggested
that you  rebuild the three daemons with PBS_SERVER_HOME set to directory
which will be used in normal operation.  Otherwise you will always have to
use the -d option when starting the daemons.
.LP
When the new batch system is ready to be placed into service, you will wish to
move jobs from the old system to the new.  The following procedure is
suggested.  All servers must be run by root.  The qmgr and qmove commands
should be run by an batch administrator (likely, root is good).
.IP 1.
With the old batch system running, disable the queues and stop scheduling
by setting \*Qscheduling=false\*U.
.IP 2.
Backup the pool of jobs in PBS_SERVER_HOME(old)/server_priv/jobs.
Tar may used for this.   
.LP
Assuming the change is a minor update (change in third digit of the release
version number) or a local change where the job structure did not change
from the old version to the new, it is likely that you could start the new
system in the old HOME and all jobs would be recovered.  However if the job
structure has changed you will need to 
.I move
the jobs from the old system to the new.
The release notes will contain a warning if the job structure has changed or
the move is required for other reasons.
.LP
To move the jobs, continue with the following steps:
.IP 3.
It is likely that PBS_SERVER_HOME will have changed and have been made
during testing.
If not, build a (temporary) server directory tree by changing PBS_SERVER_HOME
using --set-server-home
and typing 
.Ty "buildutils/pbs_mkdirs server"
in the top of the object tree.
.IP 4.
Start the new PBS server in its new home.  If the new home is different from the
directory when it was compiled, use the -d option.
Use the -t option if the server has not been configured for the new directory.
Also start with an alternative port using the -p option.
Turn off attempts to schedule with the -a option:
.Cs
pbs_server -t create -d \f1new_home\fP -p 13000 -a false
.Ce
Remember, you will need to use the 
.Ty :port
syntax when commanding the new server.
.IP 5.
Duplicate on the new server the current queues and server attributes
(assuming you wish to
do so).  Enable each queue which will receive jobs at the new server.
.Cs
qmgr -c "print server" > \f1/tmp/config\fP
qmgr \f1host\fP:13000  < \f1/tmp/config\fP
qenable \f1queue1\fP@\f1host\fP:13000
qenable \f1queue2\fP@\f1host\fP:13000
...
.Ce
.IP 6.
Now list the jobs at the original server and move a few jobs one at a time
from the old to the new server:
.Cs
qstat 
qmove \f1queue\fP@\f1host\fP:13000 \f1job\fP
qstat @\f1host\fP:13000
...
.Ce
If all is going well, move the remaining jobs a queue at a time:
.Cs
qmove \f1queue1\fP@\f1host\fP:13000 `qselect -q\f1queue1\fP`
qstat \f1queue1\fP@\f1host\fP:13000
qmove \f1queue2\fP@\f1host\fP:13000 `qselect -q\f1queue2\fP`
qstat \f1queue2\fP@\f1host\fP:13000
...
.Ce
.IP 7.
At this point, all of the jobs should be under control of the new server and
located in the new server home.  If the new server home is a temporary
directory, shut down the new server and move everything to the real home using
.Cs
cp -R \f1new_home real_home\fP
.Ce
or, if the real (new) home is already set up,
.Cs
cd \f1new_home\fP/server_priv/jobs
cp * \f1real_home\fP/server_priv/jobs
.Ce
to copy just the jobs.
.LP
At this point, you are ready to bring up and enable the new batch system.
.LP
You should be aware of one quirk when using qmove.   If you wish to move a
job from a server running on a test port to the server running on the
normal port (15000), you may attempt, 
.I unsuccessfully ,
to use the following command:
.Cs
qmove \f1queue@host\fP 123.job.\f1host\fP:13000
.Ce
However, that will only move the job to the end of the queue it is already in.
The server receiving the move request (13000), will compare the destination
server name, host, with its own name only, not including the port.   Hence
it will match and it will not send the job where you intended.  To get the
job to move to the server running on the normal port you have to specify
that port in the destination:
.Cs
qmove \f1queue@host\fP:15000 123.job.\f1host\fP:13000
.Ce
.LP
.OH 'PBS Administrator Guide''Scheduling'
.EH 'Scheduling''PBS Administrator Guide'
.NH 1
.Tc \f3\s+2Scheduling Policies\s-2\fP
.LP
PBS provides a separate process to schedule which jobs should be placed into
execution.  This is a flexible mechanism by which you may implement
a very wide variety of policies.  The scheduler uses the standard PBS API
to communicate with the Server and an additional API to communicate with the 
PBS resource monitor,
.B pbs_mom .
Should the provided schedulers be insufficient to meet your site's needs,
it is possible to implement a replacement scheduler using the APIs to
accomplish your heart's desires.
.LP
The first generation batch system, NQS, and many of the other batch systems
use various queue based controls to limit or schedule jobs.  Queues would 
be turned on and off to control job ordering over time or have a limit of
the number of running jobs in the queue.
.LP
While PBS supports multiple queues and the queues have some of the
\*Qjob scheduling\*U attributes used by other batch systems, the PBS Server
does not by itself run jobs or enforce any of the restrictions implied by
these queue attributes.  In fact, the Server will happily run a 
.I held
job that resides in a 
.I stopped
queue with a zero limit on running jobs, if it is directed to do so.  The
direction may come from the operator, administrator, or the Scheduler.
In fact, the Scheduler is nothing more than a client with administration
privilege.
.LP
If you chose to implement your site scheduling policy using a multiple queue
\- queue control based scheme, you may do so.
The server and queue attributes used to control job scheduling may be adjusted
by a client with privilege, such as 
.B qmgr (8B),
or by one of your own creation.  However, the controls actually
reside in the Scheduler, not in the Server.  The Scheduler must check the
status of the Server and queues, as well as the jobs,
determining the setting of the server and queue controls.
It then must use the settings of those controls in its decision making.
.LP
Another approach is the \*Qwhole pool\*U approach, wherein all jobs are
in a single pool (single queue).  The Scheduler evaluates each job on its
merits and decides which, if any, to run.   The policy can easily include
factors such as time of day, system load, size of job, etc.  Ordering of jobs
in the queue need not be considered.
The PBS team believes that this approach is superior for two reasons:
.RS
.IP 1.
Users are not tempted to lie about their requirements in order to \*Qgame\*U
the queue policy. 
.IP 2.
The scheduling can be performed against the complete set of
current jobs resulting in better fits against the available resources.
.RE
.LP
.NH 2
.Tc "\f3Scheduler \- Server Interaction\fP"
.LP
In developing a scheduling policy, it may be important to understand when
and how the server and the scheduler interact.  The server always initiates the
scheduling cycle.  The server opens a connection to the scheduler and sends a
command indicating the reason for the scheduling cycle.
The reason or event that triggers a cycle are:
.IP -
A job newly becomes eligible to execute.  The job may be a new job in an
execution queue, or a job in an execution queue that just changed state from
held or waiting to queued.  [\ \s-1SCH_SCHEDULE_NEW\s+1\ ]
.IP -
An executing job terminates.  [\ \s-1SCH_SCHEDULE_TERM\s+1\ ]
.IP -
The time interval since the prior cycle specified by the server attribute
.At schedule_iteration
is reached.  [\ \s-1SCH_SCHEDULE_TIME\s+1\ ]
.IP -
The server attribute 
.At scheduling
is set or reset to true.  If set true, even if it's value was true, the
scheduler will be cycled.  This provides the administrator/operator a means
on forcing a scheduling cycle.  [\ \s-1SCH_SCHEDULE_CMD\s+1\ ]
.IP -
If the scheduler was cycled and it requested one and only one job to be run,
then the scheduler will be recycled by the server.  This event is a bit
abstruse.   It exists to \*Qsimplify\*U a scheduler.   The scheduler only
need worry about choosing the one best job per cycle.   If other jobs can
also be run, it will get another chance to pick the next job.   Should a
scheduler run none or more than one job in a cycle it is clear that it need
not be recalled until conditions change and one of the above trigger the
next cycle.  [\ \s-1SCH_SCHEDULE_RECYC\s+1\ ]
.IP -
If the server recently recovered, the first scheduling cycle, resulting
from any of the above, will be indicated uniquely.
[\ \s-1SCH_SCHEDULE_FIRST\s+1\ ]
.LP
Once the server has contacted the scheduler and sent the reason for the 
contact, the scheduler then becomes a privileged client of the server.
As such, it may command the server to perform any action allowed to a
manager.  
.LP
When the scheduler has completed all activities it wishes to perform in
this cycle, it will close the connection to the server.  While a connection
is open, the server will not attempt to open a new connection.
.LP
One point should be clarified about job ordering:
.QP
Queues \*Qare\*U and \*Qare not\*U FIFOs.
.LP
What is meant is that while jobs are ordered first in \- first out in the
server and in each queue, that fact does NOT imply that running them in that
order is mandated, required, or even desirable.  That is a decision left 
completely up to site policy and implementation.  The server will maintain
the order across restarts solely as a aid to sites that wish to use a FIFO
ordering in some fashion.
.NH 2
.Tc \f3BaSL Scheduling\fP
.LP
The provided BaSL Scheduler uses a C-like procedural language to write the
scheduling policy. The language provides a number of constructs and predefined
functions that facilitate dealing with scheduling issues. Information about a
PBS server, the queues that it owns, jobs residing on each queue, and the
computational nodes where jobs can be run are accessed via the BaSL data types
.B Server,
.B Que,
.B Job,
.B CNode,
.B "Set Server",
.B "Set Que",
.B "Set Job",
and
.B "Set CNode".
.sp
The idea is that a site must first write a function (containing the
scheduling algorithm) called
.I sched_main()
(and all functions supporting it) using BaSL constructs, and then translate the
functions into C using the BaSL compiler
.B "basl2c",
which would also attach a
main program to the resulting code.  This main program performs general
initialization and housekeeping chores such as setting up local socket to
communicate with the server running on the same machine, cd-ing to the priv
directory, opening log files, opening configuration file (if any), setting up
locks, forking the child to become a daemon, initializing a scheduling cycle
(i.e.  get node attributes that are static in nature), setting up the signal
handlers, executing global initialization assignment statements specified by
the scheduler writer, and finally sitting on a loop waiting for a scheduling
command from the server. The name of the resulting code is
.I pbs_sched.c .
.sp
When the server sends the scheduler an appropriate
scheduling command
{\ \s-1SCH_SCHEDULE_NEW\s+1\ , \ \s-1SCH_SCHEDULE_TERM\s+1\ , \ \s-1SCH_SCHEDULE_TIME\s+1\ , \ \s-1SCH_SCHEDULE_RECYC\s+1\ , \ \s-1SCH_SCHEDULE_CMD\s+1\ , \ \s-1SCH_SCHEDULE_FIRST\s+1\ },
the scheduler wakes up and obtains information about server(s), jobs, queues, and execution host(s),
and then it calls
.I sched_main().
The list of servers, execution hosts, and host queries to send to the hosts'
MOMs are specified in the scheduler configuration file. 
.sp
Global variables defined in the BaSL program will retain their values
in between scheduling cycles while locally-defined variables do not.
.LP
.NH 2
.Tc \f3Tcl Based Scheduling\fP
.LP
The provided Tcl based Scheduler uses the basic Tcl interpreter
with some extra commands for communicating with the PBS Server and Resource
Monitor.  The scheduling policy
is defined by a script written in Tcl.
A number of sample scripts are provided in the source directory
.I src/scheduler.tcl/sample_scripts .
.LP
The Tcl based Scheduler works, very generally, in the following way:
.IP 1.
On start up, the Scheduler reads the initialization script (if it exists)
and executes it.  Then, the body script is read into memory.  This is the
file that will be executed each time a \*Qschedule\*U command is received
from the server.
It then waits for a \*Qschedule\*U command from the server.
.IP 2.
When a schedule command is received, the body script is executed.  No
special processing is done for the script except to provide a connection
to the Server.  A typical script will need to retrieve information for
candidate jobs to run from the server using
.B pbsselstat
or
.B pbsstatjob .
Other information from the Resource Monitor(s) will need to be retrieved
by opening connections with
.B openrm
and submitting queries with
.B addreq
and getting the results with
.B getreq .
The Resource Monitor connections must be closed explicitly with
.B closerm
or the Scheduler will eventually run out of file descriptors.
When a decision is made to run a job, a call to
.B pbsrunjob
must be made.
.IP 3.
When the script evaluation is complete, the Scheduler will close the TCP/IP
connection to the Server.
.NH 3
Tcl Based Scheduling Advice
.LP
The Scheduler does not restart the Tcl interpreter for each cycle.
This gives the ability to carry information from one cycle to the next.
It also can cause problems if variables are not initialized or "unset"
at the beginning of the script when they are not expected to contain any
information later on.
.LP
System load average is frequently used by a script.  This number
is obtained from the system kernel by pbs_mom.  Most systems smooth the
load average number over a time period.  If one scheduling cycle runs one or
more jobs and the next scheduling cycle occurs quickly, the impact of the
newly run jobs will likely not be reflected in the load average.   
This can cause the load average to shoot way up especially when first starting
the batch system.  Also when jobs terminate, the delay in lowering the
load average may delay the scheduling of additional jobs.
.LP
The Scheduler redirects the output from \*Qstdout\*U and \*Qstderr\*U to
a file.  This makes it easy to generate debug output to check what your
script is doing.  It is advisable to use this feature heavily until you
are fairly sure that your script is working well.
.NH 2
.Tc "\f3C Based Scheduling\fP"
.LP
The C based scheduler is similar in structure and operation to the Tcl
scheduler except that C functions are used rather than Tcl scripts.  
.IP 1.
On start up, the scheduler calls
.I "schedinit(argc, argv)"
to initialize whatever is required to be initialized.  This is called one time
only.
.IP 2.
When a schedule command is received, the function
.I "schedule(cmd, connector)"
is invoked.  All scheduling activities occur within that function.
.IP 3.
Upon return to the main loop, the connection to the server is closed.
.LP
Several working scheduler code examples are provided in the samples
subdirectory.
.NH 2
.Tc "\f3C Based Sample Schedulers\fP"
.LP
The following sections discuss simple C based sample schedulers supplied
with PBS.  The sources for the samples are found in 
.I src/scheduler.cc/samples
under the scheduler type name, for example 
.I src/scheduler.cc/samples/fifo .
.NH 3
.Tc "FIFO Scheduler"
.LP
This scheduler will provide several simple scheduling policies.  It provides the
ability to sort the jobs in several different ways, in addition to FIFO order.
There is also the ability to sort on user and group priority.  Mainly this
scheduler is intended to be a jumping off point for a real scheduler to be
written.  A good amount of code has been written to make it easier to change
and add to this scheduler.  Check the IDS for a more detailed view of the
code.
.LP
As distributed, the fifo scheduler is configured to:
.IP -
All jobs in a queue will considered for execution before the next queue
is examined.
(See file 
.Ty PBS_HOME/sched_priv/sched_config )
.IP -
The queues are sorted by queue priority.
(See file 
.Ty PBS_HOME/sched_priv/sched_config)
.IP -
The jobs within each queue are sorted by requested cpu time (cput).
The shortest job is places first.
(See file 
.Ty PBS_HOME/sched_priv/sched_config)
.IP -
Jobs which have been queued for more than a day will be considered starving
and heroic measures will be taken to attempt to run them.
.IP -
Any queue whose name starts with \*Qded\*U is treated as a dedicated time queue.
Jobs in that queue will only be considered for execution if the system is in
dedicated time as specified in the 
.Ty dedicated_time
configuration file.  If the system is in dedicated time, jobs not in a \*Qded\*U
queue will not considered.
(See file 
.nh
.Ty "PBS_HOME/sched_priv/dedicated_time & PBS_HOME/sched_priv/sched_config)"
.hy 1
.IP -
Prime time is from 4:00 AM to 5:30 PM.  Any holiday is considered non-prime.
Standard federal holidays for the year 1998 are included.
(See file
.Ty PBS_HOME/sched_priv/holidays)
.IP -
A sample
.Ty dedicated_time
and resource group file are also included.
.IP -
The system resources which are checked to make sure they are not exceeded: 
.I mem
(memory requested) and 
.I ncpus
(number of CPUs requested).
.LP
.NH 4
Installing the FIFO scheduler
.IP 1. 
As discussed in the build overview, run configure with the following options:
.Ty --set-sched=c
and
.Ty --set-sched-code=fifo ,
which are the default.
.IP 2. 
You may wish to read through the src/scheduler.cc/samples/fifo/config.h file.  
Most default values will be fine.
.IP 3. 
Build and install PBS
.IP 4. 
Change directory into 
.Ty PBS_HOME/sched_priv
and edit the scheduling policy config file
.Ty sched_config ,
or use the default values.  
This file controls the scheduling policy (which jobs are run when).
The default name of
.Ty sched_config
may be changed in config.h.
The format of the sched_config file is: 
.IP
.ft 3
name: value [prime | non_prime | all]
.ft 1
.IP
name and value may not contain any white space
.br
value can be:  true | false | number | string 
.br
any line starting with a '#' is a comment. 
.br
a blank third word is equivalent to \*Qall\*U which is both prime and non-prime
.IP 
the associated values as shipped as defaults are shown in braces {}:
.RS
.IP round_robin
.br
boolean: If true \- run jobs one from each queue in a circular fashion; if
false \- run as many jobs as possible up to queue/server limits from one
queue before processing the next queue.
The following server and queue attributes, if set,  will control if a job
\*Qcan be\*U run:
.At resources_max ,
.At max_running ,
.At max_user_run ,
and
.At max_group_run .
See the man pages pbs_server_attributes and pbs_queue_attributes.
.br
{false all}

.IP by_queue
.br
boolean: If true \- the jobs will be run from their queues; if false \- the
entire job pool in the server is looked at as one large queue.
.br
{true all}

.IP strict_fifo
.br
boolean: If true \- will run jobs in a strict FIFO order.
This means if a job fails to run for any reason, no
more jobs will run from that queue/server that 
scheduling cycle.  If 
.I strict_fifo 
is not set, large jobs can be starved, i.e., not allowed to run because a 
never ending series of small jobs use the available resources.   Also see the
server attribute 
.At resources_max
in chapter 3.4, and the fifo parameter
.I help_starving_jobs
below.
.br
{false all}

.IP fair_share
.br
boolean: This will turn on the fair share algorithm.  It will also turn on 
usage collecting and jobs will be selected using a function of their usage
and priority(shares).
.br
{false all}

.IP load_balancing
boolean: If this is set the scheduler will load balance the jobs between a 
list of time-shared hosts (:ts) obtained from the Server (pbs_server).
The Server reads the list from its nodes file, see chapter 3.1.
.br
{false all}

.IP help_starving_jobs
boolean: This bit will have the scheduler turn on its rudimentry starving jobs
support.  Once jobs have waited for the amount of time give by
.Ty starve_max , 
they are considered starving.  If a job is considered starving, then no jobs
will run until the starving job can be run.  
.Ty Starve_max 
needs to be set also.

.IP sort_by 
string: have the jobs sorted.  sort_by can be set to a single
sort type or 
.I multi_sort.  
If set to 
.I multi_sort, 
multiple 
.I key 
fields are used.  Each 
.I key 
field will be a key for the multi sort.  The order of the key fields decides 
which sort type is used first.

Sorts: no_sort, shortest_job_first, longest_job_first, 
smallest_memory_first, largest_memory_first, high_priority_first,
low_priority_first, multi_sort, fair_share, large_walltime_first, 
short_walltime_first
.br
{shortest_job_first}
.RS
.IP no_sort 
do not sort the jobs
.IP shortest_job_first
ascending by the cput attribute
.IP longest_job_first
descending by the cput attribute
.IP smallest_memory_first
ascending by the mem attribute
.IP largest_memory_first
descending by the mem attribute
.IP high_priority_first
descending by the job priority attribute
.IP low_priority_first
ascending by the job priority attribute
.IP large_walltime_first
descending by job walltime attribute
.IP cmp_job_walltime_asc
ascending by job walltime attribute
.IP multi_sort
sort on multiple keys.  
.IP fair_share
If
.Ty fair_share
if given as the sort key, the jobs are sorted based on the values in the
resource group file.  This is only used if strict priority sorting is needed.
.RE
.IP key
Sort type as defined above for multiple sorts.   Each sorting key is listed
on a separate line starting with the word
.I key .
For example:
.Cs 
sort_by: multi_sort
key: sortest_job_first
key: smallest_memory_first
key: high_priority_first
.Ce
.IP log_filter
What event types not to log.  The value should be the addition of the event 
classes which should be filtered(i.e. ORing them together).
The numbers are defined in 
.I src/include/log.h.
NOTE: those numbers are in hex and log_filter is in base 10.
.br
{256}

Examples:
.nf
filter PBSEVENT_DEBUG2 PBSEVENT_DEBUGnPBSEVENT_ADMIN
	  0x100: 256	   0x080: 128  	  0x004: 4	= 388

	PBSEVENT_JOB	PBSEVENT_DEBUG	PBSEVENT_SCHED
	   0x008: 8	   0x080: 128	  0x040: 64	= 200		
.fi

.IP dedicated_prefix
The queues with this prefix will be considered dedicated queues.
Example:
if the dedicated prefix is "ded"
.br 
then dedicated, ded1, ded5 etc would be dedicated queues

{ded}

.IP starve_max
The amount of time before a job is considered starving.  This config variable
is not used if 
.Ty help_starving_jobs
is not set.

.LP
The following do not matter if fair share is not turned on (which is is not by
default).

.IP half_life
The half life of the fair share usage
.br
{24:00:00}

.IP unknown_shares
The amount of shares for the "unknown" group. 
.br
{10}
.IP sync_time
The amount of time between writing the fair share usage data to disk.
.br
{1:00:00}
.RE
.IP
The policy set by the supplied values in sched_config is:
.br
Jobs are run on the basis of queue priority, both in prime and non-prime time.
.br
Jobs with in each queue are sorted on the basis of smallest (memory) first.
.br
Help for starving jobs will take effect after a job is 24 hours old.

.IP 5.
If fair share or strict priority is going to be used, the resource group file
will need to be created.  Use the following format:
.Cs
# comment
username cresgrp resgrp shares
.Ce
.RS
.IP username 
string: the username of the user or the group
.IP cresgrp
numeric: an id for the group or user, should be unique for each.  For users,
the UID works well.
.IP resgrp
.br
string: the name of the parent resource group this user/group is in.
The root of the entire tree is called 
.Ty root
and is added automatically to the tree by the scheduler.
.IP shares
numeric: The amount of shares(priority) the user/group has in the resource 
group.
.RE

.IP 6.
If strict priority is wanted, a fair share tree will be needed.  A really 
simple one will suffice.  Every user's resgrp will be root.  The amount of
shares will be their priority.  Next, set 
.Ty unknown_shares
to one.  Everyone who is not in the tree will share the one share between them
to make sure everyone in the tree will have priority over them.  Lastly, the 
main sort must be set to 
.I fair_share.
This will sort by the fair share tree which was just set up.

.IP 7. 
Create the holidays file to handle prime time and holidays.  The holidays file 
should use the UNICOS 8 holiday format.  The ordering does matter.  Any line 
that begins with a "*" is considered a comment.
.RS
.IP YEAR\ YYYY
This is the current year.  
.IP <day>\ <prime>\ <nonprime>
Day can be weekday | saturday | sunday
.br
prime and nonprime are times when prime or non-prime time start.  They can 
either be HHMM with no colons(:) or the word "all" or "none"
.IP <day>\ <date>\ <holiday>
day is the day of the year between 1 and 365
date is the calendar date.  Ex Jan 1
holiday is the name of the holiday.  Ex New Year's Day
This is repeated for each company holiday
.RE
.IP 8.
To load balance between timesharing nodes, several things need to happen.  
First, a nodes file needs to be set up in the PBSHOME/server_priv
(See section 3.1).  All 
timesharing nodes need to be denoted with :ts.  These are the nodes which the 
scheduler will load balance between.  Secondly, on every node there has to be
a mom.  In each of mom's config files two static values need to be set up.  One 
for ideal load and the other is maximum load.  This is done by putting two 
lines in the config file like the following format: name value.  The name will
be 
.I ideal_load
and
.I max_load.
Lastly, turn the load_balancing bit on in the scheduling policy config file.
Load balancing will have the job comment changed on running of the job to show
where the job was run.

.nf
Example of mom config file:	(64 processor machine)
ideal_load 60
max_load 64
.fi

.IP 9.
Space sharing is done automatically if there are both a nodes file and the 
job requests nodes.  Make sure to set up a resources_default.nodes and 
resources_default.nodect.

.IP 10.
The scheduler honors the following attributes/node resources:
.RS
.TS
;
l l l.
Queue	:	started
Queue	:	queue_type
Queue	:	max_running
Queue	:	max_user_run
Queue	:	max_group_run
Job	:	job state
Server	:	max_running
Server	:	max_user_run
Server	:	max_group_run
Server	:	resources_available
Server	:	resources_max
Node	:	loadave
Node	:	arch
Node	:	ncpus
Node	:	physmem
.TE
.RE

NOTE: if resources_available.res is set, it will be used, if not
resources_max.res will be used.  If neither are set infinity is 
assumed.
.RE
.LP
.NH 4
Examples FIFO Configuration Files
.LP
The following are just examples and may or may not be what is shipped.
.LP
.LP

.UL "Example of a scheduling config file"

.nf
.ft 2
# 	Set the boolean values which define how the scheduling policy finds 
#	the next job to consider to run.
.ft 5
round_robin: False	ALL
by_queue: True		prime
by_queue: false		non-prime
strict_fifo: true	ALL
fair_share: True	prime
fair_share: false	non-prime

.ft 2
# help jobs which have been waiting too long 
.ft 5
help_starving_jobs: true	prime
help_starving_jobs: false	non-prime

.ft 2
# Set a multi_sort
# This example will sort jobs first by ascending cpu time requested, and then
# by ascending memory requested, and then finally by descending job priority
#
.ft 5
sort_by: multi_sort
key: shortest_job_first
key: smallest_memory_first
key: high_priority_first

.ft 2
# Set the debug level to only show high level messages.
# Currently this only shows jobs being run
.ft 5
debug_level: high_mess

.ft 2
# a job is considered starving if it has waited for this long
.ft 5
max_starve:	24:00:00

.ft 2
# If the scheduler comes by a user which is not currently in the resource group
# tree, they get added to the "unknown" group.  The "unknown" group is in roots
# resource group.  This says how many shares it gets.
.ft 5
unknown_shares: 10

.ft 2
# The usage information needs to be written to disk in case the scheduler 
# goes down for any reason.  This is the amount of time between when the 
# usage information in memory is written to disk.  The example syncs the 
# information ever hour.
.ft 5
sync_time: 1:00:00

.ft 2
# What events do you not want to log.  The event numbers are defined in 
# src/include/log.h.  NOTE: the numbers are in hex, and log_filter is in
# base 10.
# The example is not to log DEBUG2 events, which are the most prolific
.ft 5
log_filter: 256
.fi
.LP
.LP

.UL "Here is an example of the holidays file"

.nf
.ft 2
* the current year
.ft 5
YEAR    1998

.ft 2
*
* Start and end of prime time
*
*               Prime   Non-Prime
* Day           Start   Start
.ft 5
.TS
;
l6 l l.
weekday	0400	1130
saturday	none	all
sunday	none	all
.TE

.ft 2
* 
* The holidays
*
* Day of        Calendar        Company
* Year          Date            Holiday
*
.ft 2
.TS
;
l12 l12 l.
1	Jan 1	New Year's Day
20	Jan 20	Martin Luther King Day
48	Feb 17	President's Day
146	May 26	Memorial Day
185	Jul 4	Independence Day
244	Sep 1	Labor Day
286	Oct 13	Columbus Day
315	Nov 11	Veteran's Day
331	Nov 27	Thanksgiving
359	Dec 25	Christmas Day
.TE
.fi
.ft 1
.LP
.LP

.UL "Example of the resource group file for fair share"

.nf
.ft 2
#
# the groups "root" and "unknown" are added by the scheduler
# All the parents must be added for the children.  This is why all the groups
# are added first.  The cresgrp numbers the users have are their UIDs
#

# name		resgrp		child resgrp	shares

.ft 5
.TS
;
l10 l10 l14 l.
grp1	50	root	10
grp2	51	root	20
grp3	52	root	10
grp4	53	grp1	20
grp5	54	grp1	10
grp6	55	grp2	20
usr1	60	root	5
usr2	61	grp1	10
usr3	62	grp2	10
usr4	63	grp6	10
usr5	64	grp6	10
usr6	65	grp6	20
usr7	66	grp3	10
usr8	67	grp4	10
usr9	68	grp4	10
usr10	69	grp5	10
.TE
.fi
.ft 1
.LP
.LP

.UL "Example of strict priority resource group file"

.nf
.ft 2
# this is a strict priority resource group file.  These are people who should 
# get priority over everyone else.  The amount of shares is the priority of 
# the user.
.ft 5
.fi

.TS
;
l10 l10 l14 l.
sally	1000	root	4
larry	1001	root	6
manager	1010	root	100
vp	1016	root	500
ceo	2000	root	10000
.TE
.ft 1
.LP
.LP

.UL "Example of dedicated file"

.nf
.ft 2
# Format: 
#	FROM		 	       TO
# MM/DD/YYYY HH:MM        MM/DD/YYYY HH:MM
.ft 5
.TS
;
l6 l6 l6 l.
04/10/1998	15:30	04/11/1998	23:50
05/15/1998	05:15	05/15/1998	08:30
06/10/1998	23:25	06/10/1998	23:50
.TE
.fi
.ft 1
.LP
.NH 2
.Tc "\f3Scheduling and File Staging\fP"
.LP
A decision must be made about when
to begin to stage in files for a job. The files must be available before the
job executes.  The amount of time that will be required to copy the files is
unknown to PBS, that being a function of file size and network speed.
If file in-staging is not started until the job has been selected to run
when the other required resources are available, either those resources are
\*Qwasted\*U while the stage in occurs, or another job is started which takes
the resources away from the first job, and might prevent it from running.
If the files are staged in well before the job is otherwise ready to run,
the files may take up valuable disk space need by running jobs.
.LP
PBS provides two ways that file in-staging can be initiated for a job.
If a run request is received for a job with a requirement for staging-in files,
the staging in operation is begun and when completed, the job is run.
Or, a specific stage-in request may be received for a job, see pbs_stagein(3B),
in which case the files are staged in but the job is not run.  When the job
is run, it begins execution immediately because the files are already there.
.LP
In either case, if the files could not be staged-in for any reason, the job
is placed into a wait state with a \*Qexecute at\*U time
.Sc PBS_STAGEFAIL_WAIT ,
30 minutes, in the future.   A mail message is sent to the job owner requesting
that s/he look into the problem.  The reason the job is changed into wait
state is to prevent the scheduler from constantly retrying the same job which
likely would keep on failing.
.LP
Figure 5.0 in appendix B of the ERS shows the (sub)state changes for a job
involving file in staging.  The scheduler may note the substate of the job and
chose to perform pre-staging via the pbs_stagein() call.
The substate will also indicate completeness or failure of the operation.
The scheduler developer should carefully chose a stage in approach based
on factors such as the likely source of the files, network speed, and
disk capacity.

.LP
.OH 'PBS Administrator Guide''Operation'
.EH 'Operation''PBS Administrator Guide'
.NH 1
.Tc "\f3\s+2GUI System Administrator Notes\s-2\fP"
.LP
Currently, PBS provides two GUIs: xpbs and xpbsmon.
.NH 2
.Tc "xpbs"
.LP
\f3xpbs\f1 provides a user-friendly point-and-click interface to the PBS
commands.
.br
The system administrator can specify a global resources file,
\f2${PBS_LIB}/xpbs/xpbsrc\f1, which is read by the GUI if a
personal \f2.xpbsrc\f1 file is missing.  Keep in mind that within an
Xresources file (Tk only), later entries take precedence. For example, suppose
in your \f2.xpbsrc\f1 file, the following entries appear in order:
.sp
xpbsrc*backgroundColor: blue
.br
*backgroundColor: green
.sp
The later entry "green" will take precedence even though the first one is more
precise and longer matching.
.LP
The things that can be set in the personal preferences file are fonts, colors,
and favorite server host(s) to query.
.NH 2
.Tc "xpbsmon"
.LP
\f3xpbsmon\f1 is the node monitoring GUI for PBS. It is used for displaying
graphically information about execution hosts in a PBS environment. Its
view of a PBS environment consists of a list of sites where each site
runs one or more servers, and each server runs jobs on one or more execution
hosts (nodes).
.LP
The system administrator needs to define the sites information in a global X
resources file, \f2$PBS_LIB/xpbsmon/xpbsmonrc\f1, which is read by the GUI if
a personal \f2.xpbsmonrc\f1 file is missing. A default xpbsmonrc file usually
would have been created already upon install, defining (under *sitesInfo
resource) a default site name, list of servers that run on a site, set of nodes
(or execution hosts) where jobs on a particular server run, and the list of
queries that are communicated to each node's \f3pbs_mom\f1.  If node queries
have been specified, the host where xpbsmon is
running must have been given explicit permission by the \f3pbs_mom\f1 daemon to
post queries to it.  This is done by including a 
.Ty $restricted
entry in the Mom's config file.  See chapter 2.5 for more information on
the restricted entry.
.LP
It is not recommended to manually update the *sitesInfo value in the xpbsmonrc
file as its syntax is quite cumbersome. The recommended procedure is to
bring up xpbsmon, click on "Pref.." button, manipulate the widgets in
the Sites, Server, and Query Table dialog boxes, then click "Close" button
and save the settings to a \f2.xpbsmonrc\f1 file. Then copy this file over to
\f2$PBS_LIB/xpbsmon\f1.
.NH 1 
.Tc "\f3\s+2Operational Issues\s-2\fP"
.LP
This chapter addresses a few of the \*Qday to day\*U operational issues
which will arise.
.NH 2
.Tc \f3Security\fP
.LP
There are three parts to security in the batch system: 
.IP "Internal security"
Can the daemons be trusted?
.IP Authentication
How do we believe a client about who it is. 
.IP Authorization
Is the client entitled to have the requested action performed.
.LP
.NH 3
.Tc "Internal Security"
.LP
An effort has been made to insure the various PBS daemon themselves cannot
be a target of opportunity in an attack on the system.  The two major parts
of this effort is the security of files used by the daemons and the security
of the daemons environment.
.LP
Any file used by PBS, especially files that specify configuration or other
programs to be run, must be secure.  The files must be owned by root and in
general cannot be writable by anyone other than root.
When PBS directories are installed, the make file runs a program to validate
ownership and access to the files.  This can be rechecked at any time by 
running 
.Ty check-tree
in the top level make file.  check-tree is located in the directory give by the
value of bindir in configure.
Each daemon also validates the most critical files and directories each time
it is started.
.LP
A corrupted environment is another source of attach on a system.  To prevent
this type of attach, each daemon resets its own environment when it starts.
The source of the environment is a file named by PBS_ENVIRON set by the
configure option --set-environ.
If it does not already exists, this file is created during the install
process.  It should be edited to include the minimum set of variables required
on your system.
Please note that one variable, 
.B PATH
must be included.  The value of PATH in pbs_mom's environment, from this
file, will be passed on to batch jobs.
To maintain security, it is important that $PATH be restricted to known, safe
directories.  Do not include "." in PATH.
Another variable which can be dangerous and should not be set is IFS.
.LP
The syntax of the PBS_ENVIRON file is either
.Cs
.Ty "variable_name=value"
.Ce
or
.Cs
.Ty "variable_name"
.Ce
In the later case, the value for the variable is obtained from the daemons
environment before it is reset.
.LP
Other variables for the job's environment may also be
obtained from MOM's environment, this list varies by system.  If you are
interested, see the list in the variable 
.I obtain_vnames
in the source code of src/resmom/*/mom_start.c.
.NH 3
.Tc "Host Authentication"
.LP
PBS uses a combination of a information to authenticate a host.
If a request is made from a client whose socket is bound to a privileged
port (less than 1024, which requires root privilege), PBS (right or wrong)
believes the IP (Internet Protocol) network layer as to whom the host is.
If the client request is from a non-privileged port, the name of the host
which is making a client request must be included in the credential included
with the request and it must match the IP network layer opinion as to the
host's identity.
.NH 3
.Tc "Host Authorization"
.LP
Access to the pbs_server from another system may be controlled by an access
control list (ACL).   See section 10.1.1 of the ERS for details.
.LP
Access to pbs_mom is controlled through a list of hosts specified
in their configuration files.   By default, only \*Qlocalhost\*U and the name
returned by gethostname(2) are allowed.  See the man pages pbs_mom(8B)
for more information on the configuration file.
.LP
Access to the pbs_sched is not limited other than it must be from a
privileged port.
.NH 3
.Tc User Authentication
.LP
\f2Is the user who he/she claims to be?\fP
.LP
The PBS server authenticates the user name included in a request with the
supplied PBS credential.  This credential is supplied by 
.B pbs_iff (1B),
see section 10.2 of the ERS.
.NH 3
.Tc "User Authorization"
.LP
\f2Is the user entitled to make the request of the server job under
that name?\fP
.LP
PBS as shipped assumes a consistent user name space within the set of systems
which make up a PBS cluster.  Thus if a job is submitted by
.I UserA@hostA ,
PBS will allow the job to be deleted or altered by 
.I UserA@hostB .
The routine
.I site_map_user ()
is called twice.  Once to map the name of the requester and again to map
the job owner to a name on the server's (local) system.
If the two mapping agree, the requester is considered the job owner.
See section 10.1.3 of the ERS.
This behavior may be changed by a site by altering the server routine
site_map_user() found in the file src/server/site_map_user.c,
see the Internal Design Spec.
.LP
\f2Is the user entitled to execute the job under that name?\fP
.LP
A user may supply a name under which the job is to executed on a certain
system.  If one is not supplied, the name of the job owner is chosen to be 
the execution name.  See the 
.I "-u user_list"
option of the 
.B qsub (1B)
command.  Authorization to execute the job under the chosen
name is granted under the following conditions:
.IP 1.
The job was submitted on the server's (local) host and the submitter's name
is the same as the selected execution name.
.IP 2.
The host from which the job was submitted are declared trusted by the 
execution host in the /etc/hosts.equiv file or the submitting host and
submitting user's name are listed in the execution users' .rhosts file.
The system supplied library function,
.I ruserok (),
is used to make these checks.
.LP
If the above are not satisfactory to a site, the routine
.I site_check_user_map ()
in the file src/server/site_check_u.c may be modified.  See the IDS for
more information.
.LP
In addition to the above checks, access to a PBS server and queues within that
server may be controlled by  access control lists.  See section 10.1.1 and
10.1.2 of the ERS for more information.
.NH 3
.Tc "Group Authorization"
.LP
PBS allows a user to submit jobs and specify under which group the job should
be executed.  The user specifies a 
.I "group_list"
attribute for the job which contains a list of 
.Ty groups@hosts
similar to the user list.  See the 
.At group_list
attribute under the -W option of qsub(1B).
The PBS Server will ensure that the user is a member of the specified group by 
.IP 1.
Checking if the group is the user's primary group in the password entry.
In this case the user's name does not have to appear in the group entry for his
primary group.
.IP 2.
Checking for the user's name in the specified group entry in /etc/group.
.LP
The job will be aborted if both checks fail.
The checks are skipped if the user does not supply a group list attribute.
In this case the user's primary group from the password file will be used.
.LP
When staging files in or out, PBS also uses the selected execution group
for the copy operation.  This provides normal Unix access security to the
files.   Since all group information is passed as a string of characters,
PBS cannot determine if a numeric string is intended to be a group name or
gid.
.LP
Therefore when a group list is specified by the user, PBS places one
requirement on the groups within a system.
Each and every group in which a user might execute a job MUST have a group
name and an entry in /etc/group.  If no group lists are ever used, PBS will
use the login group and will accept it even if the group is not listed in
/etc/group.  Note in this case, the 
.At egroup
attribute value is a numeric string representing the user's gid rather than
the group \*Qname\*U.
.NH 3
.Tc "Root Owned Jobs"
.LP
The server will reject any job which would execute under the UID of zero
unless the owner of the job, typically root this or some other system,
is listed in the server attribute
.At acl_roots .
.NH 2
.Tc "\f3Job Prologue/Epilogue Scripts\fP"
.LP
PBS provides the ability to run a site supplied script before and/or after
each job runs.  This provides the capability to perform initialization or
cleanup of resources, such as temporary directories or scratch files.
The scripts may also be used to write \*Qbanners\*U on the job's output files.
.LP
If a script is not present, MOM continues in a normal manner.
If present, the script is run with root privilege.
In order to be run, the script must adhere to the following rules:
.IP \(bu 3
The script must be in the \f2(pbs_home)\f5/mom_priv\f1 directory with the
name \f5prologue\fP for the script to be run before the job and the name
\f5epilogue\fP for the script to be run after the job.
.IP \(bu
The script must be owned by root.
.IP \(bu
The script must be readable and executable by root.
.IP \(bu
The script cannot be writable by anyone but root.
.LP
The script may be a shell script or an executable object file.
Typically, a shell script should start with a line of the form:
.Ty "#! interpreter" .
 See the rules under execve(2) or exec(2) on your system.
.NH 3
Prologue and Epilogue Arguments
.LP 
When invoked, the prologue is called with the following arguments:
.IP argv[1] 10
is the job id.
.IP argv[2]
is the user name under which the job executes.
.IP argv[3]
is the group name under which the job executes.
.LP
The epilogue is called with the above, plus:
.IP argv[4] 10
is the job name.
.IP argv[5]
is the session id. \(dg
.IP argv[6]
is the requested resource limits (list). \(dg
.IP argv[7]
is the list of resources used.
.IP argv[8]
is the name of the queue in which the job resides. \(dg
.IP argv[9]
is the account string, if one exists. \(dg
.FS \(dg
The PBS development group reserves the right in a future release to remove
certain of the arguments passed to the Epilogue which could be obtained with
in the script by calling qstat(1B) or pbs_statjob(3B).
.FE
.LP
For both the prologue and epilogue:
.IP envp 10
The environment passed to the script is null.
.IP cwd
The current working directory is the user's home directory.
.IP input 
When invoked, both scripts have standard input connected to a system
dependent file.  For all systems execute the SP, this is /dev/null.
For the SP, the file is the host file containing the list of nodes
assigned to the job.
.IP output
With one exception, the standard output and standard error of the scripts
are connected to the files which contain the standard output and error
of the job.  If a job is an interactive PBS job, the standard output and error
of the epilogue is pointed to /dev/null because the pseudo terminal connection
used was released by the system when the job terminated.
.NH 3
Prologue Epilogue Time Out
.LP
To prevent a bad script or error condition within the script from delaying
PBS, MOM places an alarm around the scripts execution.  This is currently
set to 30 seconds.  If the alarm sounds before the scripts has terminated,
MOM will kill the script.  The alarm value can be changed by changing the
define of 
.Sc PBS_PROLOG_TIME
within src/resmom/prolog.c.
.NH 3
Prologue Error Processing
.LP
Normally, the prologue script should exit with a zero exit status.
MOM will record in her log any case of a non-zero exit from a script.
Exit status values and their impact on the job are:
.IP -4
The script timed out (took too long).  The job will be requeued.
.IP -3
The wait(2) call waiting for the script to exit returned with an error.
The job will be requeued.
.IP -2
The input file to be passed to the script could not be opened.
The job will be requeued.
.IP -1
The script has a permission error, it is not owned by root and or is writable
by others than root.
The job will be requeued.
.IP 0
The script was successful.   The job will run.
.IP 1
The script returned an exit value of 1, the job will be aborted.
.IP >1
The script returned a value greater than one, the job will be requeued.
.LP
The above apply to normal batch jobs.
Note, interactive-batch jobs (-I option) cannot be requeued on a non-zero
status, the network connection back to qsub is lost and cannot be
re-established.  Interactive jobs will be aborted on any non-zero prologue
exit.

The administrator must exercise great caution in setting up the prologue to
prevent jobs from being flushed from the system.
.LP
Epilogue script exit values are logged, if non-zero, but have no impact on the
state of the job.
.NH 2
.Tc "\f3Use and Maintenance of Logs\fP"
.LP
The PBS system tends to produce lots of log file entries.
There are two types of logs, the event logs which record events within each
PBS daemon (pbs_server, pbs_mom, and pbs_sched) and the Server's accounting log.
.NH 3
The Daemon Logs
.LP
Each PBS daemon maintains an event log file.
The Server (pbs_server), Scheduler (pbs_sched), and MOM (pbs_mom)
default their logs to a file with the
current date as the name in the PBS_HOME/(daemon)_logs directory.  
This location can be overridden with the "-L pathname" option; pathname
must be an absolute path.
.LP
If the default log file name is used, no -L option, the log will be closed
and reopened with the current date daily.  This happens on the first message
after midnight.  If a path is given with the -L option, the automatic
close/reopen does not take place.   All daemons will close and reopen the
same named log file on receipt of SIGHUP.  The pid of the daemon is available
in its lock file in its home directory.
Thus it is possible to move the current log file to a new name and send
SIGHUP to restart the file:
.Cs
cd PBS_HOME/daemon_logs
mv current archive
kill -HUP `cat ../daemon_priv/daemon.lock`
.Ce
.LP
The amount of output in the logs depends on the selected events to log and
the presence of debug writes, turned on by compiling with -DDEBUG.
The server and MOM can be directed to record only messages pertaining
to certain event types.  The specified events are logically \*Qor-ed\*U.
Their decimal values are:
.IP 1
Error Events
.IP 2
Batch System/Server Events
.IP 4
Administration Events
.IP 8
Job Events
.IP 16
Job Resource Usage (hex value 0x10)
.IP 32
Security Violations (hex value 0x20)
.IP 64
Scheduler Calls (hex value 0x40)
.IP 128
Debug Messages (hex value 0x80)
.IP 256
Extra Debug Messages (hex value 0x100)
.LP
Everything turned on is of course 511.  127 is a good value to use.
The event logging mask is controlled differently for the server and MOM.
The server's mask is set via qmgr(1B) setting the 
.At log_events
attribute.   This can be done at any time.
MOM's mask may be set via her configuration file with a
.Ty $logevent
entry, see the -c option on pbs_mom.  To change her logging mask, edit
the configuration file and send MOM a SIGHUP signal.
.LP
The scheduler, being site written may have a different method of changing
its event logging mask, or it may not have the ability at all.
.NH 3
The Accounting Log
.LP
The PBS Server daemon maintains an accounting log.  The format of the log
is described in chapter 3 of the ERS.  The log name defaults to
.Ty (pbs_home)/server_priv/accounting/yyyymmdd
where yyyymmdd is the date.  The accounting may be placed elsewhere
by specifying the -A option on the pbs_server command line.
The option argument is the full (absolute) path name of the file to be used.
If a null string is given, for example
.Cs
pbs_server -A ""
.Ce
then the accounting log will not be opened and no accounting records will
be recorded.
.LP
If the default file is used, named for the date, the file will be closed
and a new one opened every day at midnight.
If the server receives a SIGHUP signal, it will close the accounting log
and reopen it.  This allows you to rename the old log and start recording
anew on an empty file.  For example, if the server was started on February 1,
it will be writing in the file 
.Ty 19960201 .
If the current date is February 9, then the following actions will cause
the current accounting file to be renamed
.Ty feb1 ,
the server to close 032 and starting writing 
.Ty 19960209 .
.Cs
mv 19960201 feb1
kill -HUP 1234     (the server's pid)
.Ce
.LP
.NH 2
.Tc \f3Problem Solving\fP
.LP
The following is a very incomplete list of possible problems and how to
solve them.
.NH 3
.Tc "Clients Unable to Contact Server"
.LP
If a client command, qstat, qmgr, ..., is unable to connect to a server
there are several possibilities to check.  If the error return is
15034, \*QNo server to connect to\*U, check (1) that there is indeed a 
server running and (2) that the default server information is set correctly.
The client commands will attempt to connect to the server specified on the
command line if given, or if not given, the server specified in the \*Qdefault
server file\*U specified when the commands where built and installed.
.LP
If the error return is 15007, \*QNo permission\*U, check for (2) as above.
Also check that the executable
.I pbs_iff
is located in the search path for the client and that it is setuid root.
Additionally, try running pbs_iff by typing:
.Cs
pbs_iff server_host 15000
.Ce
Where 
.Ty server_host
is the name of the host on which the server is running and 
.Ty 15000
is the port to which the server is listening (if built with a different
port number, use that number instead of 15000).  pbs_iff should print
out a string of garbage characters and exit with a status of 0.
The garbage is the encrypted credential which would be used by the command
to authenticate the client to the server.  If pbs_iff fails to print the
garbage and/or exits with a non-zero status, either the server is not running
or was built with a different encryption system than was pbs_iff.
.NH 3
.Tc "Non Delivery of Output"
.LP
If the output of a job cannot be delivered to the user, it is saved in
a special directory, (pbs_home)/undelivered, and mail is sent to the user.
The typical causes of non-delivery are (1) destination host is not trusted
and the user does not have a .rhost file, (2) An improper path was specified,
(3) a directory is not writable, and (4) the user's .cshrc on the
destination host generates output when executed.  This are explained fully in
the section \*QDelivery of Output Files\*U in the next chapter.
.NH 3
.Tc "Job Cannot be Executed"
.LP
If a user receives a mail message containing a job id and the line
\*QJob cannot be executed\*U,
the job was aborted by MOM when she tried to place it into execution.
The complete reason can be found in one of two places, MOM's log file or
the standard error file of the user's job.
.LP
If the second line of the message is \*QSee Administrator for help\*U,
then MOM aborted the job before the job's files were set up.   The reason will
be noted in MOM's log.  Typical reasons are a bad user/group account, 
checkpoint/restart file (Cray), or a system error.
.LP
If the second line of the message is \*QSee job standard error file\*U,
then MOM had created the job's file and additional messages were written to
standard error.  This is typically the result of a bad resource request.
.NH 3
.Tc "Running Jobs with No Active Processes"
.LP
On very rare occasions, PBS may be in a situation where a job is in the
Running state but has no active processes.  This should never happen as the
death of the job's shell should trigger Mom to notify the server that the job
exited and end of job processing should begin.  The fact that it happens
even rarely means there is a bug in PBS (\f2gasp! Oh the horror of it all.\fP).
.LP
If this situation is noted, PBS offers a way out.  Use the qsig command to 
send SIGNULL, signal 0, to the job.   If Mom notes there are not any processes
then she will force the job into the exiting state.
.NH 2
.Tc "\f3Communication with the User\fP"
.LP
Users tend to want to know what is happening to their job.  PBS provides a
special job attribute, 
.I comment ,
which is available to the operator, manager, or the scheduler program.  This
attribute can be set to a string to pass information to the job owner.  It
might be used to display information about why the job is not being run or why
a hold was placed on the job.  Users are able to see this attribute when it
is set by using the -f option of the qstat command.  A scheduler program can
set the comment attribute via the pbs_alterjob() API.  Operators and managers
may use the -W option of the qalter command, for example
.Cs
qalter -W comment="some text" job_id
.Ce
.OH 'PBS Administrator Guide''Advice'
.EH 'Advice''PBS Administrator Guide'
.NH 1
.Tc "\f3\s+2Advice for Users\s-2\fP"
.LP
The following sections provide information necessary to the general
user community concerning use of PBS.  Please make this information available.
.NH 2
.Tc "\f3Modification of User shell initialization files\fP"
.LP
A user's job may not run if the user's start-up files (.cshrc, .login, or
\&.profile) contain commands which
attempt to set terminal characteristics.
Any such activity should be skipped by placing
a test of the environment variable \f3PBS_ENVIRONMENT\fP
(or for NQS compatibility, \f3ENVIRONMENT\fP).
This can be done as shown in the following sample .login:
.Cs
...
setenv PRINTER printer_1
setenv MANPATH /usr/man:/usr/local/man:/usr/new/man
if ( ! $?PBS_ENVIRONMENT ) then
	do terminal stuff here
endif
.Ce
.LP
If the user's login shell is csh, the following message may appear in the
standard output of a job:
.Cs
Warning: no access to tty, thus no job control in this shell
.Ce
This message is produced by many csh versions when the shell determines 
that its input is not a terminal.  Short of modifying csh, there is no way
to eliminate the message.   Fortunately, it is just an informative message
and has no effect on the job.
.NH 2
.Tc "\f3Shell Invocation\fP"
.LP
When PBS starts a job, it invokes the user's login shell (unless the user
submitted the job with the -S option).  PBS passes the job script which is
a shell script to the login in one of two ways depending on how PBS was
installed.
.RS 4
.IP "Script as Standard Input" 5
The standard method for PBS (built with SHELL_INVOKE = 0), is to open the
script file as standard input for the shell.
This is equivalent to typing
.Ty "shell\ <\ script" .
This offers advantages and disadvantages:
.RS 4
.IP + 3
The user's script will always be directly processed by the user's login shell.  
.IP +
If the user specifies a non-standard shell (any old program) with the -S option,
the script can be read by that program as its input.
.IP -
If a command within the job script reads from standard input, it may read
lines from the script depending on how far ahead the shell has buffered
its input.  Any command line so read will not be executed by the shell.
A command that reads from standard input with out explicit redirection is 
generally unwise in a batch job.
.RE
.IP "Name of Script on Standard Input"
The alternative method (PBS built with SHELL_INVOKE = 1), is to pass the
name of the job script to the shell program.
This is equivalent to typing the script name as a command to an interactive
shell.  Since this is the only line passed to the script, standard input will
be empty to any commands.  This approach also offers both advantages and
disadvantages:
.RS 4
.IP + 3
Any command which reads from standard input without redirection will get an EOF.
.IP +
The shell syntax can vary from script to script, it does not have to match the
syntax for the user's login shell.   The first line of the script, even before
any #PBS directives, should be
.Ty #!/shell
where 
.Ty shell
is the full path to the shell of choice, /bin/sh, /bin/csh, ...
The login shell
will interpret the #! line and invoke that shell to process the script.
.IP -
An extra shell process is run to process the job script.
.IP -
If a non-standard shell is used via the -S option, it will not receive the
script, but its name, on its standard input.
.RE
.LP
The choice if shell invocation methods is left to the site.   It is recommended
that all PBS execution servers (pbs_mom) within that site be built to use
the same shell invocation method.
.RE
.LP
.NH 2
.Tc "\f3Job Exit Status\fP"
.LP
The exit status of a job is normally the exit status of the shell executing
the job script.  If a user is using 
.I csh
and has a
.I .login
file in the home directory, the exit status of csh becomes the exit status
of the last command in .logout.  This may impact the use of job dependencies
which depend on the job's exit status.  To preserve the job's status, the
user may either remove .logout or add the following two lines to it.  Add
as the first line:
.br
.Ty "\ \ \ \ set EXITVAL = $status"
.br
and as the last executable line:
.br
.Ty "\ \ \ \ exit $EXITVAL"
.NH 2
.Tc "\f3Delivery of Output Files\fP"
.LP
PBS uses a version of the 
.B rcp (1)
command,
.B pbs_rcp (1B)
to return output files to the user at a remote host after the user's job
terminates.
This version of rcp is based on the bsd 4.4 lite distribution rcp.  It is
provided because it, unlike some rcp implementation, always exits with a
non-zero exits status for any error.   Thus pbs_mom knows if the file was
not delivered.  Note that the secure copy program, scp, is also based on
this version of rcp and it is good about exit statuses.  
.LP
Using rcp,
the copy of output or staged files can fail for (at least) two reasons.
.IP 1.
If the user's .cshrc script outputs any characters to standard output,
e.g. contains an echo command, 
.B pbs_rcp
will fail.
See the section in this document entitled
.B "Modification of User shell initialization files" .
.IP 2.
The user must have permission to 
.I rsh
to the remote host.
Output is delivered to the remote destination host with the remote file owner's
name being the job owner's name (job submitter).  On the execution host, the
file is owned by the user's execution name which may be different.
For information, see the 
.Ty "-u user_list"
option on the
.B qsub (1)
command.
.IP
If the two names are identical, permission to rcp may be granted at the
system level by an entry in the destination host's 
.I /etc/host.equiv
file calling out the execution host.
.IP
If the owner name and the execution name are different or if the destination
host's /etc/hosts.equiv file does not contain an entry for the execution host,
the user must have an ".rhosts" file in her home directory of the system
to which the output files are being returned.  The .rhosts must contain
an entry for the system on which the job executed with the user name under
under which the job was executed.  It is wise to have two lines, one
with just the "base" host name and one with the full 
.I "host.domain_name" .
.LP
For delivery of output files on the local host, PBS uses the 
.B /bin/cp (1)
command.
Local and remote Delivery of output may fail for the following additional
reasons:
.IP 1.
A directory in the specified path does not exist.
.IP 2.
A directory in the specified path is not searchable by the user.
.IP 3.
The target directory is not writable by the user.
.LP
Additional information as to the cause of the delivery problem might be
determined from MOM's log file.  Each failure is logged.  The various
error codes are described in requests.c/sys_copy() in the IDS.
.LP
If PBS is built to use the \f2Secure Copy Program\fP, scp, then PBS will first
try to deliver output or stage-in/out files using scp.   If scp fails, PBS
will try again using rcp [assuming that scp might not exist on the remote
host].  If rcp also files, the above cycle will be repeated after a delay
in case the problem is caused by a temporary network problem.   All failures
are logged in Mom's log.
.NH 2
.Tc "\f3Stage in and Stage out problems\fP"
.LP
The same requirements and hints discussed above in regard to delivery of
output apply to staging files in and out.  It may also be useful to
note that the stage in and out option on qsub both take the form
.br
.Ty local_file@remote_host:remote_file
.br
regardless of the direction of transfer.
Thus for stage in, the direction of travel is
.nf
	local_file  <--  remote_host:remote_file
.fi
and for stage out, the direction of travel is
.nf
	local_file  -->  remote_host:remote_file
.fi
Also note that all relative paths are
relative to the user's home directory on the respective hosts.
PBS uses rcp or scp (or cp if the remote host is the local host) to perform the 
transfer.   Hence, a stage in is just a
.nf
	rcp -r remote_host:remote_file local_file
.fi
and a stage out is just
.nf
	rcp -r local_file remote_host:remote_file
.fi
.LP
As with rcp, the remote_file may be a directory name.  Also as
with rcp, the local_file specified in the stage in/out directive may
name a directory.
For stage in, if remote_file is a directory, then local file must also be
a directory.   For stage out, if local_file is a directory, then remote_file
must also be a directory.
.LP
If 
.I local_file
is directory on a stage out directive, the local_file
directory on the execution host, including all files and subdirectories,
will be copied.  At the end of the job, the directory, including all files
and subdirectories, will be deleted.   Users should be aware that this may
create a problem if multiple jobs are using the same directory.
.LP
Stage in presents another problem.   Assume the user wishes to stage in
the contents of a single file named
.I poo
and gives the following stage in directive:
.Cs
-W stagein=/tmp/bear@somehost:poo
.Ce
If /tmp/bear is an existing directory, the local file becomes /tmp/bear/poo.
When the job exits, PBS will determind that 
.I /tmp/bear
is a directory and append 
.I /poo 
to it.  Thus 
.I /tmp/bear/poo
will be deleted.
If however, the user wishes to stage in the contents of a directory named
.I cat
and gives the following stage in directive:
.Cs
-W stagein=/tmp/dog/newcat@somehost:cat
.Ce
where 
.I /tmp/dog
is an existing directory, then at job end, PBS will determine that
.I /tmp/dog/newcat
is a directory and append
.I /cat
and then fail on the attempt to delete
.I /tmp/dog/newcat/cat .
.LP
On stage in when remote_file is directory, the user should not specify a
new directory as local_name.  In the above case, the user should go with
.Cs
-W stagein=/tmp/dog@somehost:cat
.Ce
which will produce 
.I /tmp/dog/cat
which will match what PBS will try to delete at job's end.
.LP
Wildcards should not be used in either the local_file or the remote_file
name.  PBS does not expand the wildcard character on the local system.
If wildcards are used in the remote_file name, since rcp is launched by
rsh to the remote system, the expansion will occur.   However, at job end,
PBS will attempt to delete the file whose name actually contains the wildcard
character and fail to find it.  This will leave all the staged in files
in place (undeleted).
.NH 2
.Tc "\f3Dependent Jobs and Test Systems\fP"
.LP
If you have users running on a test batch system using an alternative port
number, -p option to pbs_server, problems may occur with job dependency if
the following requirements are not observed:
.IP 1.
For a test system,
the job identifier in a dependency specification must include at least the
first part of the host name.
.IP 2.
The colon in the port number specification must be escaped by a black slash.
This is true for both the server and current server sections.
.LP
For example:
.br
.Ty 123.test_host\e:17000
.br
.Ty 123.old_host@test_host\e:17000
.br
.Ty 123.test_host\e:17000@diff_test_host\e:18000
On a shell line, the back slash itself must be escaped from the shell, so the
above become:
.br
.Ty 123.test_host\e\e:17000
.br
.Ty 123.old_host@test_host\e\e:17000
.br
.Ty 123.test_host\e\e:17000@diff_test_host\e\e:18000
.LP
These rules are not documented on the qsub/qalter man pages since the likely
hood of the general user community finding themselves seting up dependencies
with jobs on a test system is small and the inclusion would be generally
confusing.
