.nr % 1
.OH ''PBS ERS'Appendix A'
.EH 'Appendix A'PBS ERS''
.P1
.so ers_setup.ms
.Rv $Revision: 2.0 $
.SH 1
Appendix A - Scheduler Language Syntax
.OF 'Chapt \*(rV''B-%'
.EF 'A-%''Chapt \*(rV'
.LP
.\" This program is confidential and proprietary to MRJ Technology Solutions
.\" and may not be reproduced, published or disclosed to others without
.\" written authorization from MRJ.
.\" 
.\" Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.
.\" 
.\" This program is derived from prior work some of which was originally
.\" written as a joint project between the Numerical Aerospace Simulation
.\" (NAS) Systems Division of NASA Ames Research Center and the National
.\" Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
.\" National Laboratory.
.QP
Due to problems with the current implementation of the BASL Scheduler, it
is recommended that it not be used.  Instead used either the Tcl or C
based schedulers.
.QP
The following information is retained for information only.
.LP
The following is the syntax definition for the Batch Scheduler Language 
(BASL) used by the PL (procedural language) job scheduler program, see section 8.
.sp 2
.nf
.Ty
declaration_list::=   declaration
                    | declaration declaration_list

declaration::=   source type identifier ';' 
               | source type identifier '=' constant ';' 
               | source type identifier identifier ';'   
               | source type identifier identifier '=' constant ';' 
               | monitor

type::=    "resource"
        |  "attribute"
        |  "requirement"
        |  "variable"

source::=     "job"
            | "queue"
            | "host"
            | "global"

identifier::=   ALPHASTRING               
            | identifier ':' ALPHASTRING 

monitor::=      "rm" NUMBER ALPHASTRING

program::=   compound_statement
          |  program compound_statement

compound_statement::=  '{' statement_list '}'
                    | iteration

statement_list::=   statement                       
                  | statement statement_list        

statement::=   compound_statement
              | expression';'
              | if_clause

if_clause::=     "if" '(' value ')' statement
             |   "if" '(' value ')' statement "else" statement 

expression::=   assignment
              | action
              | "break"
              | "exit"
              | "continue"

action::= "run"
        | "run JOBID"
        | "run at HOSTID"
        | "run JOBID at HOSTID"
        | "run THISJ"      
        | "run" lvalue     
        | "delete"
        | "delete JOBID"     
        | "delete THISJ"
        | "delete" lvalue     
        | "delete" lvalue lvalue   
        | "delete JOBID" lvalue     
        | "delete THISJ" lvalue     
        | "rmquery"                 

assignment::=   lvalue ASSIGNOP value   
              | lvalue POSTOP  

ASSIGNOP::= "=" 
          | "+="
          | "-="
          | "*="
          | "/="

POSTOP::= "++"
        | "--"

iteration::=   "foreach job"   statement
             | "foreach queue" statement
             | "foreach host"  statement 

value::=    lvalue
         |  constant
         |  value LOGICAL value  
         |  value ARITHOP value  
         |  value COMPARATOR value
         |  '!'  value 
         |  expression 
         | '(' value ')' 

LOGICAL::= "||"
         | "&&"

ARITHOP::= "+"
         | "-"
         | "*" 
         | "/"
         | "^"

COMPARATOR::= "<"
            | ">" 
            | "==" 
            | "<="
            | ">="
            | "!="

lvalue::=   identifier   

constant::= NUMBER   
          | NUMBER SUFFIX 
          | time 
          | DAY
          | "THISJOB"
          | "THISQUEUE" 
          | "THISHOST" 
          | "JID" 
          | "QID"
          | "HID"
          | '"' identifier '"' 

DAY::=      mon 
          | tue 
          | wed
          | thu 
          | fri
          | sat
          | sun 
          | Mon
          | Tue
          | Wed 
          | Thu
          | Fri
          | Sat
          | Sun           


time::=     datecon   
          | intercon   
          | timecon    

datecon::=  NUMBER ',' NUMBER ',' NUMBER   

intercon::= INTERVAL              
          | intercon INTERVAL  
          
timecon::=  NUMBER ':' NUMBER ':' NUMBER   

SUFFIX::= "kw"
        | "Kw"
        | "KW"
        | "kb" 
        | "Kb"
        | "KB" 
        | "mw" 
        | "Mw" 
        | "MW" 
        | "mb" 
        | "Mb" 
        | "MB" 
        | "gw" 
        | "Gw" 
        | "GW"
        | "gb" 
        | "Gb" 
        | "GB"
.fi
.ft 1

