.\" This program is confidential and proprietary to MRJ Technology Solutions
.\" and may not be reproduced, published or disclosed to others without
.\" written authorization from MRJ.
.\" 
.\" Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.
.\" 
.\" This program is derived from prior work some of which was originally
.\" written as a joint project between the Numerical Aerospace Simulation
.\" (NAS) Systems Division of NASA Ames Research Center and the National
.\" Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
.\" National Laboratory.
.IP Account 15
is an arbitrary character string which may have meaning to
one or more hosts in the batch system.  Frequently, account
is used as a grouping for charging for the use of resources.
.IP Administrator 15
See Manager.
.IP Attribute 15
is an inherent characteristic of the parent object.  Typically, this is a
data item whose value affects the operation or behavior of the object and
is settable by owner of the object.  For example, the user may supply values
for attributes of a job.
.IP Batch 15
or batch processing, is the capability of running
.I jobs
outside of the interactive login session.  
In this document, batch implies a more complex subsystem
which provides for additional control over job scheduling and
resource contention.
.IP "Batch Server" 15
is a persistent subsystem (daemon) upon a single host which provides batch
processing capability.
.IP "Batch System" 15
is a set of batch servers that are configured
for processing.  The system may consist of multiple hosts, each with
multiple servers.
.IP Cluster
is a set of execution \*Qservers\*U or hosts on which a single batch server
manages batch jobs.  A cluster may be made up of a set of workstations,
multiple cpu systems, or one or more parallel systems.  Each allocatable
unit is a node, see Node.
.IP Complex 15
or queue complex in NQS was a set of queues within a batch server.
The purpose of a complex was to provide additional control over resource usage.
The advanced scheduling features of PBS eliminates the requirement for
complexes.
.IP Destination 15
is the location within the batch system where the job is
sent for processing or executing.  IN PBS, a destination may uniquely
define a single
queue at a single batch server or it may map into many locations.
.IP "Destination Identifier " 15
is a string which names the destination.  It is in two parts and has the
format
.DS C
queue@server
.DE
where server is the name of a batch server and queue is the string identifying
a queue on that server.
.IP "File Staging" 15
is the movement of files between a specified location and the execution
host.
See "Stage In" and "Stage Out" .
.IP Group 15
is a collection of system users (see Users).
A user must be a member of a group and may be a member of more than one.
Within Unix and POSIX systems, membership in a group establishes one
level of privilege.  Group membership is also often used to control or
limit access to system resources.
.IP Hold 15
is an artificial restriction which prevents a job from being selected for
processing.  There are three types of holds,
.Av User
which is applied by the job owner,
.Av Other
(or operator) which is applied by the batch operator or administrator, and
.Av System
which is applied by the system itself or the batch system administrator.
.IP Job 15
or 
.I "batch job"
is the basic execution object managed by the batch subsystem.  A job is a
collection of related processes which is managed as a whole.  A job can
often be thought of as a shell script.
In POSIX terms, a job is a session group.  A session is a  processes group
the member processes cannot leave.
.IP Manager 15
or Batch System Manager is a person authorized to use all restricted
capabilities of the batch system.  The manager may act upon the
the batch system, queues, or jobs.  Also called the administrator.
.IP Node 15
Within PBS, the term Node is used to mean a computional unit, one or more of
which can be allocated to a job in a shared or exclusive manner.  A node is
characterized by (a) a unique memory address space, (b) and operating system
image, (c) an IP address, and (d) a PBS execution server (pbs_mom).
If a set of nodes is allocated in an 
.I exclusive
manner to a job, no other job may use that set of nodes during the execution
of the job to which the nodes are assigned.   This is often called 
.I "Space Sharing"
If a set of nodes is allocated in a
.I shared
manner, multiple jobs may have processes executing on the set at the same
time; often called 
.I "Time Sharing" .
.IP Operator 15
or Batch Operator is a person authorized to use some but not all of the
restricted capabilities of the batch system.
.IP Owner 15
of a job is the user who submitted the job to the batch system.
.IP PBS 15
is short for
.I "Portable Batch System" .
.IP POSIX 15
refers to the various standards being developed by the "Technical
Committee on Operating Systems and Application Environments of the IEEE
Computer Society" under standard  P1003.  There are a number of
subcommittees under POSIX, those of interest to this project are:
.RS 15
.IP POSIX.1 10
System Application Program Interface (the system calls).
.IP POSIX.2 10
The command shell language.
.IP POSIX.3 10
Test Methods
.IP POSIX.10 10
Super Computing Profile
.IP POSIX.12 10
Protocol Independent Interfaces (one of the many network working groups)
.IP POSIX.14 10
Multiprocessor Working Group
.IP POSIX.15 10
Batch Queuing Extensions.  This standard has been approved as 1003.2d.
.RE
.IP Queue 15
is a collection of jobs (or job related tasks) within the
batch queuing system.
Each queue has a set of associated attributes which
determine what actions are performed upon each job  within the queue. 
Typical attributes include queue name, queue priority, resource limits,
destination(s) and job count limits.
Selection/scheduling of jobs is implementation defined.  The use of the
term "queue" does not imply the ordering is "first in, first out."
.IP Rerunable
If a batch job can be terminated and its execution restarted from the
beginning without harmful side effects, then the job is said to be rerunable.
.IP "Stage In" 15
is to move a file or files to the host prior to the batch job beginning
execution.
.IP "Stage Out" 15
is to move a file or files off of the host after the batch job completes
execution.
.IP User 15
is a user of the compute system.  Each user is identified by a unique
character string, the user name; and by a unique number, the user id.
.IP "User ID" 15
is a numeric identifier uniquely assigned to each user.
Privilege to access system resources and services is typically established
by the user id.
