.\" This program is confidential and proprietary to MRJ Technology Solutions
.\" and may not be reproduced, published or disclosed to others without
.\" written authorization from MRJ.
.\" 
.\" Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.
.\" 
.\" This program is derived from prior work some of which was originally
.\" written as a joint project between the Numerical Aerospace Simulation
.\" (NAS) Systems Division of NASA Ames Research Center and the National
.\" Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
.\" National Laboratory.
.\" include special ERS/IDS style macro definitions
.\" The following macros are style for object names and values.
.de Ar		\" command/function arguments and operands (italic)
.ft 2
.if \\n(.$>0 \&\\$1\fP\\$2
..
.de Av		\" data item values  (Helv)
.ft 6
.ps -1
.if \\n(.$>0 \&\\$1\s+1\fP\\$2
..
.de At		\" attribute and data item names (Helv Bold)
.ft 6
.ps -1
.if \\n(.$>0 \&\\$1\s+1\fP\\$2
..
.de Ty		\" Type-ins and examples (typewritter)
.ft 5
.if \\n(.$>0 \&\\$1\fP\\$2
..
.de Er		\" Error values ( [Helv] )
\&\f6\s-1[\^\\$1\^]\s+1\fP\\$2
..
.de Sc		\" Symbolic constants ( {Helv} )
\&\f6\s-2{\^\\$1\^}\s+2\fP\\$2
..
.de Al		\" Attribute list item, like .IP but set font and size
.IP "\&\f6\s-1\\$1\s+1\fP"
..
.\" following macro cuts the date provided by RCS so only yy/mm/dd shows
.de Cd
\&\\$2
..
.de Rv
.ds rV Draft Revision: \\$2
..
.\" the following pair of macros are used to bracket sections of code
.de Cs
.ft 5
.nf
..
.de Ce
.sp
.fi
.ft 1
..
.\" the following macro is used to place a box around a function name
.\" at the start of the functions description, this highlights it.
.\" it will also create an index entry if number register is set to 1.
.de Fn
.sp
.B1
.sp
\&\\$1
.if \\nI=1 .tm \\$1 | \\n(H1-\\n(PN
.sp
.B2
.sp
..
.\" the following macro is used to create a TOC (I=2) or index (I=1) entry 
.\" for a module (file) name
.de Fi
File: \\$1
.if \\nI=1 .tm \\$1 | \\n(H1-\\n(PN
.if \\nI=2 \{\
.	tm .XA \\n(H1-\\n(PN
.	tm \\*(SN \\$1
.\}
..
.\" macro to use in generating TOC section, parameter is printed and output
.\" if number register I = 2, output in XA format for PS PE macros
.de Tc
\&\\$1 \\$2 \\$3 \\$4 \\$5
.if \\nI=2 \{\
.	tm .XA \\n(H1-\\n(PN
.	tm \\*(SN \\$1 \\$2 \\$3 \\$4 \\$5
.\}
..
.\" macro to use in generating Index entries
.de Ix
\&\\$1
.if \\nI=1 .tm \\$1 | \\n(H1-\\n(PN
..
.\" End of macros 
