\" following macro cuts the date provided by RCS so only yy/mm/dd shows
.de Cd
\&\\$2
..
.sp 3
.in +0.7i
.sp 0.22i
.vs 11
.ps +22
P
.br
\h'11p'B\ \ 
.ps -4
\v'-4p'Portable Batch System\v'4p'
.br
.ps +4
\h'21p'S
.br
.ps -22
.vs 12
\l'4.9i'
.br
.in -0.8i
.sp 3
.TL
Project Plan
.AU
Albeaus Bayucan \(dg
.FS \(dg
MRJ Technology Solutions, NASA Contract NAS2-14303, Moffett Field, CA
.FE
Robert L. Henderson \(dg
Tom Proett \(dg
Dave Tweten
.AI
Numerical Aerospace Simulation Systems Division
NASA Ames Research Center
.sp
.so ../ers/release.ms
.br
Printed: \*(DY
.LP

.ds CH PBS Project Plan
.bp
.LP
.DS C
Portable Batch System, Rights to Use and Redistribute
.DE
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
.LP
.ds LF $Revision: 2.0 $
.ds CF -%-
.SH
PBS Revision History
.LP
.IP "" 15
June 18, 1993 \(em Initial approval of Project Plan
.so ../ers/rel_history.ms
.sp
.SH
Acknowledgements
.LP
Special acknowledgements are extended to the following groups for
their contributions to this project plan:
.sp
.DS
Lawrence Livermore National Laboratory - LCC
Lawrence Livermore National Laboratory - NERSC
.DE
.bp
.NH 1
INTRODUCTION
.LP
This document is part of a sequence (as explained in Section 3) which
covers all aspects of the NAS Systems Division development of the software
package \*QPortable Batch System\*U or
.B PBS .
PBS is an extension to a POSIX\**
.FS
IEEE Standard 1003,
.I
Information technology \(em portable operating system interface.
.R
.FE
or Unix operating system which provides the capability to submit and control
jobs in a batch environment, independent of the interactive environment.
This particular document in the series tells how the project will
progress over its lifetime.
As the project progresses,
various parts of this document will be plan, and others will be history.
.LP
The aspects of the project covered are the release plan, the document
plan, the development plan and the manpower plan.
There is no equipment acquisition plan because the PBS project involves
only software.
The release plan covers the versions of PBS planned over its lifetime,
and the purposes of each.
The document plan details what documents come into existance during the
project, when and how.
For each software release, the software development plan shows how the
required development was done or is planned to be done.
Finally, the manpower plan shows how the project's staffing level has
varied or is planned to vary over time.

.NH 1
RELEASE PLAN
.LP
PBS releases are designated by three integers,
separated by decimal points.  The first integer gives the number of
complete re-implementations, and builds from one.  The second integer
gives the number of feature releases since the last re-implementation;
it starts with zero.  The last digit gives the number of \*Qbug fix\*U
releases since the last feature release; it too starts with zero.
.NH 2
Release 1.0
.LP
This is the initial version of PBS.
Its purpose is to create a usefully functioning version which can serve
as a test platform and as a development base.
The first version of PBS runs in isolation from NQS and with no
distributed cluster computing features except job synchronization.
Compared to NQS, the major new features of PBS release 1.0 are:
.IP \(bu
POSIX 1003.2d compliant with extensions.
.IP \(bu
Three levels of commands: user, operator and administrator.
.IP \(bu
Application programming interface.
.IP \(bu
PBS server to PBS server job routing.
.IP \(bu
File staging, both before and after job execution.
.IP \(bu
Job tracking.
.IP \(bu
Client-only installation supported.
.IP \(bu
Configurable, replaceable job scheduler.
.IP \(bu
Much more flexable, expandable protocol.
.IP \(bu
Runs on Silicon Graphics and Sun Sparc workstations.
.NH 2
Release 1.0.1
.LP
This is a bug fix release.
.NH 2
Release 1.0.2
.LP
This PBS Release is a porting release.
This release intruduces complete support for the Thinking Machines
CM-5 and Silicon Graphics Power Servers, and partial support for the
Intel Paragon.
.NH 2
Release 1.0.3
.LP
This PBS Release is a porting release.
This release introduces complete support for the IBM SP-2 and for the
IBM RS-6000 workstation.
With this release, the PBS Beta Program begins.
.NH 2
Release 1.0.4
.LP
This is mostly a bug fix release.
It also includes some minor features requested by the NAS IBM SP-2 support
group, and a new document, the Administrator Guide.
.NH 2
Release 1.1
.LP
This PBS Release is a porting release.
Its goal is to make PBS work on the remaining machines neglected in
the original 1.0 release.
The only new feature of release 1.1 is support for Cray Unicos on the
C-90.
.NH 2
Release 1.1.1
.LP
This release serves two purposes.
It is a bug fix release; it also provides early availability for the
``interactive batch'' feature of release 1.2.
.NH 2
Release 1.1.2
.LP
This release serves two purposes.
It is a bug fix release.
It provides early availability for the prolog/epilog feature of
release 1.2.
.NH 2
Release 1.1.3
.LP
This release serves three purposes.
It is a bug fix release.
It moves batch accounting records into their own file and adds information.
Finally, it introduces an interim kludge to enable SP-2 style node
management on clusters.
Release 1.2 distributed jobs makes the kludge unnecessary, and it is
removed then.
.NH 2
Release 1.1.4
.LP
This release serves several purposes.
It is a bug fix release.
It incorporates awareness of the Unicos UDB.
It imbelishes SP-2 style node management to include a resource
reservation system like the SRFS reservation system for Unicos.
Finally, it institutes on-line qmgr help.
.NH 2
Release 1.1.5
.LP
This release serves four purposes.
Its major purpose is to incorporate any changes required to permit PBS
to run in production operation on the NAS Cray C-90, Vonneumann.
It begins a two release sequence to convert from cryptographic user
authentication to a system that will not be subject to export controls.
It is also a bug fix release, and provides early availability for the
SunOS 5 port.
.NH 2
Release 1.1.6
.LP
This release serves five ends.
It is a bug fix release.
It makes it easier for sites to define their own additional resources.
It incorporates the first version of an intelligent router capability.
It completes a two release sequence to convert from cryptographic user
authentication to a system that will not be subject to export
controls.
Finally, it introduces ``Berkeley'' style non-license text in all
source files.
.NH 2
Release 1.1.7
.LP
This release serves two purposes.
It is a bug fix release.
It also includes some strongly requested features to help the scheduler
control job order-of-presentation in queue displays.
.NH 2
Release 1.1.8
.LP
This release serves three purposes.
It begins early availability of part of the ``distributed job''
feature of release 1.2 by merging MOM and the Resource Monitor.
It provides early availability of the Tcl/Tk graphical user interface
feature.
Finally, it provides early availability for the ``User Guide.''
.NH 2
Release 1.1.9
.LP
This release provides early availability of the second part of the
``distributed job'' feature of release 1.2 by updating the protocol
between MOM and the Server.
.NH 2
Release 1.1.10
.LP
This release provides early availability of the third part of the
``distributed job'' feature of release 1.2 by instituting a
one-MOM-per-node architecture for cluster support along with the prototype of
the task spawn and terminate interface.
.LP
A \*Qbeta\*U version of version two of the \f3BA\fPtch \f3S\fPcheduling
\f3L\fPanguage  (BASL-2)will also be available.
This feature provides a pre-compiler that produces C code and a set of
helper functions to simplify scheduler development.
.LP
The new protocol is extended by use between the commands and the server.
The old ASN.1 protocol is still accepted.
.NH 2
Release 1.1.11
.LP
This release provides early availability of the additional parts of the
``distributed job'' feature of release 2.0 by including the marjority
applications programming interface to support remote session start,
communication establishment, and signaling; the Task Manager API.
.LP
The full version of BASL-2 will be available.
.NH 2
Release 1.1.12
.LP
This release provides the remaining parts of the ``distributed job'' feature
of release 2.0 as defined in the PSCHED draft.   In addition, resource 
management of nodes is moved from a single Mom to the PBS Job Server.  This
allows for
.I sharing
of nodes between jobs as well as exclusive use of nodes by jobs.
The PSCHED resource managment calls for the portable scheduler are also 
implemented.
.NH 2
Release 2.0
.LP
Though some ports are included in this release, it mostly marks a
return to major platform-independent feature improvements.
The major release includes feature available \*Qearly\*U in the minor
1.1.x releases.  The system is completely retested and validated and all
documentation is reviewed for completeness.
The major new features of release 1.2 are:
.IP \(bu
PBS is ported to Cray T3D and T3E Unicos.
.IP \(bu
In addition to the job synchronization facilities first provided in
release 1.0, the distributed job abstraction is supported.
This feature consists of two parts.
One is the ability to map job-relative node numbers to assigned node addresses
for the benefit of parallel communication packages such as MPI.
The other is support for remote process start.
.IP \(bu
A Deja Gnu based automatic regression test set begins to be used
during release preparation.
.IP \(bu
X-Windows interfaces are provided for user, operator and administrator
commands.
.IP \(bu
So called ``interactive batch'' is supported.
Users can take advantage of the scheduling and resource scheduling
features of a batch system, but retain the debugging advantages of
interactive use.
.IP \(bu
PBS administrator defined prolog and epilog processes are run
immediately before and immediately after each batch job to permit
site-dependent setup and tear down.
.IP \(bu
PBS is ported to SunOS 5 (a.k.a. Solaris).
.IP \(bu
All references to and use of the ASN.1 prototcol and ISODE is removed.

.NH 1
DOCUMENT PLAN
.LP
The PBS project will produce and maintain six documents over its
lifetime.
This
.I "PBS Project Plan"
is one.
The others are the ERS (\c
.I "PBS External Reference Specification" ),
the IDS (\c
.I "PBS Internal Design Specification" ),
the Test Plan (\c
.I "PBS Formal Test Plan" ),
the Administrator Guide (\c
.I "PBS Administrator Guide" ),
and the User Guide (\c
.I "PBS User Guide" ).
.NH 2
The Project Plan
.LP
This document is the
.I "PBS Project Plan" .
Its purpose is to provide an overall road map of what is to be done,
when and by whom.  It is to be maintained throughout the life of the
project.  Sections are to be added and revised as required to reflect the
initial intent and subsequent progress of the project through all its
releases.
.NH 2
The External Reference Specification
.LP
The ERS is the overall design document.  It is written and revised by
the designers of PBS.  It itemizes the goals to be achieved by the
design and describes generally how they are to be met.  It also
specifies all user interfaces.  The ERS will be revised as work on each
release begins, to reflect the features to be incorporated into the
release.  As work on a release continues, changes are made so that
by release, the edition of the ERS then available reflects the release
as built.
.NH 2
The Internal Design Specification
.LP
The IDS is written by the implementors of PBS.  It serves two purposes. 
When initially written, and when initially revised as part of a new
release, it is an aid to the project members in coordinating their
development.  At release, the IDS becomes the software maintenance
manual for the system analyst responsible for the release's continued
health.  Ideally, once the IDS is initially complete for a release, all
the implementers could disappear, and the release could be completed
and maintained, making reference only to the ERS, the IDS and the code.
.LP
The IDS contains all interface specifications not already covered in
the ERS, and contains explanations of each major module which has been
written or modified.  These explanations cover each module's inputs,
outputs, purpose and method.  Discussions on technical issues which
lead to non-obvious design decisions must also be included.
.NH 2
The Test Plan
.LP
The Test Plan is written and maintained by the author of the formal
test set used to test PBS.
It specifies what kinds tests are to be conducted by the PBS
developers prior to formal testing.
It describes the set of formal tests to be used and the methods used
to run them.
.NH 2
The Administrator Guide
.LP
The
.I "PBS Administrator Guide"
contains detailed directions for completing the initial build of PBS.
It also gives advice on PBS configuration, maintenance, and
troubleshooting.
It is written and maintained by the developers of PBS.
.NH 2
The User Guide
.LP
The
.I "PBS User Guide"
provides a tutorial overview of PBS from a user's perspective.
It is intended to be written in an informal style, and to be available
both in printable and Hypertext Markup Language (HTML) form.
It is written and maintained cooperatively by the PBS developers and
by the support staff of early production sites.

.NH 1
SOFTWARE DEVELOPMENT PLAN
.LP
Each subsection after the common milestone definitions gives a chart of
milestones, the individual responsible for each milestone and initial,
currently planned and final dates for each feature release of PBS.
The initial dates are frozen on the actual date of the last milestone
of the previous release.
The latest dates are updated as the release is developed.
The latest dates are replaced by actual dates as milestones are met.
.NH 2
Definition of Common Milestones
.LP
It is important to form a common understanding of the meaning
of each milestone so all can agree when it is achieved.  Milestones
unique to a single chart are defined in the subsection contining the
chart.  A few milestones appear in all charts; they are defined below.
.NH 3
ERS Complete/Updated
.LP
This milestone is achieved when a full ERS document has been printed and
reviewed by the project membership, and its updated descriptions
accurately reflect the changed content of the associated feature
release.  In particular, all new or changed
.B man
pages and all general descriptions of function must be included and must
be correct.
This milestone
.I "does not"
constitute a point at which ERS content is frozen; it continues to be
modified as the need becomes apparent while work on the release
progresses.
Upon the completion of this milestone, IDS modification should begin.
.NH 3
IDS Complete/Updated
.LP
This milestone is achieved when a full IDS document has been printed and
reviewed by the project membership, and its updated descriptions
accurately reflect the changed content of the associated feature
release.  In particular, all detailed algorithmic descriptions
(including pseudocode where necessary) and all new or changed header
files must be included, be correct and be consistant among themselves. 
Additionally, at this milestone, the ERS has been updated to reflect any
design changes made between the
.I "ERS Complete/Updated"
milestone and the IDS completion.
This milestone
.I "does not"
constitute a point at which IDS content is frozen; it continues to be
modified as the need becomes apparent while work on the release
progresses.
Upon the completion of this milestone, coding should begin.
In addition, modification of the
.I "PBS Formal Test Plan"
should begin.
.NH 3
Test Plan Complete/Updated
.LP
This milestone is achieved when a full
.I "PBS Formal Test Plan"
has been printed and reviewed by the project membership, and has been
approved.
This milestone
.I "does not"
constitute a point at which Test Plan content is frozen; it continues
to be modified as the need becomes apparent while work on the release
progresses.
.NH 3
Administrator Guide Complete/Updated
.LP
This milestone is achieved when a full
.I "PBS Administrator Guide"
has been printed and reviewed by the project membership, and has been
approved.
This milestone
.I "does not"
constitute a point at which Administrator Guide content is frozen; it
continues to be modified as the need becomes apparent while work on
the release progresses.
.NH 3
User Guide Complete/Updated
.LP
This milestone is achieved when a full
.I "PBS User Guide"
has been printed and reviewed by the project membership, and has been
approved.
This milestone
.I "does not"
constitute a point at which User Guide content is frozen; it
continues to be modified as the need becomes apparent while work on
the release progresses.
.NH 3
No Known Bugs
.LP
This milestone is achieved when coding is complete, integration is
complete and all basic functions have been tested and found to work.
It is assumed that continued testing associated with feature changes,
with formal testing, and with other related activities will result in
the discovery of other serious bugs which need to be fixed before
release.
The essence of this milestone is the
.I "initial"
achievement of full function.
Upon the completion of this milestone, trial preparation and testing of
release tar files should begin.
.NH 3
Release
.LP
This milestone is achieved when a release tar file has been created,
made available, and been announced to release customers along with
current copies of the all documents.
The tar file contains all source code for the release, all documentation in
the form of
.B guides ,
.B man
pages,
.B README
files which are sufficient to show a system administrator how to build
the release.
Before release, all project documents must be reviewed by the project
and revised, as necessary, to reflect the state of the release.
.KF
.DS L
.TS
box center tab(;) ;
l r||ce se se
l r||ce se se
l r||ce se|ce
l r||ce se|ce
l r||ce|ce|ce
l r||re|re|re .
;;Completion Dates;;
;;_
;;Estimated
;;_
Activities;;Initial;Latest;Actual
_;_;_;_;_
ERS Complete;RH;12-2-92;;12-2-92
Work Assigned;RH;11-2-92;;11-2-92
ASN Tool Select;all;11-16-92;;11-16-92
ISODE on Cray;all;1-1-93;;1-1-93
Server-Net I/F IDS;RH;1-18-93;;2-19-93
Server-Net I/F Code;RH;2-22-93;;2-22-93
Command Lib IDS;BK;6-15-93;;6-1-94
Command Lib Code;KC;6-1-93;;9-21-93
Admin Cmds IDS;BK;2-8-93;;9-21-93
Admin Cmds Code;BK;5-15-93;;10-26-93
User Cmds IDS;BK;3-1-93;;1-4-94
User Cmds Code;BK;5-15-93;;12-21-93
Operator Cmds IDS;BK;6-1-93;;9-21-93
Operator Cmds Code;BK;7-1-93;;9-28-93
Server-Resource IDS;TP;5-1-93;;12-15-93
Server-Resource Code;TP;7-1-93;;12-3-93
Server-Job Select IDS;CS;6-1-93;;9-29-93
Server-Job Select Code;CS;7-1-93;;1-4-94
Server-Initialize IDS;RH;1-12-93;;3-1-93
Server-Initialize Code;RH;2-16-93;;3-15-93
Server-Batch Reqs IDS;RH;4-1-93;;7-23-93
Server-Batch Reqs Code;RH/TP;5-1-93;;1-31-94
Server-MOM IDS;RH/DT;2-9-93;;9-7-93
Server-MOM Code;RH;5-1-93;;6-8-94
Server-Route Job IDS;RH;6-15-93;;12-7-93
Server-Route Job Code;RH;7-1-93;;1-11-94
Schedule Script Code;DT;2-8-94;;4-18-94
Test Plan Complete;RH/DT;9-7-93;;6-15-94
No Known Bugs;all;11-1-93;;6-15-94
Release to NASA/LLNL;all;6-1-94;;6-15-94
.TE
.DE
.DS C
Figure 1: Release 1.0 Milestones
.DE
.KE
.NH 2
Release 1.0
.LP
Instead of the general milestone, \*QIDS Complete/Updated\*U,
Figure\ 1 contains several entries of the form \*Qtask IDS\*U.
In addition to the general milestone, \*QNo Known Bugs\*U, Figure\ 1
contains several entries of the form \*Qtask Code\*U.
Each specific milestone means the same thing as the corresponding
general milestone, but for a specific task.
Descriptions of the specific tasks appear in the following paragraphs.
.NH 3
ASN Tool Select
.LP
The network protocol used by PBS is specified in the ISO ASN.1 language.
The task chooses which of the available protocol compilers should be
used for PBS.
.NH 3
ISODE on Cray
.LP
The ASN.1 compiler to be used for PBS is called ISODE (ISO Development
Environment).  It is a freely available product.  This task ports it to
the Cray C-90.
.NH 3
Server-Net I/F
.LP
This task completes the server network protocol state machine.
It is covered in ERS sections 3.1 and 3.2, and in IDS
sections 10.5.
.NH 3
Command Lib
.LP
This task completes the PBS Interface Library (IFL).
It is covered in ERS sections 3, 4, and 11, and in IDS section 10.6.
.NH 3
Admin Cmds
.LP
This task builds upon the PBS IFL to create the PBS Administrator
configuration command, qmgr.
It is covered in ERS section 7, and in IDS section 4.
.NH 3
User Cmds
.LP
This task builds upon the PBS IFL to create the PBS user commands.
It is covered in ERS section 5, and in IDS section 2.
.NH 3
Operator Cmds
.LP
This task builds upon the PBS IFL to create the PBS operator commands.
It is covered in ERS section 6, and in IDS section 3.
.NH 3
Server-Resource
.LP
This task completes the machine independent portion and one machine
dependent portion of the resource monitor.
It is covered in ERS section 3.4, and in IDS section 7.
.NH 3
Server-Job Select
.LP
This task completes the machine independent portion and one machine
dependent portion of the job scheduler.
It is covered in ERS section 8 and appendix B, and in IDS section 6.
.NH 3
Server-Initialize
.LP
This task completes the portion of the PBS server which initializes its
data structures.
It is covered in IDS section 5.3.4.
.NH 3
Server-Batch Reqs
.LP
This task completes the portion of the PBS server which processes
individual PBS requests received from the network.
It is covered in ERS section 3.1, and in IDS section 5.3.10.
.NH 3
Server-MOM
.LP
This task completes the machine independent portion and one machine
dependent portion of the
Machine-Oriented Miniserver, also previously called the shepherd job.
It is covered in ERS section 3, and in IDS section 8.
.NH 3
Server-Route Job
.LP
This task completes the code for the job router, a subprocess of the
server which moves jobs between servers.
It is covered in ERS sections 3.3.4, and in IDS section 5.3.12.
.NH 3
Scheduling Scripts
.LP
This task completes demonstration scheduling scripts for the Cray C-90,
and CM-5.
They satisfy NAS scheduling goals for these machines.
Though the scheduler itself is covered in the IDS and in the ERS, there is no
such coverage for the scripts themselves.
.KF
.DS L
.TS
box center tab(;) ;
l r||ce se se
l r||ce se se
l r||ce se|ce
l r||ce se|ce
l r||ce|ce|ce
l r||re|re|re .
;;Completion Dates;;
;;_
;;Estimated
;;_
Activities;;Initial;Latest;Actual
_;_;_;_;_
ERS Updated;all;6-1-94;;7-19-94
IDS Updated;all;6-1-94;;11-22-94
Test Plan Updated;all;6-1-94;;3-15-95
C-90 Resource/MOM;BK/TP;10-5-93;;2-1-95
CM-5 MOM;TP;3-8-94;;9-12-94
CM-5 Resource;TP;9-23-93;;12-30-93
Intel Resource;TP;11-2-93;;2-15-94
SP-2 Resource/MOM;TP;9-6-94;;11-22-94
Tcl Scheduler;TP;10-21-94;;11-22-94
No Known Bugs;all;4-19-94;;1-15-95
Release to Beta;all;5-3-94;;3-15-95
.TE
.DE
.DS C
Figure 2: Release 1.1 Milestones
.DE
.KE
.NH 2
Release 1.1
.LP
In addition to the milestones in the general definitions, figure\ 2
shows several specific items for release 1.1.
Their explanations follow.
.NH 3
Tcl Scheduler
.LP
This task completes a set of Tcl support routines to permit Tcl to be
used as a scheduling language.
It is covered in ERS sections 7.2 and 8.4 and in IDS section 6.2.
.NH 3
SP-2 Resource/MOM
.LP
This task completes the machine dependent portion of the resource
monitor for the IBM SP-2.
It also completes the machine dependent portion of the
Machine-Oriented Miniserver (previously called the shepherd job) for
the IBM SP-2.
They should already be accomplished under \*QServer-Resource IDS\*U and
\*QServer-Shepherd IDS.\*U
It is covered in ERS section 9.1.6, and in IDS sections 7.3.12,
7.3.13, and 8.3.1.
.NH 3
C-90 Resource/MOM
.LP
This task completes the machine dependent portion of the resource
monitor for the Cray C-90.
It also completes the machine dependent portion of the
Machine-Oriented Miniserver (previously called the shepherd job) for
the Cray C-90.
They should already be accomplished under \*QServer-Resource IDS\*U and
\*QServer-Shepherd IDS.\*U
It is covered in ERS section 9.1.3, and in IDS sections 7.3.9, 7.3.10,
and 8.2.5.
.NH 3
CM-5 Resource
.LP
This task completes the machine dependent portion of the resource
monitor for the Thinking Machines CM-5.
That should already be accomplished under \*QServer-Resource IDS.\*U
It is covered in ERS section 9.1.5 and in IDS section 7.3.7.
.NH 3
CM-5 MOM
.LP
This task completes the machine dependent portion of the
Machine-Oriented Miniserver (previously called the shepherd job) for
the Thinking Machines CM-5.
That should already be accomplished under \*QServer-Shepherd IDS.\*U
It is covered in IDS sections 8.2.5.
.NH 3
Intel Resource
.LP
This task completes the machine dependent portion of the resource
monitor for the Intel Paragon.
That should already be accomplished under \*QServer-Resource IDS.\*U
It is covered in ERS section and 9.1.4 and in IDS section 7.3.8.
.KF
.DS L
.TS
box center tab(;) ;
l r||ce se se
l r||ce se se
l r||ce se|ce
l r||ce se|ce
l r||ce|ce|ce
l r||re|re|re .
;;Completion Dates;;
;;_
;;Estimated
;;_
Activities;;Initial;Latest;Actual
_;_;_;_;_
ERS Updated;all;1-10-97;10-25-96;10-25-96
IDS Updated;all;1-10-97;10-25-96;10-25-96
Test Plan Updated;AB;3-31-95;;12-18-95
User Guide Complete;DT;6-13-95;12-31-97;n/a
Administrator Guide Updated;RH;6-13-95;1-10-98;7-31-98
Interactive Batch;RH;2-28-95;;4-10-95
Job Prolog/Epilog;RH;4-11-95;;5-25-95
Cray T3D/T3E Resource/MOM;BK;6-13-95;;10-17-95
SunOS 5 Resource/MOM;TP;11-29-95;;11-29-95
Formal Tests;AB;11-1-95;;12-18-95
.8 Combine MOM and Resource;TP;5-23-95;7-12-96;7-12-96
.8 Graphical User Interface;AB;3-15-96;7-12-96;8-21-96
.9 Update Server to MOM;RH;8-9-96;10-25-96;12-25-96
.9 New Stage In API;RH;12-25-96;;12-25-96
.10 Mother Superior;TP;10-4-96;4-30-97;4-30-97
.10 New BASL (Beta);AB;4-30-97;;4-30-97
.11 PSCHED Cluster (Task) API;AB;10-11-96;10-29-97;12-22-97
.11 New BASL (final);AB;10-29-97;;12-22-97
.12 New Node Management;RH;7-9-98;7-15-98;7-15-98
2.0 Doc Review and Bugs;all;9-15-98;;
.TE
.DE
.DS C
Figure 3: Release 2.0 Milestones
.DE
.KE
.NH 2
Release 2.0
.LP
In addition to the milestones in the general definitions, figure\ 3
shows several specific items for release 2.0.
Their explanations follow.
.NH 3
Cray T3D Resource/MOM
.LP
This task completes the machine dependent portion of the resource
monitor for Cray Unicos on the T3D/T3E.
It also completes the machine dependent portion of the
Machine-Oriented Miniserver for Cray Unicos on the T3D/T3E.
.NH 3
Combine MOM and Resource
.LP
This task is the first step toward full ``distributed job'' support.
It merges MOM and the Resource Monitor.
Under distributed job conditions, there would have to be a MOM and a
Resource Monitor per node.
They would also have to communicate.
This makes the whole package smaller and more efficient.
.NH 3
Update Server to MOM
.LP
This task is the second step toward full ``distributed job'' support.
It updates Server to MOM communication so the server is prepared for
the next step.
.NH 3
New Stage In API
.LP
The addition of a new Stage In Files Now API entry allows the scheduler
to have control over when file staging starts for a job being considered
for execution.
.NH 3
Mother Superior
.LP
This task is the third step toward full ``distributed job'' support.
It supports parallel jobs with one MOM at each node, and a
distinguished MOM for each job (Mother Superior), that handles
relations with the Server.
A prototype implementation of a subset of the PSCHED task management API
is included.
.NH 3
Task Management (Cluster) API
.LP
This task is the fourth and final step to full ``distributed job'' support.
It incorporates into PBS the full implementation of the PSCHED task management
API.
A standard for this API is being addressed by an informal committee of
which NAS is a member.  The PBS development group is to guide the development
of the standard and produce a pliminary implementation.   
This API aids in starting a process
on another node of a cluster, and to map job-relative node numbers
into assigned node addresses for parallel communication packages like MPI.
.NH 3
Formal Tests
.LP
This task completes a set of automated formal tests, designed to be
run by Deja Gnu.
The tests will be used as a regression test suite.
.NH 3
Graphical User Interface
.LP
This task creates a unified Tcl/Tk-based graphical user interface (GUI) for
all the user commands.
.NH 3
Interactive Batch
.LP
This task implements the ability to qsub an "interactive" job.
.NH 3
Job Prolog/Epilog
.LP
This task creates the capability for a PBS administrator to cause one
process to be run immediately before each batch job, and to cause
another process to be run immediately after.
.NH 3
SunOS 5 Resource/MOM
.LP
This task completes the machine dependent portion of the resource
monitor for Solaris.
It also completes the machine dependent portion of the
Machine-Oriented Miniserver for Solaris.
.LP
.KF
.DS L
.TS
box center tab(;) ;
l r||ce se se
l r||ce se se
l r||ce se|ce
l r||ce se|ce
l r||ce|ce|ce
l r||re|re|re .
;;Completion Dates;;
;;_
;;Estimated
;;_
Activities;;Initial;Latest;Actual
_;_;_;_;_
ERS Updated;all;;9-15-98;
IDS Updated;all;;9-15-98;
Test Plan Updated;AB;9-15-98;
ASN.1 Removal;RH;8-6-98;9-7-98k;
Administrator Guide Updated;RH;8-15-98;9-7-98;
No Known Bugs;all;8-1-98;9-15-98;
Release;all;9-30-98;;
.TE
.DE
.DS C
Figure 4: Release 2.0 Milestones
.DE
.KE

.NH 1
MANPOWER PLAN
.LP
This section identifies the active PBS project members, past project
members, and outlines the sources and uses of project manpower over time.
.LP
The presumed lifetime of PBS is five years beyond the delivery of
the last feature release.
Maintenance staffing is required for that duration.
.KF
.DS L
.TS
box center tab(;) ;
l|c|l|c|c
l|c|l|r|n .
Name;Initials;Affiliation;Joined;Availability
_
Albeaus Bayucan;AB;NASA-MRJ;7-10-95;1.0
Robert L. Henderson;RH;NASA-MRJ;;1.0
Cas Lesiak;CL;NASA-MRJ;1997;1.0
Bhroam Mann;BM;NASA-MRJ;1997;1.0
Tom Proett;TP;NASA-MRJ;8-18-93;1.0
Dave Tweten;DT;NASA;;0
.TE
.DE
.DS C
Figure 6: Active Project Members
.DE
.KE
.NH 2
Active Project Members
.LP
Figure\ 6 identifies the current PBS project participants, and gives
the fraction of \*Qfull time\*U that each has available for PBS.
.KF
.DS L
.TS
box center tab(;) ;
l|c|l|ce se
l|c|l|ce se
l|c|l|ce|ce
l|c|l|re|re .
;;;Date
;;;_
Name;Initials;Affiliation;Joined;Left
_
Kent Crispin;KC;LLNL-LCC;6-25-92;10-19-93
Terry Heidelberg;TH;LLNL-LCC;6-25-92;7-20-93
Bruce Kelly;BK;LLNL-NERSC;6-25-92;3-22-96
John Musch;JM;NASA;10-1-94;3-31-95
Dan Nessett;DN;LLNL-LCC;8-4-92;11-3-92
Clark Streeter;CS;LLNL-NERSC;6-25-92;9-12-95
Bob Wood;BW;LLNL-LCC;6-25-92;1-5-93
.TE
.DE
.DS C
Figure 7: Past Project Members
.DE
.KE
.NH 2
Past Project Members
.LP
Figure\ 7 lists the names and periods of participation of people who
once worked on PBS but no longer do so.
.KF
.DS L
.TS
box center tab(;) ;
l||ce||ce||ce||ce||ce se se se||ce se se se
l||ce||ce||ce||ce||ce se se se||ce se se se
l||ce||ce||ce||ce||ce|ce|ce|ce||ce|ce|ce|ce
l||ce||ce||ce||ce||ce|ce|ce|ce||ce|ce|ce|ce
l||ne||ne||ne||ne||ne|ne|ne|ne||ne|ne|ne|ne .
;FY;FY;FY;FY;FY97;FY98
;;;;;_;_
;93;94;95;96;Q1;Q2;Q3;Q4;Q1;Q2;Q3;Q4
_;_;_;_;_;_;_;_;_;_;_;_;_
On-going Support (NASA-MRJ);;0.2;1;1;1;0.5;0.5;0.5;0.5;0.5;0.5;0.5
Development (NASA-MRJ);
\ \ \ \ Release 1.0;1.1;1.5;;;;;;;;;;
\ \ \ \ Release 1.1;;0.3;0.4;;;;;;;;;
\ \ \ \ Release 2.0;;;0.6;1;2;2.5;3.5;4.5;4.5;4.5;4.5;4.5
_;_;_;_;_;_;_;_;_;_;_;_;_
NASA-MRJ Total;1.1;2;2;2;2;3;4;5;5;5;5;5
_;_;_;_;_;_;_;_;_;_;_;_;_
Development (NASA-Sterling);
\ \ \ \ Release 1.1;;;0.3;1;;;;;;;;
\ \ \ \ Release 2.0;;;;;;;;;;1;;
_;_;_;_;_;_;_;_;_;_;_;_;_
NASA-Sterling Total;;;0.3;1;;;;;;;;
_;_;_;_;_;_;_;_;_;_;_;_;_
Project Leadership (NASA);0.3;0.2;0.2;0.2;0.2;0.2;0.2;0.2;0.2;0.2;0.2;0.2
Development (NASA)
\ \ \ \ Release 1.0;0.3;0.6;;;;;;;;;;;;;
\ \ \ \ Release 1.1;;0.2;0.8;;;;;;;;;
\ \ \ \ Release 2.0;;;;;;;;;;;;
_;_;_;_;_;_;_;_;_;_;_;_;_
NASA-Civil Service Total;0.6;1;1.3;0.8;0.2;0.2;0.2;0.2;0.2;0.2;0.2;0.2
_;_;_;_;_;_;_;_;_;_;_;_;_
Development (LLNL-LCC)
\ \ \ \ Release 1.0;0.5;;;;;;;;;;;
Development (LLNL-NERSC)
\ \ \ \ Release 1.0;0.3;0.6;;;;;;;;;;
\ \ \ \ Release 2.0;;;0.2;0.3;;;;;;;;
_;_;_;_;_;_;_;_;_;_;_;_;_
LLNL Total;0.8;0.8;0.5;0.3;;;;;;;;
=;=;=;=;=;=;=;=;=;=;=;=;=
Manpower Total;2.5;3.8;4.1;4.1;3.2;3.2;3.2;3.2;3.2;3.2;3.2;2.7
.TE
.DE
.DS C
Figure 8: Sources of Project Manpower
.DE
.KE
.NH 2
Sources of Project Manpower
.LP
Figure\ 8 gives estimated or actual manpower for each feature release
of PBS.
Though the figure does not show all of it, a 0.5 man-year per year
level of effort continues for the planned lifetime of PBS, five years
beyond the last feature release.
Given the planned last feature release date of November, 1996 (for
release 2.1), support continues through calendar 2001.
