/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/

#ifndef MOM_MACH
#include "mom_mach.h"
#endif	/* MOM_MACH */

/* struct var_table = used to hold environment variables for the job */

struct var_table {
	char  *v_block;
	char **v_envp;
	int    v_bsize;
	int    v_ensize;
	int    v_used;
};

/* struct sig_tbl = used to hold map of local signal names to values */

struct sig_tbl {
	char *sig_name;
	int   sig_val;
};

#define NUM_LCL_ENV_VAR  10

/* public funtions within MOM */

#ifdef _CRAY
#define WJSIGNAL	46

extern void  post_suspend A_((job *, int));
extern void  post_resume  A_((job *, int));

#endif	/* _CRAY */

extern void  bld_env_variables A_((struct var_table *, char *, char *));
extern pid_t fork_me A_((int sock));
extern void  init_abort_jobs A_((int));
extern int   init_groups A_((char *, int, int, int *));
extern int   kill_job A_((job *, int sig));
extern void  mom_deljob A_((job *));
extern void  mom_freenodes A_((job *));
extern void  scan_for_exiting();
extern void  scan_for_terminated();
extern int   set_job A_((job *, struct startjob_rtn *));
extern void  set_globid A_((job *, struct startjob_rtn *));
extern int   set_mach_vars A_((job *, struct var_table *));
extern char *set_shell A_((job *, struct passwd *));
extern void  start_exec A_((job *));
extern int   open_master();
extern int   open_slave();
extern char *rcvttype A_((int));
extern int   rcvwinsize A_((int));
extern int   remtree A_((char *));
extern int   setwinsize A_((int));
extern void  set_termcc A_((int));
extern int   site_job_setup A_((job *));
extern int   site_mom_chkuser A_((job *));
extern int   site_mom_postchk A_((job *, int));
extern int   site_mom_prerst A_((job *));
extern int   reader A_((int, int));
extern int   writer A_((int, int));
extern int   conn_qsub A_((char *host, unsigned int port));
extern int   run_pelog A_((int which, char *file, job *pjob, int pe_io_type));

/* Defines for pe_io_type, see run_pelog() */

#define PE_IO_TYPE_NULL	-1
#define PE_IO_TYPE_ASIS	0
#define PE_IO_TYPE_STD 	1
#define PE_PROLOGUE	1
#define PE_EPILOGUE	2

#ifdef LIBPBS_H
extern int   open_std_file A_((job *, enum job_file, int, gid_t));
extern char *std_file_name A_((job *, enum job_file));
#endif	/* LIBPBS_H */

#ifdef BATCH_REQUEST_H
extern int   start_checkpoint A_((job *, int abt, struct batch_request *pq));
#endif /* BATCH_REQUEST_H */
