/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/

#include <pbs_config.h>   /* the master config generated by configure */

#include <ctype.h>
#include <string.h>

static char ident[] = "@(#) $RCSfile: ck_job_name.c,v $ $Revision: 2.0 $";

/*
 * check_job_name = job name must be <= 15 "printable" characters with
 *	first alphabetic, maybe.  The POSIX Batch standard calls for only
 *	alphanumeric, but then conflicts with itself to default to the
 *	script base-name which may have non-alphanumeric characters and
 *	the first character not alphabetic.
 *
 *	We check for visible, printable characters and the first being
 *	alphabetic if comining from a -N option (chk_alpha = 1).
 */
int check_job_name(name, chk_alpha)
    char *name;
    int   chk_alpha;
{

    if ( (strlen(name) > (size_t)15) ||
	 ((chk_alpha == 1) && (isalpha((int)*name) == 0)) )
		return (-1);

    while (*name) {
	if (isgraph((int)*name++) == 0)	/* disallow any non-printing */
		return (-1);
    }
    return (0);
}
