/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*
 * locate_job
 *
 *	Connect to the server the job was submitted to, and issue a
 * Locate Job command. The result should be the server that the job
 * is currently at.
 */

#include <pbs_config.h>   /* the master config generated by configure */

#define TRUE 1
#define FALSE 0
#define notNULL(x) (((x)!=NULL) && (strlen(x)>(size_t)0))

#include <stdlib.h>
#include <string.h>
#include "pbs_ifl.h"

static char ident[] = "@(#) $RCSfile: locate_job.c,v $ $Revision: 2.0 $";

int 
locate_job(job_id, parent_server, located_server)
char *job_id;
char *parent_server;
char *located_server;
{
    int connect;
    char jid_server[PBS_MAXCLTJOBID+1];
    char *location;

    if ( (connect = pbs_connect(parent_server)) > 0 ) {
        strcpy(jid_server, job_id);
	if ( notNULL(parent_server) ) {
	    strcat(jid_server, "@");
            strcat(jid_server, parent_server);
	}
        location = pbs_locjob(connect, jid_server, NULL);
        if ( location == NULL ) {
            pbs_disconnect(connect);
            return FALSE;
        }
        strcpy(located_server, location);
        free(location);
        pbs_disconnect(connect);
        return TRUE;
    } else
        return FALSE;
}
