/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*
 *
 * parse_destination_id
 *
 * full syntax permitted;
 *
 * queue_name[@server_name[:port_number]]
 * @server_name[:port_number]
 *
 */

#include <pbs_config.h>   /* the master config generated by configure */

#include <string.h>
#include <ctype.h>
#include "pbs_ifl.h"

#define ISNAMECHAR(x) ( (isgraph(x)) && ((x) != '#') && ( (x) != '@') )
#define MAXSERVERNAME PBS_MAXSERVERNAME+PBS_MAXPORTNUM+2

static char queue_name[PBS_MAXQUEUENAME+1]; 
static int q_pos;
static char server_name[MAXSERVERNAME]; 
static int c_pos;

static char ident[] = "@(#) $RCSfile: parse_destid.c,v $ $Revision: 2.0 $";

int 
parse_destination_id(destination_in, queue_name_out, server_name_out) 
char *destination_in;
char **queue_name_out;
char **server_name_out;
{
    int i;
    char *c;

    /* initialize static data for this parsing call */
    for ( i=0; i<PBS_MAXQUEUENAME+1; i++ ) queue_name[i]='\0'; 
    q_pos= 0;
    for ( i=0; i<MAXSERVERNAME; i++ ) server_name[i]='\0';
    c_pos = 0;

    /* Begin the parse */
    c = destination_in;
    while ( isspace(*c) ) c++;

    /* Looking for a queue */
    while ( *c != '\0' ) {
        if ( ISNAMECHAR(*c) ) {
	    if ( q_pos >= PBS_MAXQUEUENAME ) return 1;
            queue_name[q_pos++]=*c;
        } else
            break;
        c++;
    }

    /* Looking for a server */
    if ( *c == '@' ) {
        c++;
        while ( *c != '\0' ) {
            if ( ISNAMECHAR(*c) ) {
	        if ( c_pos >= MAXSERVERNAME ) return 1;
                server_name[c_pos++]=*c;
            } else
                break;
            c++;
        }
	if ( c_pos == 0 ) return 1;
    }

    if ( *c != '\0' ) return 1;

    /* set char * pointers to static data, to arguments */
    if ( queue_name_out != NULL ) *queue_name_out = queue_name;
    if ( server_name_out != NULL ) *server_name_out = server_name;

    return 0;
}
