/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*
 * prt_job_err
 *
 *	Print the error message returned by the server, if supplied. Otherwise,
 * print a default error message.
 */

#include <pbs_config.h>   /* the master config generated by configure */

#include <stdio.h>

#include "pbs_error.h"
#include "pbs_ifl.h"

static char ident[] = "@(#) $RCSfile: prt_job_err.c,v $ $Revision: 2.0 $";

void prt_job_err( cmd, connect, id )
char	*cmd;
int	 connect;
char	*id;
{
	char *errmsg;

	errmsg = pbs_geterrmsg(connect);
	if ( errmsg != NULL ) {
		fprintf(stderr, "%s: %s ", cmd, errmsg);
	} else {
		fprintf(stderr, "%s: Server returned error %d for job ", cmd, pbs_errno);
	}
	fprintf(stderr, "%s\n", id);
}
