/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*
 * set_attr
 *
 *	Add an entry to an attribute list. First, create the entry and set
 * the fields. If the attribute list is empty, then just point it at the
 * new entry. Otherwise, append the new entry to the list.
 */

#include <pbs_config.h>   /* the master config generated by configure */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "pbs_ifl.h"

static char ident[] = "@(#) $RCSfile: set_attr.c,v $ $Revision: 2.0 $";

void 
set_attr(attrib, attrib_name, attrib_value)
struct attrl **attrib;
char *attrib_name;
char *attrib_value;
{
    struct attrl *attr, *ap;
    
    attr = (struct attrl *) malloc(sizeof(struct attrl));
    if ( attr == NULL ) {
        fprintf(stderr, "Out of memory\n");
        exit(2);
    }
    if ( attrib_name == NULL )
        attr->name = NULL;
    else {
        attr->name = (char *) malloc(strlen(attrib_name)+1);
        if ( attr->name == NULL ) {
            fprintf(stderr, "Out of memory\n");
            exit(2);
        }
        strcpy(attr->name, attrib_name);
    }
    attr->resource = NULL;
    if ( attrib_value == NULL )
        attr->value = NULL;
    else {
        attr->value = (char *) malloc(strlen(attrib_value)+1);
        if ( attr->name == NULL ) {
            fprintf(stderr, "Out of memory\n");
            exit(2);
        }
        strcpy(attr->value, attrib_value);
    }
    attr->next = NULL;
    if ( *attrib == NULL ) {
        *attrib = attr;
    } else {
        ap = *attrib;
	while ( ap->next != NULL ) ap = ap->next;
        ap->next = attr;
    }

    return;
}
