#include <pbs_config.h>   /* the master config generated by configure */

#include <assert.h>
#include <stddef.h>

#include "dis.h"
#include "dis_.h"

int disrsi_(stream, negate, value, count)
    int			stream;
    int			*negate;
    unsigned        	*value;
    unsigned		count;
    {
	int		c;
	unsigned	locval;
	unsigned	ndigs;
	char		*cp;

	assert(negate != NULL);
	assert(value != NULL);
	assert(count);
	assert(stream >= 0);
	assert(dis_getc != NULL);
	assert(dis_gets != NULL);

	if (dis_umaxd == 0)
	        disiui_();
	switch (c = (*dis_getc)(stream)) {
	    case '-':
	    case '+':
		*negate = c == '-';
		if ((*dis_gets)(stream, dis_buffer, count) != count)
		        return (DIS_EOD);
		if (count >= dis_umaxd) {
			if (count > dis_umaxd)
			        goto overflow;
			if (memcmp(dis_buffer, dis_umax, dis_umaxd) > 0)
			        goto overflow;
		}
		cp = dis_buffer;
		locval = 0;
		do {
			if ((c = *cp++) < '0' || c > '9')
			        return (DIS_NONDIGIT);
			locval = 10 * locval + c - '0';
		} while (--count);
		*value = locval;
		return (DIS_SUCCESS);
	    case '0':
		return (DIS_LEADZRO);
	    case '1':
	    case '2':
	    case '3':
	    case '4':
	    case '5':
	    case '6':
	    case '7':
	    case '8':
	    case '9':
		ndigs = c - '0';
		if (count > 1) {
			if ((*dis_gets)(stream, dis_buffer + 1, count - 1) !=
								count - 1)
			        return (DIS_EOD);
			cp = dis_buffer;
			if (count >= dis_umaxd) {
				if (count > dis_umaxd)
				        break;
				*cp = c;
				if (memcmp(dis_buffer, dis_umax, dis_umaxd) > 0)
				        break;
			}
			while (--count) {
				if ((c = *++cp) < '0' || c > '9')
				        return (DIS_NONDIGIT);
				ndigs = 10 * ndigs + c - '0';
			}
		}
		return (disrsi_(stream, negate, value, ndigs));
	    case -1:
		return (DIS_EOD);
	    case -2:
		return (DIS_EOF);
	    default:
		return (DIS_NONDIGIT);
	}
	*negate = FALSE;
    overflow:
	*value = UINT_MAX;
	return (DIS_OVERFLOW);
}
