/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*	PBS_jcred.c

	send job credentials to the server.

	Note: This code is not mean to be used by a persistent process.
	If an error occurs, not all the allocated structures are freed.
*/

#include <pbs_config.h>   /* the master config generated by configure */

#include <string.h>
#include <stdio.h>
#include "libpbs.h"
#include "dis.h"

static char ident[] = "@(#) $RCSfile: PBSD_jcred.c,v $ $Revision: 2.0 $";

int PBSD_jcred(c, buf, len)
int c;
char *buf;
int len;
{
	int	rc;
	struct batch_reply *reply;
	int	sock;
	int	type = 0;

	sock = connection[c].ch_socket;
	DIS_tcp_setup(sock);

	if ( (rc =encode_DIS_ReqHdr(sock,PBS_BATCH_JobCred,pbs_current_user)) ||
	     (rc = encode_DIS_JobCredential(sock, type, buf, len)) ||
	     (rc = encode_DIS_ReqExtend(sock, (char *)0)) ) {
		connection[c].ch_errtxt = strdup(dis_emsg[rc]);
		return (pbs_errno = PBSE_PROTOCOL);
	}
	if (DIS_tcp_wflush(sock)) {
		return (pbs_errno = PBSE_PROTOCOL);
	}
				
	reply = PBSD_rdrpy(c);
	
	PBSD_FreeReply(reply);

	return connection[c].ch_errno;
}
