/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*	pbs_msgjob.c
 *
 *	send the MessageJob request
*/

#include <pbs_config.h>   /* the master config generated by configure */

#include <string.h>
#include <stdio.h>
#include "libpbs.h"
#include "dis.h"

static char ident[] = "@(#) $RCSfile: PBSD_msg2.c,v $ $Revision: 2.0 $";

/*
 *	PBS_msg_put.c
 *
 *	Send the MessageJob request, does not read the reply.
 */

int PBSD_msg_put(c, jobid, fileopt, msg, extend)
	int   c;
	char *jobid;
	int   fileopt;
	char *msg;
	char *extend;
{
	int rc = 0;
	int sock;

	sock = connection[c].ch_socket;
	DIS_tcp_setup(sock);

	if ( (rc = encode_DIS_ReqHdr(sock, PBS_BATCH_MessJob, pbs_current_user)) ||
	     (rc = encode_DIS_MessageJob(sock, jobid, fileopt, msg)) ||
	     (rc = encode_DIS_ReqExtend(sock, extend)) ) {
		connection[c].ch_errtxt = strdup(dis_emsg[rc]);
		return (pbs_errno = PBSE_PROTOCOL);
	}
	if (DIS_tcp_wflush(sock)) {
		pbs_errno = PBSE_PROTOCOL;
		rc	  = pbs_errno;
	}
		
	return rc;			
}
