/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*	PBS_status.c

	The function that underlies all the status requests
*/

#include <pbs_config.h>   /* the master config generated by configure */

#include <string.h>
#include <stdio.h>
#include "libpbs.h"

static char ident[] = "@(#) $RCSfile: PBSD_status.c,v $ $Revision: 2.0 $";

static struct batch_status *alloc_bs();

struct batch_status *
PBSD_status(c, function, id, attrib, extend )
	int c;
	int function;
	char *id;
	struct attrl *attrib;
	char *extend;
{
	int rc;
	struct batch_status *PBSD_status_get A_((int c));

	/* send the status request */

	if (id == (char *)0)
		id = "";	/* set to null string for encoding */

	rc = PBSD_status_put(c, function, id, attrib, extend);
	if (rc) {
		return (struct batch_status *)NULL;
	}

	/* get the status reply */

	return ( PBSD_status_get(c) );
}

struct batch_status *PBSD_status_get(c)
	int c;
{
	struct brp_cmdstat  *stp; /* pointer to a returned status record */
	struct batch_status *bsp;
	struct batch_status *rbsp = (struct batch_status *)NULL;
	struct batch_reply  *reply;
	int i;

	/* read reply from stream into presentation element */

	reply = PBSD_rdrpy(c);
	if ( reply == NULL ) {
                pbs_errno = PBSE_PROTOCOL;
	} else if ( reply->brp_choice != BATCH_REPLY_CHOICE_NULL  &&
	            reply->brp_choice != BATCH_REPLY_CHOICE_Text &&
	            reply->brp_choice != BATCH_REPLY_CHOICE_Status ) {
		pbs_errno = PBSE_PROTOCOL;
	} else if ( connection[c].ch_errno == 0 ) {
		/* have zero or more attrl structs to decode here */
		stp = reply->brp_un.brp_statc;
		i = 0;
		pbs_errno = 0;
		while( stp != (struct brp_cmdstat *)NULL ) {
			if( i++ == 0 ) {
				rbsp = bsp = alloc_bs();
				if( bsp == (struct batch_status *)NULL ) {
					pbs_errno = PBSE_SYSTEM;
					break;
				}
			} else {
				bsp->next = alloc_bs();
				bsp = bsp->next;
				if( bsp == (struct batch_status *)NULL ) {
					pbs_errno = PBSE_SYSTEM;
					break;
				}
			}
			bsp->name = strdup(stp->brp_objname);
			bsp->attribs = stp->brp_attrl;
			if (stp->brp_attrl)
				stp->brp_attrl = 0;
			bsp->next = (struct batch_status *)NULL;
			stp = stp->brp_stlink;
		}
		if (pbs_errno) {
			pbs_statfree(rbsp);
			rbsp = (struct batch_status *)NULL;
		}
	}
	PBSD_FreeReply(reply);
	return rbsp;
}

/*	
	Allocate a batch status reply structure
*/

static struct batch_status *alloc_bs()
{
	struct batch_status *bsp;

	bsp = MH(struct batch_status);
	if (bsp) {

		bsp->next = (struct batch_status *)NULL;
		bsp->name = (char *)NULL;
		bsp->attribs = (struct attrl *)NULL;
		bsp->text = (char *)NULL;
	}
	return bsp;
}
