/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*	PBS_status_put()

	The function that sends the general batch status request
*/

#include <pbs_config.h>   /* the master config generated by configure */

#include <string.h>
#include <stdio.h>
#include "libpbs.h"
#include "dis.h"

static char ident[] = "@(#) $RCSfile: PBSD_status2.c,v $ $Revision: 2.0 $";

int PBSD_status_put(c, function, id, attrib, extend )
	int c;
	int function;
	char *id;
	struct attrl *attrib;
	char *extend;
{
	int rc = 0;
	int sock;

	sock = connection[c].ch_socket;
	DIS_tcp_setup(sock);

	if ( (rc = encode_DIS_ReqHdr(sock, function, pbs_current_user))   ||
	     (rc = encode_DIS_Status(sock, id, attrib)) ||
	     (rc = encode_DIS_ReqExtend(sock, extend)) ) { 
		connection[c].ch_errtxt = strdup(dis_emsg[rc]);
		return (pbs_errno = PBSE_PROTOCOL);
	}
	if (DIS_tcp_wflush(sock)) {
		return (pbs_errno = PBSE_PROTOCOL);
	}

	return 0;
}
