/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/

static char ident[] = "@(#) $RCSfile: PBS_attr.c,v $ $Revision: 2.0 $";

#include <pbs_config.h>   /* the master config generated by configure */

#include <stdio.h>
#include <stdlib.h>
#include "libpbs.h"

int PBS_val_al(alp)
	struct attrl *alp;
{
	while (alp) {
		if ( (alp->name == 0) || (alp->value == 0) )
			return -1;
		alp = alp->next;
	}
	return 0;
}

void PBS_free_al( alp )
	struct attrl *alp;
{
	struct attrl *talp;
	while( alp != (struct attrl *)NULL ) {
		free( alp->name );
		free( alp->resource );
		free( alp->value );
		talp = alp;
		alp = alp->next;
		free( talp );
	}
}

int PBS_val_aopl(aoplp)
	struct attropl *aoplp;
{
	while( aoplp != (struct attropl *)NULL ) {
		if ( (aoplp->name == 0) || (aoplp == 0) )
			return -1;
		aoplp = aoplp->next;
	}
	return 0;
}

void PBS_free_aopl( aoplp )
	struct attropl *aoplp;
{
	struct attropl *taoplp;
	while( aoplp != (struct attropl *)NULL ) {
		free( aoplp->name );
		free( aoplp->resource );
		free( aoplp->value );
		taoplp = aoplp;
		aoplp = aoplp->next;
		free( taoplp );
	}
}
