/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
 
static char ident[] = "@(#) $RCSfile: dec_JobFile.c,v $ $Revision: 2.0 $";

/*
 * decode_DIS_JobFile() - decode a Job Related Job File Move request
 *
 *	Data items are:	u int	block sequence number
 *			u int	file type (stdout, stderr, ...)
 *			u int	size of data in block
 *			string	job id
 *			cnt str	data
 */

#include <pbs_config.h>   /* the master config generated by configure */

#include <sys/types.h>
#include <stdlib.h>
#include "libpbs.h"
#include "list_link.h"
#include "server_limits.h"
#include "attribute.h"
#include "credential.h"
#include "batch_request.h"
#include "dis.h"

int decode_DIS_JobFile(sock, preq)
	int	 sock;
	struct batch_request *preq;
{
	int   rc;
	size_t amt;

	preq->rq_ind.rq_jobfile.rq_data = 0;

	preq->rq_ind.rq_jobfile.rq_sequence = disrui(sock, &rc);
	if (rc) return rc;

	preq->rq_ind.rq_jobfile.rq_type = disrui(sock, &rc);
	if (rc) return rc;

	preq->rq_ind.rq_jobfile.rq_size = disrui(sock, &rc);
	if (rc) return rc;

	if ((rc = disrfst(sock, PBS_MAXSVRJOBID+1, preq->rq_ind.rq_jobfile.rq_jobid)) != 0)
		return rc;

	preq->rq_ind.rq_jobfile.rq_data = disrcs(sock, &amt, &rc);
	if ((amt != preq->rq_ind.rq_jobfile.rq_size) && (rc == 0))
		rc = DIS_EOD;
	if (rc) {
		if (preq->rq_ind.rq_jobfile.rq_data)
			(void)free(preq->rq_ind.rq_jobfile.rq_data);
			preq->rq_ind.rq_jobfile.rq_data = 0;
	}

	return rc;
}
