/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
 
static char ident[] = "@(#) $RCSfile: dec_JobObit.c,v $ $Revision: 2.0 $";

/*
 * decode_DIS_JobObit() - decode a Job Obituary Batch Request (Notice)
 *
 *	This request is used by the server ONLY.
 *	The batch request structure must already exist.
 *
 *	Data items are:	string		job id
 *			signed int	status
 *			list of		svrattrl
 */

#include <pbs_config.h>   /* the master config generated by configure */

#include <sys/types.h>
#include "libpbs.h"
#include "list_link.h"
#include "server_limits.h"
#include "attribute.h"
#include "credential.h"
#include "batch_request.h"
#include "dis.h"

int decode_DIS_JobObit(sock, preq)
	int   sock;
	struct batch_request *preq;
{
	int   rc;

	CLEAR_HEAD(preq->rq_ind.rq_jobobit.rq_attr);
	rc = disrfst(sock, PBS_MAXSVRJOBID, preq->rq_ind.rq_jobobit.rq_jid);
	if (rc != 0) return rc;
	preq->rq_ind.rq_jobobit.rq_status = disrsi(sock, &rc);
	if (rc) return rc;

	/* decode list of svrattrl (if any) */

	rc = decode_DIS_svrattrl(sock, &preq->rq_ind.rq_jobobit.rq_attr);
	return rc;
}
