/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
 
static char ident[] = "@(#) $RCSfile: dec_ReqHdr.c,v $ $Revision: 2.0 $";

/*
 * decode_DIS_ReqHdr() - Decode the Request Header Fields
 *	common to all requests
 *
 *	Fields are:	Protocol ID (unsigned integer)
 *			Protocol Version (unsigned integer)
 *			Request Type (unsignded integer)
 *			User Name (string)
 *
 *	Returns:  -1	on EOF (end of file on first read only)
 *		   0	on success
 *		  >0	a DIS error return, see dis.h
 */

#include <pbs_config.h>   /* the master config generated by configure */

#include <sys/types.h>
#include "libpbs.h"
#include "list_link.h"
#include "server_limits.h"
#include "attribute.h"
#include "credential.h"
#include "batch_request.h"
#include "dis.h"

int decode_DIS_ReqHdr(sock, preq, proto_type, proto_ver)
	int	 sock;
	struct batch_request *preq;
	int	*proto_type;
	int	*proto_ver;

{
	int rc;
	
	*proto_type = disrui(sock, &rc);
	if (rc) {
		return rc;
	}
	if (*proto_type != PBS_BATCH_PROT_TYPE)
		return  DIS_PROTO;
	*proto_ver = disrui(sock, &rc);
	if (rc) return rc;

	preq->rq_type = disrui(sock, &rc);
	if (rc) return rc;

	return ( disrfst(sock, PBS_MAXUSER+1, preq->rq_user) );
}
