/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/

#include <pbs_config.h>   /* the master config generated by configure */

#include <sys/types.h>
#include <stdlib.h>
#include "libpbs.h"
#include "list_link.h"
#include "attribute.h"
#include "credential.h"
#include "batch_request.h"
#include "pbs_error.h"
#include "dis.h"

static char ident[] = "@(#) $RCSfile: dec_Resc.c,v $ $Revision: 2.0 $";

/*
 * decode_DIS_rescl() - decode a resource request
 *
 *	Used for resource query, resource reserver, resource free.
 *
 *	The batch_request structure must already exist (be allocated by the
 *	caller.   It is assumed that the header fields (protocol type, 
 *	protocol version, request type, and user name) have been decoded.
 *
 *	Data items are:	signed int	resource handle
 *			unsigned int	count of resource queries
 *		followed by that number of:
 *			string		resource list
 */

int decode_DIS_Rescl(sock, preq)
	int	 sock;
	struct batch_request *preq;
{
	int    ct;
	int    i;
	char **ppc;
	int    rc;

	/* first, the resource handle (even if not used in request) */

	preq->rq_ind.rq_rescq.rq_rhandle = disrsi(sock, &rc);
	if (rc) return rc;

	/* next need to know how many query strings */

	ct = disrui(sock, &rc);
	if (rc) return rc;
	preq->rq_ind.rq_rescq.rq_num = ct;
	if (ct) {
		if ((ppc = (char **)malloc(ct * sizeof (char *))) == 0)
			return PBSE_RMSYSTEM;

		for (i=0; i<ct; i++)
			*(ppc + i) = (char *)0;

        	preq->rq_ind.rq_rescq.rq_list = ppc;
		for (i=0; i<ct; i++) {
			*(ppc+i) = disrst(sock, &rc);
			if (rc)
				break;
		}
	}
		
	return rc;
}
