/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
 
static char ident[] = "@(#) $RCSfile: dec_Status.c,v $ $Revision: 2.0 $";

/*
 * decode_DIS_Status() - decode a Status batch request
 *
 *	The batch_request structure must already exist (be allocated by the
 *	caller.   It is assumed that the header fields (protocol type,
 *	protocol version, request type, and user name) have already be decoded.
 *
 *	Data items are:	string		job id
 *			list of 	attrl
 */

#include <pbs_config.h>   /* the master config generated by configure */

#include <sys/types.h>
#include "libpbs.h"
#include "list_link.h"
#include "server_limits.h"
#include "attribute.h"
#include "credential.h"
#include "batch_request.h"
#include "dis.h"

int decode_DIS_Status(sock, preq)
	int   sock;
	struct batch_request *preq;
{
	int rc;

	CLEAR_HEAD(preq->rq_ind.rq_status.rq_attr);
	rc = disrfst(sock,
	       (PBS_MAXSVRJOBID > PBS_MAXDEST ? PBS_MAXSVRJOBID:PBS_MAXDEST)+1,
	       preq->rq_ind.rq_status.rq_id);
	if (rc) return rc;

	rc = decode_DIS_svrattrl(sock, &preq->rq_ind.rq_status.rq_attr);
	return rc;
}
