/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
 
static char ident[] = "@(#) $RCSfile: enc_JobFile.c,v $ $Revision: 2.0 $";

/*
 * encode_DIS_JobFile() - encode a Job Releated File
 *
 *	Data items are:	u int	block sequence number
 *			u int	file type (stdout, stderr, ...)
 *			u int	size of data in block
 *			string	job id
 *			cnt str	data
 */

#include <pbs_config.h>   /* the master config generated by configure */

#include "libpbs.h"
#include "pbs_error.h"
#include "dis.h"

int encode_DIS_JobFile(sock, seq, buf, len, jobid, which)
	int	 sock;
	int	 seq;
	char	*buf;
	int	 len;
	char	*jobid;
	int	 which;
{
	int   rc;

	if (jobid == (char *)0)
		jobid = "";
	if ( (rc = diswui(sock, seq) != 0) ||
	     (rc = diswui(sock, which) != 0) ||
	     (rc = diswui(sock, len) != 0) ||
	     (rc = diswst(sock, jobid) != 0) ||
	     (rc = diswcs(sock, buf, len) != 0) )
		return rc;

	return 0;
}
