/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
 
static char ident[] = "@(#) $RCSfile: enc_QueueJob.c,v $ $Revision: 2.0 $";

/*
 * encode_DIS_QueueJob() - encode a Queue Job Batch Request
 *
 *	This request is used for the first step in submitting a job, sending
 *	the job attributes.
 *
 *	Data items are:	string	job id
 *			string	destination
 *			list of	attribute, see encode_DIS_attropl()
 */

#include <pbs_config.h>   /* the master config generated by configure */

#include "libpbs.h"
#include "pbs_error.h"
#include "dis.h"

int encode_DIS_QueueJob(sock, jobid, destin, aoplp)
	int   sock;
	char *jobid;
	char *destin;
  	struct attropl *aoplp;
{
	int   rc;

	if (jobid == (char *)0)
		jobid = "";
	if (destin == (char *)0)
		destin = "";

	if ( (rc = diswst(sock, jobid) != 0) ||
	     (rc = diswst(sock, destin) != 0) )
		return rc;

	return (encode_DIS_attropl(sock, aoplp));
}
