/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
 
static char ident[] = "@(#) $RCSfile: enc_Reg.c,v $ $Revision: 2.0 $";

/*
 * encode_DIS_Register() - encode a Register Dependency Batch Request
 *
 *	This request is used by the server ONLY; its input is a server
 *	batch request structure.
 *
 *	Data items are:	string		job owner
 *			string		parent job id
 *			string		child job id
 *			unsigned int	dependency type
 *			unsigned int	operation
 *			signed long	cost
 */

#include <pbs_config.h>   /* the master config generated by configure */

#include <sys/types.h>
#include "libpbs.h"
#include "list_link.h"
#include "server_limits.h"
#include "attribute.h"
#include "credential.h"
#include "batch_request.h"
#include "dis.h"

int encode_DIS_Register(sock, preq)
	int   sock;
	struct batch_request *preq;
{
	int   rc;

	if ( (rc = diswst(sock, preq->rq_ind.rq_register.rq_owner) != 0) ||
	     (rc = diswst(sock, preq->rq_ind.rq_register.rq_parent) != 0) ||
	     (rc = diswst(sock, preq->rq_ind.rq_register.rq_child) != 0) ||
	     (rc = diswui(sock, preq->rq_ind.rq_register.rq_dependtype) != 0) ||
	     (rc = diswui(sock, preq->rq_ind.rq_register.rq_op) != 0) ||
	     (rc = diswsl(sock, preq->rq_ind.rq_register.rq_cost) != 0) )
		return rc;

	return 0;
}
