/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
 
static char ident[] = "@(#) $RCSfile: enc_Track.c,v $ $Revision: 2.0 $";

/*
 * encode_DIS_TrackJob() - encode a Track Job Batch Request
 *
 *	This request is used by the server ONLY; its input is a server
 *	batch request structure.
 *
 *	Data items are:	string		job id
 *			unsigned int	hopcount
 *			string		location
 *			u char		state
 */

#include <pbs_config.h>   /* the master config generated by configure */

#include <sys/types.h>
#include "libpbs.h"
#include "list_link.h"
#include "server_limits.h"
#include "attribute.h"
#include "credential.h"
#include "batch_request.h"
#include "dis.h"

int encode_DIS_TrackJob(sock, preq)
	int   sock;
	struct batch_request *preq;
{
	int   rc;

	if ( (rc = diswst(sock, preq->rq_ind.rq_track.rq_jid) != 0) ||
	     (rc = diswui(sock, preq->rq_ind.rq_track.rq_hopcount) != 0) ||
	     (rc = diswst(sock, preq->rq_ind.rq_track.rq_location) != 0) ||
	     (rc = diswuc(sock, preq->rq_ind.rq_track.rq_state[0]) != 0) )
		return rc;

	return 0;
}
