/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
#include <pbs_config.h>   /* the master config generated by configure */

#include <sys/types.h>
#include <netdb.h>
#include <netinet/in.h>
#include "portability.h"

/*
 * get_svrport - get the port number for a given service
 *
 *	Return the port number in an unsigned interger in host byte order.
 *	Assumes the protocol type is tcp.
 *	Returns 0 on an error.
 */

static char ident[] = "@(#) $RCSfile: get_svrport.c,v $ $Revision: 2.0 $";

unsigned int get_svrport(service_name, ptype, pdefault)
	char *service_name;
	char *ptype;
	unsigned int pdefault;	/* in host byte order */
{
	struct servent *psvr;

	psvr = getservbyname(service_name, ptype);
	if (psvr)
		return ((unsigned int)ntohs(psvr->s_port));
	else
		return (pdefault);
}
