/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*	pbs_alterjob.c

	Send the Alter Job request to the server -- 
	really an instance of the "manager" request.
*/

#include <pbs_config.h>   /* the master config generated by configure */

#include <stdio.h>
#include <stdlib.h>
#include "libpbs.h"

static char ident[] = "@(#) $RCSfile: pbsD_alterjo.c,v $ $Revision: 2.0 $";

int 
pbs_alterjob(c, jobid, attrib, extend)
int c;
char *jobid;
struct attrl *attrib;
char *extend;
{
	struct attropl *ap = (struct attropl *)NULL;
	struct attropl *ap1 = (struct attropl *)NULL;
	int i;
	
	if ((jobid == (char *)0) || (*jobid == '\0'))
		return (pbs_errno = PBSE_IVALREQ);

	/* copy the attrl to an attropl */
	while( attrib != (struct attrl *)NULL ) {
		if( ap == (struct attropl *)NULL ) {
			ap1 = ap = MH(struct attropl);
		} else {
			ap->next = MH(struct attropl);
			ap = ap->next;
		}
		if( ap == (struct attropl *)NULL ) {
			pbs_errno = PBSE_SYSTEM;
			return -1;
		}
		ap->name = attrib->name;
		ap->resource = attrib->resource;
		ap->value = attrib->value;
		ap->op = SET;
		ap->next = (struct attropl *)NULL;
		attrib = attrib->next;
	}
		
	i = PBSD_manager(c,
		PBS_BATCH_ModifyJob,
		MGR_CMD_SET,
		MGR_OBJ_JOB,
		jobid,
		ap1,
		extend);
		
	/* free up the attropl we just created */
	while( ap1 != (struct attropl *)NULL ) {
		ap = ap1->next;
		free( ap1 );
		ap1 = ap;
	}
	
	return i;
}
