/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*	pbs_holdjob.c

	Send the Hold Job request to the server -- 
	really just an instance of the "manager" request.
*/

#include <pbs_config.h>   /* the master config generated by configure */

#include <stdio.h>
#include "libpbs.h"

static char ident[] = "@(#) $RCSfile: pbsD_holdjob.c,v $ $Revision: 2.0 $";

int pbs_holdjob(c, jobid, holdtype, extend)
int c;
char *jobid;
char *holdtype;
char *extend;
{
	struct attropl aopl;
	
	if ((jobid == (char *)0) || (*jobid == '\0'))
		return (pbs_errno = PBSE_IVALREQ);

	aopl.name = ATTR_h;
	aopl.resource = (char *)NULL;
	if ((holdtype == (char *)NULL) || (*holdtype == '\0'))
		aopl.value = "u";
	else
		aopl.value = holdtype;
	aopl.op = SET;
	aopl.next = (struct attropl *)NULL;
	return PBSD_manager(c, PBS_BATCH_HoldJob,
			   MGR_CMD_SET,
			   MGR_OBJ_JOB,
			   jobid,
			   &aopl,
			   extend);
}
