/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*	pbs_locjob.c

	This function does the LocateJob request.
*/

#include <pbs_config.h>   /* the master config generated by configure */

#include <string.h>
#include <stdio.h>
#include "libpbs.h"
#include "dis.h"

static char ident[] = "@(#) $RCSfile: pbsD_locjob.c,v $ $Revision: 2.0 $";

char *
pbs_locjob(c, jobid, extend)
int c;
char * jobid;
char * extend;
{
	int	rc;
	struct batch_reply *reply;
	char       *ploc = (char *)0;
	int sock;
	

	if ((jobid == (char *)0) || (*jobid == '\0')) {
		pbs_errno = PBSE_IVALREQ;
		return (ploc);
	}

	sock = connection[c].ch_socket;

	/* setup DIS support routines for following DIS calls */

	DIS_tcp_setup(sock);

	if ( (rc = encode_DIS_ReqHdr(sock, PBS_BATCH_LocateJob,pbs_current_user)) ||
	     (rc = encode_DIS_JobId(sock, jobid))	   ||
	     (rc = encode_DIS_ReqExtend(sock, extend)) ) {
		connection[c].ch_errtxt = strdup(dis_emsg[rc]);
		pbs_errno = PBSE_PROTOCOL;
		return (char *)NULL;
	}
	
	/* write data over tcp stream */

	if (DIS_tcp_wflush(sock)) {
		pbs_errno = PBSE_PROTOCOL;
		return (char *)NULL;
	}

	/* read reply from stream */

	reply = PBSD_rdrpy(c);
	if ( reply == NULL) {
                pbs_errno = PBSE_PROTOCOL;
	} else if ( reply->brp_choice != BATCH_REPLY_CHOICE_NULL &&
	            reply->brp_choice != BATCH_REPLY_CHOICE_Text &&
	            reply->brp_choice != BATCH_REPLY_CHOICE_Locate) {
		advise("pbs_locjob", "Unexpected reply choice");
		pbs_errno = PBSE_PROTOCOL;
	} else if ( connection[c].ch_errno == 0 ) {
		ploc = strdup(reply->brp_un.brp_locate);
	}

	PBSD_FreeReply(reply);

	return ploc;
}
