/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*	pbs_movejob.c */

#include <pbs_config.h>   /* the master config generated by configure */

#include <string.h>
#include <stdio.h>
#include "libpbs.h"
#include "dis.h"

static char ident[] = "@(#) $RCSfile: pbsD_movejob.c,v $ $Revision: 2.0 $";

int pbs_movejob(c, jobid, destin, extend)
	int c;
	char *jobid;
	char *destin;
	char *extend;
{
	int		    rc;
	struct batch_reply *reply;
	int		    sock;


	if ((jobid == (char *)0) || (*jobid == '\0'))
		return (pbs_errno = PBSE_IVALREQ);
	if (destin == (char *)0)
		destin = "";

	sock = connection[c].ch_socket;

	/* setup DIS support routines for following DIS calls */

	DIS_tcp_setup(sock);

	if ( (rc=encode_DIS_ReqHdr(sock,PBS_BATCH_MoveJob, pbs_current_user)) ||
	     (rc = encode_DIS_MoveJob(sock, jobid, destin))   ||
	     (rc = encode_DIS_ReqExtend(sock, extend)) ) {
		connection[c].ch_errtxt = strdup(dis_emsg[rc]);
		return (pbs_errno = PBSE_PROTOCOL);
	}
				
	if (DIS_tcp_wflush(sock)) {
		return (pbs_errno = PBSE_PROTOCOL);
	}

	/* read reply */
	
	reply = PBSD_rdrpy(c);
	
	PBSD_FreeReply(reply);

	return connection[c].ch_errno;
}
