/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*	pbs_msgjob.c
 *
 *	send the MessageJob request and get the reply.
*/

#include <pbs_config.h>   /* the master config generated by configure */

#include <string.h>
#include <stdio.h>
#include "libpbs.h"
#include "dis.h"

static char ident[] = "@(#) $RCSfile: pbsD_msgjob.c,v $ $Revision: 2.0 $";

int pbs_msgjob(c, jobid, fileopt, msg, extend)
	int c;
	char *jobid;
	int fileopt;
	char *msg;
	char *extend;
{
	struct batch_reply *reply;
	int	rc;

	if ((jobid == (char *)0) || (*jobid == '\0') ||
	    (msg == (char *)0) || (*msg == '\0'))
		return (pbs_errno = PBSE_IVALREQ);

	/* setup DIS support routines for following DIS calls */

	DIS_tcp_setup(connection[c].ch_socket);

	if (rc = PBSD_msg_put(c, jobid, fileopt, msg, extend))  {
		connection[c].ch_errtxt = strdup(dis_emsg[rc]);
		return (pbs_errno = PBSE_PROTOCOL);
	}

	/* read reply */

	reply = PBSD_rdrpy(c);
	rc = connection[c].ch_errno;
	
	PBSD_FreeReply(reply);

	return rc;
}
