/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*	pbs_submit.c
 *
 *	The Submit Job request.  
*/

#include <pbs_config.h>   /* the master config generated by configure */

#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include "libpbs.h"

static char ident[] = "@(#) $RCSfile: pbsD_submit.c,v $ $Revision: 2.0 $";

char *
pbs_submit(c, attrib, script, destination, extend)
	int c;
	struct attropl *attrib;
	char * script;
	char * destination;
	char * extend;
{
	struct attropl *pal;
	char * return_jobid = (char *)NULL;

	
	/* first be sure that the script is readable if specified ... */

	if ((script != (char *)0) && (*script != '\0')) {
		if( access( script, R_OK ) != 0 ) {
			pbs_errno = PBSE_BADSCRIPT;
			return (char *)NULL;
		}
	}

	/* initiate the queueing of the job */

	for (pal = attrib; pal; pal = pal->next)
		pal->op = SET;		/* force operator to SET */
	
	/* Queue job with null string for job id */
	return_jobid = PBSD_queuejob(c, "", destination, attrib, extend);
	if( return_jobid == (char *)NULL ) {
		return (char *)NULL;
	}
		
	/* send script across */

	if ((script != (char *)0) && (*script != '\0')) {
		if( PBSD_jscript(c, script) != 0 ) {
			pbs_errno = PBSE_BADSCRIPT;
			return (char *)NULL;
		}
	}
	
	/* OK, the script got across, apparently, so we are */
	/* ready to commit 				    */
	
	if (PBSD_rdytocmt(c, return_jobid) != 0) {
		return (char *)NULL;
	}
	
	if (PBSD_commit(c, return_jobid) != 0) {
		return (char *)NULL;
	}
	
	return return_jobid;
}
