/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*	pbs_statfree.c

	The function that deallocates a "batch_status" structure
*/

#include <pbs_config.h>   /* the master config generated by configure */

#include <stdlib.h>
#include <stdio.h>
#include "libpbs.h"

static char ident[] = "@(#) $RCSfile: pbs_statfree.c,v $ $Revision: 2.0 $";

void pbs_statfree( bsp )
struct batch_status *bsp;
{
	struct attrl        *atnxt;
	struct batch_status *bsnxt;
	
	while( bsp != (struct batch_status *)NULL ) {
		if( bsp->name != (char *)NULL ) (void)free( bsp->name );
		if( bsp->text != (char *)NULL ) (void)free( bsp->text );
		while( bsp->attribs != (struct attrl *)NULL ) {
			if( bsp->attribs->name != (char *)NULL )
				(void)free( bsp->attribs->name );
			if( bsp->attribs->resource != (char *)NULL )
				(void) free( bsp->attribs->resource );
			if( bsp->attribs->value != (char *)NULL )
				(void)free( bsp->attribs->value );
			atnxt = bsp->attribs->next;
			(void)free(bsp->attribs);
			bsp->attribs = atnxt;
		}
		bsnxt = bsp->next;
		(void)free(bsp);
		bsp = bsnxt;
	}
}
