/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*
 * log_event.c - contains functions to log event messages to the log file.
 *
 *	This is specific to the PBS Server.
 *
 * Functions included are:
 *	log_event()
 *	log_change()
 */

static char ident[] = "@(#) $RCSfile: log_event.c,v $ $Revision: 2.0 $";

#include <pbs_config.h>   /* the master config generated by configure */

#include <sys/param.h>
#include <sys/types.h>
#include "pbs_ifl.h"
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include "log.h"
#include "server_limits.h"
#include "list_link.h"
#include "attribute.h"
#include "server.h"

/* private data */

static long  log_event_lvl_priv = PBSEVENT_ERROR    | PBSEVENT_SYSTEM |
				  PBSEVENT_ADMIN    | PBSEVENT_JOB    | 
				  PBSEVENT_SECURITY;

/* external global data */

extern char *path_home;
long	    *log_event_mask = &log_event_lvl_priv;

/*
 * log_event - log a server event to the log file
 *
 *	Checks to see if the event type is being recorded.  If they are,
 *	pass off to log_record().
 *
 *	The caller should ensure proper formating of the message if "text"
 *	is to contain "continuation lines".
 */

void log_event(eventtype, objclass, objname, text)
	int   eventtype;
	int   objclass;
	char *objname;
	char *text;
{
	if (((eventtype & PBSEVENT_FORCE) == 0) && 
	    ((*log_event_mask & eventtype) == 0))
		return;		/* not logging this type of event */
	else
		log_record(eventtype, objclass, objname, text);
}
