/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/

#include <pbs_config.h>   /* the master config generated by configure */

#include <sys/types.h>
#include <netinet/in.h>
#include "portability.h"
#include <netdb.h>
#include <string.h>

static char ident[] = "@(#) $RCSfile: get_hostname.c,v $ $Revision: 2.0 $";

/*
 * get_fullhostname - get the fully qualified name of a host
 *
 * Returns: 0 - if success
 *		host name in character buffer pointed to by namebuf	
 *	   -1 - if error
 */

int get_fullhostname(shortname, namebuf, bufsize)
	char *shortname;
	char *namebuf;
	int   bufsize;
{
	char	       *pbkslh = 0;
	char           *pcolon = 0;
	struct hostent *phe;
	struct in_addr  ina;

	if (pcolon = strchr(shortname, (int)':')) {
		*pcolon = '\0';
		if (*(pcolon-1) == '\\')
			*(pbkslh = pcolon-1) = '\0';
	}
	phe = gethostbyname(shortname);
	if (pcolon) {
		*pcolon = ':';	/* replace the colon */
		if (pbkslh)
			*pbkslh = '\\';
	}
	if (phe == (struct hostent *)0)
		return (-1);

	(void)memcpy((char *)&ina, *phe->h_addr_list, phe->h_length);
	if ((phe = gethostbyaddr((char *)&ina, phe->h_length, phe->h_addrtype))
									   == 0)
		return (-1);

	if ((size_t)bufsize < strlen(phe->h_name))
		return (-1);
	(void)strncpy(namebuf, phe->h_name, bufsize);
	*(namebuf + bufsize) = '\0';	/* insure null terminated */
	return (0);
}
