/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
#include <pbs_config.h>   /* the master config generated by configure */

#include <sys/types.h>
#include <string.h>
#include "portability.h"
#include "list_link.h"
#include "attribute.h"
#include "server_limits.h"
#include "job.h"
#include "log.h"

static char ident[] = "@(#) $RCSfile: site_check_u.c,v $ $Revision: 2.0 $";

/* Global Data Items */

extern char *pbs_o_host;
extern char  server_host[];
extern char *msg_orighost;	/* error message: no PBS_O_HOST */

/*
 * site_check_u - site_check_user_map()
 *
 *	This routine determines if a user is privileged to execute a job
 *	on this host under the login name specified (in user-list attribute)
 *
 *	As provided, this routine uses ruserok(3N).  If this is a problem,
 *	It's replacement is "left as an exersize for the reader."
 */

int site_check_user_map(pjob, luser)
	job	*pjob;	
	char	*luser;
{
	char    *orighost;
	char	 owner[PBS_MAXUSER+1];
	char	*p1;
	char	*p2;
	int	 rc;
	
	/* get just the owner name, without the "@host" */
	
	p1 = pjob->ji_wattr[JOB_ATR_job_owner].at_val.at_str;
	p2 = owner;
	while ((*p1 != '@') && (*p1 != '\0'))
		*p2++ = *p1++;
	*p2 = '\0';

	orighost = get_variable(pjob, pbs_o_host);
	if (orighost == (char *)0) {
		log_event(PBSEVENT_JOB, PBS_EVENTCLASS_JOB, 
			  pjob->ji_qs.ji_jobid, msg_orighost);
		return (-1);
	}
	if ( !strcmp(orighost, server_host) && !strcmp(owner, luser))
		return (0);

	rc =   ruserok(orighost, 0, owner, luser);
#ifdef sun
	/* broken Sun ruserok() sets process so it appears to be owned	*/
	/* by the luser, change it back for cosmetic reasons		*/
	setuid(0);
#endif	/* sun */
	return (rc);
}
