/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
#include <pbs_config.h>   /* the master config generated by configure */

#include <stdio.h>	/* DEBUG */
/*
 * site_mom_pchk.c = a site modifible file
 *
 *	Contains Pre and Post checkpoint stubs for MOM.
 */

/*
 * This is used only in mom and needs PBS_MOM defined in order to
 * have things from other .h files (such as struct task) be defined
 */
#define PBS_MOM

#include <sys/types.h>
#include <pwd.h>
#include "portability.h"
#include "list_link.h"
#include "server_limits.h"
#include "attribute.h"
#include "job.h"
#include "mom_mach.h"
#include "mom_func.h"

static char ident[] = "@(#) $RCSfile: site_mom_ckp.c,v $ $Revision: 2.0 $";

/*
 * site_mom_postchk() - Post-checkpoint stub for MOM.
 *	Called if checkpoint (on qhold,qterm) suceeded.
 *
 *	Should return	0	If ok
 *		    non-zero	If not ok.
 */

int site_mom_postchk(pjob, hold_type)
	job *pjob;
	int  hold_type;
{
	return 0;
}

/*
 * site_mom_prerst() - Pre-restart stub for MOM.
 *	Called just before restart is performed.
 *
 *	Should return	0	if ok
 *		JOB_EXEC_FATAL1 for permanent error, abort job
 *		JOB_EXEC_RETRY	for temporary problem, requeue job.
 */

int site_mom_prerst(pjob)
	job *pjob;
{
	return 0;
}
