/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*************************************************************
*      myname           Lexer.h
*      created          7/2/1996
*      updated          7/18/1996
*      works            7/18/1996
*
*      designed			rrs/1996
*************************************************************/

/***********************************************************
*
*	               OPERATION OVERVIEW
*
* The flex will generate a scanner that looks for tokens
* in the language of BASL2.
* The sentences are parsed by parser in the other files.
*
************************************************************/
#ifndef _LEXER_H 
#define _LEXER_H
/* Feature test switches */
#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE 1
#endif  /* _POSIX_SOURCE */

#if __STDC__ == 1
/*
 * The following macro definations take affect when compiling under ansi C
 *
 * The A_ macro is provided for function prototype declarations.  It allows
 * ANSI C prototypes to be complied under K&R C
 */

#define A_(x) x

#else
/* The following macro definations take affect when compiling under K&R C */

#define const
#define volatile
#define A_(x) ()

#endif  /* __STDC__ */

#include "ParLexGlob.h"
 
/*prototypes*/

extern void
LexerInit A_((void));

extern void
LexerPutDF A_((int df));

extern void
LexerCondPrint A_((char *str));

extern void
LexerPrint A_((void));

extern void
LexerErr A_((int e));

extern void
LexerTokenPut A_((char *lexem, int lin, int len, int typ, int symbolFlag));

extern void
LexerPrintToken A_((int linenum, char *yytext, int yylen));

extern void
LexerPrintToken2 A_((struct MYTOK tok));
#endif /* _LEXER_H */
