/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*************************************************************
*      myname           List.h
*      created          7/12/1996
*      updated          8/13/1996
*      works            8/13/1996
*
*      function         Singly Linked List
*
*
*
*************************************************************/
#ifndef _LIST_H 
#define _LIST_H
/* Feature test switches */
#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE 1
#endif  /* _POSIX_SOURCE */

#if __STDC__ == 1
/*
 * The following macro definations take affect when compiling under ansi C
 *
 * The A_ macro is provided for function prototype declarations.  It allows
 * ANSI C prototypes to be complied under K&R C
 */

#define A_(x) x

#else
/* The following macro definations take affect when compiling under K&R C */

#define const
#define volatile
#define A_(x) ()

#endif  /* __STDC__ */

#include "Node.h"

typedef Np List;

/*prototypes*/

extern void
ListPutDF A_((int df));

extern void
ListCondPrint A_((char *str));

extern int
ListIsEmpty A_((List L));

extern void
ListPrint A_((List L));

extern void
ListErr A_((int e));

extern List
ListInsertFront A_((List L, Np nxp));

extern List
ListInsertSortedN A_((List L, Np nxp));

extern List
ListInsertSortedD A_((List L, char * lexem, int typ, int LineDe, int leve, int funFlag));

extern int
ListIsMember A_((List L, Np nxp));

extern Np
ListGetLast A_((List L));

extern Np
ListGetSucc A_((List L, Np nxp));

extern List
ListDelete A_((List L));

extern List
ListDeleteNode A_((List L, Np nxp));

extern Np
ListFindNodeByLexeme A_((List L, char * lexem));

extern Np
ListFindNodeByLexemeInLevel A_((List L, char * lexem, int leve));

extern Np
ListFindNodeByLexemeInLine A_((List L, char * lexem, int line));

extern Np
ListMatchNodeByLexemeInLine A_((List L, char * lexem, int line));

extern Np
ListFindNodeBeforeLexemeInLine A_((List L, char * lexem, int line));

extern Np
ListMatchNodeBeforeLexemeInLine A_((List L, char * lexem, int line));

extern Np
ListFindNodeByLexemeAndTypeInLevel A_((List L, char * lexem, int leve, int type, int (*compare_func)()));

extern Np
ListFindAnyNodeInLevelOfType A_((List L, int leve, int type));

extern List
ListDeleteLevel A_((List L, int leve));

extern void
ListParamLink A_((Np tailnp, Np newnp));

extern Np
ListFindFunProtoByLexemeInProg A_((List L, char * lexem));

#endif /* _LIST_H */
