/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*************************************************************
*      myname           Node.h
*      created          7/12/1996
*      updated          8/13/1996
*      works            8/13/1996
*
*************************************************************/
 
/*
 * This is header for the Node class emulated in C
 */
#ifndef _NODE_H
#define _NODE_H
/* Feature test switches */
#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE 1
#endif  /* _POSIX_SOURCE */

#if __STDC__ == 1
/*
 * The following macro definations take affect when compiling under ansi C
 *
 * The A_ macro is provided for function prototype declarations.  It allows
 * ANSI C prototypes to be complied under K&R C
 */

#define A_(x) x

#else
/* The following macro definations take affect when compiling under K&R C */

#define const
#define volatile
#define A_(x) ()

#endif  /* __STDC__ */

#include "ParLexGlob.h"

struct FUNDESCR 
{
	int paramCnt;
	struct Node * paramPtr;
};

/*struct Node;*/
struct Node
{
	char lexeme[LEXEMSZ];
	int type;		/* Semantic type. If this is a function, then 
					retType. */
				 
	int lineDef;
	int level;
	int funFlag;		/* YES it is a function; otherwise NO */

	struct FUNDESCR funDescr;

	struct Node *rptr;
};
typedef struct Node *Np;

/*prototypes*/

extern void
NodePutDF A_((int df));

extern void
NodeCondPrint A_((char *str));

extern Np
NodeNew A_((char *lexem, int typ, int lin, int leve, int funFla));

extern void
NodePrint A_((Np xp));

extern void
NodePrint2 A_((Np xp));

extern void
NodeFunDescrPrint A_((Np nx));

extern Np
NodeFunDescrFindByLexeme A_((Np nx, char *lexem));

extern void
NodeInit A_((Np nx, char *lexem, int typ, int lin, int leve, int funFla));

extern int
NodeCmp A_((Np xp, char *lexem));

extern void
NodeErr A_((int e));

extern char *
NodeGetLexeme A_((Np nxp));

extern int
NodeGetType A_((Np nxp));

extern int
NodeGetLineDef A_((Np nxp));

extern int
NodeGetLevel A_((Np nxp));

extern int
NodeGetFunFlag A_((Np nxp));

extern int
NodeGetParamCnt A_((Np nxp));

extern Np
NodeGetParamPtr A_((Np nxp));

extern void
NodePutLexeme A_((Np nxp, char *lexem));

extern void
NodePutType A_((Np nxp, int typ));

extern void
NodePutLineDef A_((Np nxp, int lin));

extern void
NodePutLevel A_((Np nxp, int leve));

extern void
NodePutFunFlag A_((Np nxp, int funFla));

extern void
NodePutParamCnt A_((Np nxp, int paramCn));

extern void
NodePutParamPtr A_((Np nxp, Np paramPt));

extern void
NodeParamCntIncr A_((Np nxp));

extern void
NodeParamCntDecr A_((Np nxp));

#endif /* _NODE_H */
