/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*************************************************************
*      myname           ParLexGlob.h
*      created          7/15/1996
*      updated          8/6/1996
*      works            7/29/1996
*
*      designed			rrs/1996
*************************************************************/
#ifndef _PARLEXGLOB_H 
#define _PARLEXGLOB_H
/* Feature test switches */
#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE 1
#endif  /* _POSIX_SOURCE */

#define YES_INT 2 /* funFlag: means func is internally def */
#define YES 1
#define NO 0
#define OTHER 0
#define CONST 1
#define VAR 2

#define LEXEMSZ 80

struct MYTOK
{
	char lexeme[LEXEMSZ];
	int line;
	int len;
	int type;	
	int varFlag; /* VAR, CONST, OTHER */
};

typedef struct MYTOK STRMYTOK;

/* The following defines must coincide */
/* with SymTabGlob.h entries. */
#define UNKNOWN 0
#define INTTYPE 1
#define FLOATTYPE 2
#define STRINGTYPE 3
#define STATUSTYPE 4
#define DAYOFWEEKTYPE 5
#define SERVERTYPE 6
#define QUETYPE 7
#define JOBTYPE 8
#define SIZETYPE 9
#define INTRANGETYPE 10
#define FLOATRANGETYPE 11
#define DAYOFWEEKRANGETYPE 12
#define SERVERSETTYPE 13
#define QUESETTYPE 14
#define JOBSETTYPE 15
#define SIZESETTYPE 16
#define PARAMTYPE 17
#define FUNTYPE 18
#define SERVERSTATETYPE 19
#define QUESTATETYPE 20
#define JOBSTATETYPE 21
#define SIZESTATETYPE 22
#define DATETIMETYPE 23
#define CNODETYPE 24
#define VOIDTYPE 25
#define DATETIMERANGETYPE 26
#define CNODESETTYPE 27
#define SIZERANGETYPE 28
#define GENERICTYPE 29
#define KEYWORDTYPE 30

#endif /* _PARLEXGLOB_H */
