/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National 
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore   
National Laboratory.
*/
#ifndef CONSTANT_H
#define CONSTANT_H

/* multipliers [bw] means either btye or word */
#define KILO		1024UL		/* number of [bw] in a kilo[bw] */
#define MEGATOKILO 	1024UL		/* number of mega[bw] in a kilo[bw] */
#define GIGATOKILO 	1048576UL	/* number of giga[bw] in a kilo[bw] */
#define TERATOKILO 	1073741824UL	/* number of tera[bw] in a kilo[bw] */

/* extra constants */
#define UNSPECIFIED -1		/* unspecified value */
#define FREE_DEEP 1		/* constant to pass to free_*_list */
#define INITIALIZE -1
#define INFINITY -2		/* infinity value for resources */

/* for update_jobs_cant run */
#define START_BEFORE_JOB -1
#define START_WITH_JOB 0
#define START_AFTER_JOB 1

/* return codes for is_ok_to_run_* functions */
/* codes less then RET_BASE are indexes into the resources to check array */
#define RET_BASE 1000
#define SUCCESS (RET_BASE + 1)
#define SCHD_ERROR (RET_BASE + 2)
#define NOT_QUEUED (RET_BASE + 3)
#define QUEUE_NOT_STARTED (RET_BASE + 4)
#define QUEUE_NOT_EXEC (RET_BASE + 5)
#define QUEUE_JOB_LIMIT_REACHED (RET_BASE + 6)
#define SERVER_JOB_LIMIT_REACHED (RET_BASE + 7)
#define SERVER_USER_LIMIT_REACHED (RET_BASE + 8)
#define QUEUE_USER_LIMIT_REACHED (RET_BASE + 9)
#define SERVER_GROUP_LIMIT_REACHED (RET_BASE + 10)
#define QUEUE_GROUP_LIMIT_REACHED (RET_BASE + 11)
#define DED_TIME (RET_BASE + 12)
#define CROSS_DED_TIME_BOUNDRY (RET_BASE + 13)
#define NO_AVAILABLE_NODE (RET_BASE + 14)
#define NOT_ENOUGH_NODES_AVAIL (RET_BASE + 15)
#define JOB_STARVING (RET_BASE + 16)

/* for SORT_BY */
enum sort_type
{ 
  NO_SORT, 
  SHORTEST_JOB_FIRST, 
  LONGEST_JOB_FIRST, 
  SMALLEST_MEM_FIRST, 
  LARGEST_MEM_FIRST, 
  HIGH_PRIORITY_FIRST, 
  LOW_PRIORITY_FIRST,
  LARGE_WALLTIME_FIRST,
  SHORT_WALLTIME_FIRST,
  FAIR_SHARE,
  MULTI_SORT
};

#ifdef FALSE
#  undef FALSE
#endif

#ifdef TRUE
#  undef TRUE
#endif

enum { FALSE, TRUE };

enum { USER, GROUP };

enum prime_time 
{ 
  ALL, 
  NONE, 
  PRIME, 
  NON_PRIME,
  HIGH_PRIME
};

enum days
{
  SUNDAY,
  SATURDAY,
  WEEKDAY,
  HIGH_DAY
};

#endif
