/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National 
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore   
National Laboratory.
*/

#ifndef FIFO_H
#define FIFO_H

/*
 *      schedinit - initialize conf struct and parse conf files
 */
int schedinit( int argc, char *argv[] );

/*
 *      schedule - this function gets called to start each scheduling cycle
 *                 It will handle the difference cases that caused a
 *                 scheduling cycle
 */
int schedule(int cmd, int sd);

/*
 *      scheduling_cycle - the controling function of the scheduling cycle
 */
 
int scheduling_cycle( int sd );

/*
 *      init_scheduling_cycle - run things that need to be set up every
 *                              scheduling cycle
 */
int init_schedule_cycle( server_info *sinfo );

/*
 *      run_update_job - run and update the job information
 */
int run_update_job( int pbs_sd, server_info *sinfo, queue_info *qinfo, 
							job_info *jinfo);
/*
 *
 *      next_job - find the next job to be run by the scheduler
 *
 *        sinfo - the server the jobs are on
 *        ret_code - the previous return code from running a job
 *
 *      returns the next job to run or NULL when there are no more jobs
 *              to run, or on error
 *
 */

job_info *next_job( server_info *sinfo, int ret_code );

/*
 *      update_last_running - update the last_running job array
 */
int update_last_running( server_info *sinfo );

/*
 *
 *      update_starvation - update jobs sch_priority for starvation
 */
job_info *update_starvation( job_info **jobs );


#endif
