/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National 
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore   
National Laboratory.
*/

#ifndef PARSE_H
#define PARSE_H

#include "data_types.h"
#include "globals.h"

/*
 *	parse_config - parse the config file and set a struct config
 *
 *	FILE FORMAT:
 *	config_name [white space ] : [ white space ] config_value
 */
int parse_config( char *fname );

/*
 *      init_config - initalize the config struture
 */
int init_config();
 
 
/*
 *      reinit_config - reinitialize the conf structure so the config file can
 *                    reparsed.
 */
int reinit_config();

#endif
