/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National 
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore   
National Laboratory.
*/

#ifndef PRIME_H
#define PRIME_H

/*
 *      is_prime_time - will return true if it is currently prime_time
 */
enum prime_time is_prime_time( );

/*
 *      check_prime - check if it is prime time for a particular day
 */
enum prime_time check_prime( enum days d, struct tm *t );

/*
 *      is_holiday - returns true if today is a holiday
 */
int is_holiday( int jdate );

/*
 *      load_day - fill in the prime time part of the config structure
 */
int load_day( enum days d, enum prime_time pr, char *tok );
 
/*
 *      parse_holidays - parse the holidays file.  It should be in UNICOS 8
 *                       format.
 */
int parse_holidays( char *fname );

/*
 *      init_prime_time - do any initializations that need to happen at the
 *                        start of prime time
 */
void init_prime_time( );


/*
 *      init_non_prime_time - do any initializations that need to happen at
 *                            the beginning of non prime time
 */
void init_non_prime_time( );

#endif
