/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National 
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore   
National Laboratory.
*/

#ifndef STATE_COUNT_H
#define STATE_COUNT_H

#include "data_types.h"

/*
 *	print_state_count - print out a state_count struct
 */
void print_state_count( state_count *sc );

/*
 *	init_state_count - initalize state count struct
 */
void init_state_count( state_count *sc );

/*
 *      count_states - count the jobs in each state and set the state counts
 */
void count_states( job_info **jobs, state_count *sc );

/*
 *	accumulate states from one state_count into another
 */
void total_states( state_count *sc1, state_count *sc2 );

#endif
