/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*
 * node_attr_def is the array of "attribute" definitions for a node.
 * Each legal node "attribute" is defined here
 */

#include <pbs_config.h>   /* the master config generated by configure */

#include "pbs_ifl.h" 
#include "list_link.h" 
#include "attribute.h" 

static char ident[] = "@(#) $RCSfile: node_attr_def.c,v $ $Revision: 2.0 $";

/* External Functions Referenced */

/*
* extern int decode_state A_((struct attribute *patr, char *nam, char *rn, char *val));
* extern int decode_props A_((struct attribute *patr, char *nam, char *rn, char *val));
* extern int encode_state	     A_((struct attribute *patr, list_head *ph, char *anm, char *rmn, int mode));
* extern int encode_props	     A_((struct attribute *patr, list_head *ph, char *anm, char *rmn, int mode));
* extern int set_node_state    A_((attribute *patr, attribute *new, enum batch_op));
* extern int set_node_props    A_((attribute *patr, attribute *new, enum batch_op));
* extern int node_state        A_((attribute *patr, void *pobj, int actmode));
* extern int node_prop_list    A_((attribute *patr, void *pobj, int actmode));
* extern void free_null	     A_((attribute *patr));
* extern void free_prop_attr   A_((attribute *patr));
* extern int  comp_null	     A_((attribute *patr, attribute *with));
*/


/*
 * The entries for each attribute are (see attribute.h):
 *	name,
 *	decode function,
 *	encode function,
 *	set function,
 *	compare function,
 *	free value space function,
 *	action function,
 *	access permission flags,
 *	value type
 */

attribute_def node_attr_def[] = {

/* NODE_ATR_state */
    {	ATTR_NODE_state,	/* "state" */
	decode_state,
	encode_state,
	set_node_state,
	comp_null,
	free_null,
	node_state,
	NO_USER_SET,
	ATR_TYPE_SHORT,
	PARENT_TYPE_NODE,
    },
	
/* NODE_ATR_properties */
    {	ATTR_NODE_properties,	/* "properties" */
	decode_props,
	encode_props,
	set_node_props,
	comp_null,
	free_prop_attr,
	node_prop_list,
	MGR_ONLY_SET,
	ATR_TYPE_PROP,
	PARENT_TYPE_NODE,
    },

/* NODE_ATR_ntype */
    {	ATTR_NODE_ntype,	/* "ntype" */
	decode_ntype,
	encode_ntype,
	set_node_ntype,
	comp_null,
	free_null,
	node_ntype,
	NO_USER_SET,
	ATR_TYPE_SHORT,
	PARENT_TYPE_NODE,
    },

/* NODE_ATR_jobs */
    {   ATTR_NODE_jobs,         /* "jobs" */
	decode_null,
	encode_jobs,
	set_null,
	comp_null,
	free_null,
	NULL_FUNC,
	ATR_DFLAG_RDACC,
	ATR_TYPE_JINFOP,
	PARENT_TYPE_NODE,
    },
};
