/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*
 * svr_locate.c 
 *
 * Functions relating to the Locate Job Batch Request.
 *
 * Included funtions are:
 *	
 *
 */
#include <pbs_config.h>   /* the master config generated by configure */

#include <sys/types.h>
#include "libpbs.h"
#include <signal.h>
#include <string.h>
#include "server_limits.h"
#include "list_link.h"
#include "attribute.h"
#include "server.h"
#include "credential.h"
#include "batch_request.h"
#include "job.h"
#include "work_task.h"
#include "tracking.h"
#include "pbs_error.h"
#include "log.h"

static char ident[] = "@(#) $RCSfile: req_locate.c,v $ $Revision: 2.0 $";

/* Global Data Items: */

extern struct server server;
extern char   server_name[];

/*
 * req_locatejob - service the Locate Job Request
 *
 *	This request attempts to locate a job.
 */

void req_locatejob(preq)
	struct batch_request *preq;
{
	char 		 *at;
	int		  i;
	job		 *pjob;
	char		 *location = (char *)0;

	if (at = strchr(preq->rq_ind.rq_locate, (int)'@'))
	    *at = '\0';			/* strip off @server_name */
	pjob = find_job(preq->rq_ind.rq_locate);
	if (pjob) {
	    location = server_name;
	} else {
	    for (i=0; i < server.sv_tracksize; i++) {
		if ((server.sv_track+i)->tk_mtime &&
		    !strcmp((server.sv_track+i)->tk_jobid, preq->rq_ind.rq_locate)) {
			location = (server.sv_track+i)->tk_location;
			break;
		}
	    }
	}
	if (location) {
		preq->rq_reply.brp_code = 0;
		preq->rq_reply.brp_auxcode = 0;
		preq->rq_reply.brp_choice = BATCH_REPLY_CHOICE_Locate;
		(void)strcpy(preq->rq_reply.brp_un.brp_locate, location);
		reply_send(preq);
	} else 
		req_reject(PBSE_UNKJOBID, 0, preq);
	return;
}
