/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*
 * Check permissions on the PBS Tree Built
 *
 *	Files should be owned by root, and not world writable.
 */

#include <pbs_config.h>   /* the master config generated by configure */

#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <limits.h>
#include <stdio.h>
#include <string.h>
#include "portability.h"
#include "log.h"

static char ident[] = "@(#) $RCSfile: chk_tree.c,v $ $Revision: 2.0 $";

char *msg_daemonname = 0;	/* to satisfy the Cray linker */
main(argc, argv)
	int argc;
	char *argv[];
{
	int err = 0;
	int i;
	int j;
	int chk_file_sec();
	int dir = 0;
	int no_err = 0;
	int sticky = 0;
	extern int optind;


	while ((i = getopt(argc, argv, "dns")) != EOF) {
	    switch (i) {
		case 'd': dir = 1;
			  break;
		case 'n': no_err = 1;
			  break;
		case 's': sticky = 1;
			  break;
		default: err = 1;
	    }
	}

	if (err || (optind == argc)) {
		fprintf(stderr, "Usage %s -d -s -n path ...\n\twhere:\t-d indicates directory (file otherwise)\n\t\t-s indicates world write allowed if sticky set\n\t\t-n indicates do not return the error status, exit with 0\n", argv[0]);
		return 1;
	}

	for (i=optind; i < argc; ++i)
		if (j=chk_file_sec(argv[i], dir, sticky, S_IWGRP|S_IWOTH, 1)) {
			err=1;
		}

	if (no_err)
		return 0;
	else
		return (err);
}

/*
 * log_err - for this utility, write to stderr rather than logging.
 */

void log_err(rc, routine, text)
	int  rc;
	char *routine;
	char *text;
{
	fprintf(stdout, "chk_tree: %s: error #%d: (%s)\n", text, rc,
		strerror(rc) ? strerror(rc) : "UNKNOWN");
}
