#!/bin/sh
#
# Script to create an environment variables files for the PBS daemons
#
if [ $# -eq 0 ] ; then
	echo Usage: $0 filename
	exit 1
fi
F=$1
ans=y
ED=${EDITOR:-vi}
if [ -f $F ] ; then
	if [ -w $F ] ; then
		echo ""
		echo PBS environment file $F exists and is writable.
		echo 'Do you wish to overwrite it [y|(n)]?'
		read ans
		if [ X$ans = X ] ; then ans=n ; fi
		if [ $ans = y ] ; then
			echo 'Are you sure [y\|(n)]?'
			read ans
			if [ X$ans = X ] ; then ans=n ; fi
			if [ $ans = y ] ; then
				rm $F
			fi
		fi
	elif [ -r $F ] ; then
		echo WARNING, file $F exists and is not writable.
		exit 1
	fi
fi
if [ $ans = y ] ; then
	echo ""
	echo Creating PBS environment file $F
	printenv > $F
	chmod 700 $F
fi
echo 'Do you wish to edit it [(y)\|n]?'
read ans
if [ X$ans = X ] ; then ans=y ; fi
if [ $ans = y ] ; then
	$ED $F
fi
