/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*
**	All the pbs specific code needed to make pbswish
**	work is here.  The routine pbsTk_Init() is to be called
**	in place of Tk_Init().
*/

#include <pbs_config.h>

#include	"tk.h"
#include <string.h>

static char ident[] = "@(#) $RCSfile: pbsTkInit.c,v $ $Revision: 2.0 $";

char	log_buffer[1024];

void
log_err(errnum, func, text)
    int		errnum;
    char	*func;
    char	*text;
{
  char *error_message = "Internal error";
  if ( errnum >= 0 ) {
    error_message = strerror(errnum);
  }
  fprintf(stderr, "%s: %s: %s\n",
	  error_message,func, text);
}

int
pbsTcl_Init(interp)
    Tcl_Interp	*interp;		/* Interpreter for application. */
{
	if (Tcl_Init(interp) == TCL_ERROR)
		return TCL_ERROR;
	if (Tk_Init(interp) == TCL_ERROR)
		return TCL_ERROR;
	Tcl_StaticPackage(interp, "Tk", Tk_Init, Tk_SafeInit);
#if	TCLX
	if (Tclx_Init(interp) == TCL_ERROR)
		return TCL_ERROR;
	if (Tkx_Init(interp) == TCL_ERROR)
		return TCL_ERROR;
#endif

	fullresp(0);
	add_cmds(interp);

	Tcl_SetVar(interp, "tcl_rcFileName", "~/.wishrc", TCL_GLOBAL_ONLY);
	return TCL_OK;
}

int
main(argc, argv)
    int		argc;
    char	*argv[];
{
	Tk_Main(argc, argv, pbsTcl_Init);
	return 0;
}
